<?php

namespace Framework;

class PageInfo {
	public static function create() {
		if (isset($_GET['Page']) 
			&& ctype_digit($_GET['Page'])
			&& isset($_GET['PageSize'])
			&& ctype_digit($_GET['PageSize'])) {

			$page = (int) $_GET['Page'];
			$pageSize = (int) $_GET['PageSize'];

			return new PageInfo($page, $pageSize);
		}

		return NULL;
	}

	private function __construct($page, $pageSize) {
		$this->pageSize = (int) $pageSize;
		$this->page = (int) $page;
		$this->totalItems = 0;
	}

	public function getPageSize() {
		return $this->pageSize;
	}

	public function getPage() {
		return $this->page;
	}

	public function getTotalPages() {
		return (int) ceil($this->totalItems / $this->pageSize);

	}

	public function getItemOffset() {
		return $this->pageSize * $this->page;
	}

	public function setTotalItems($count) {
		$this->totalItems = $count;
	}

	public function getTotalItems() {
		return $this->totalItems;
	}

	public function sqlCode() {
		return ' LIMIT ' . $this->getItemOffset() . ', ' . $this->pageSize;
	}

	private $pageSize;
	private $page;

	private $totalItems;
}

?>
