<?php

namespace Framework {

	abstract class Repository {
		protected $dataBase;

		public function __construct($dataBase,  $restrictedUser = false, $userId = null) {
			$this->dataBase = $dataBase;
			$this->restrictedUser = $restrictedUser;
			$this->userId = $userId;
		}

		protected $restrictedUser = false;
		protected $userId;
		
		protected function restrictedUserCondition() {
			$condition = '';
			
			if ($this->restrictedUser && $this->userId !== null) {
				$condition = ' JOIN User2Network ON User2Network.userId = '
					. $this->userId
					. ' AND User2Network.networkId = Networks.id'
					;
			}

			return $condition;
		}
		
		protected function composeQuery($columns, $tables, $condition = 'TRUE') {
			$query = 'SELECT '
				. $columns
				. ' FROM '
				. $tables
				. $this->restrictedUserCondition()
				. ' WHERE '
				. $condition
				;
			
			return $query;
		}

		abstract function getById($itemId);
		abstract function getList(Filter $filter = null, PageInfo $paging = null, SortInfo $sorting = null);
	}

}

?>
