<?php

namespace Framework {

	class SortInfo {
		public static function create(array $sortParams, $defaultSortBy, $defaultSortOrder) {
			$sortBySpec = isset($_GET['SortBy'])
				? $_GET['SortBy']
				: $defaultSortBy;
				
			$sortOrderSpec = isset($_GET['SortOrder'])
				? $_GET['SortOrder']
				: $defaultSortOrder;
		
			$sortInfo = null;

			if (!is_null($sortBySpec)) {
				$sortParams = explode(',', $sortBySpec);
				$sortOrder = null;
				
				if (!is_null($sortOrderSpec)) {
					$sortOrder = explode(',', $sortOrderSpec);
					
					if (count($sortOrder) == 1 && count($sortParams) > 1) {
						$sortOrder = array_pad($sortOrder, count($sortParams), $sortOrder[0]);
					}
					
					for ($i = 0; $i < count($sortOrder); $i++) {
						switch ($sortOrder[$i]) {
							case 'a':
							case 'A':
								$sortOrder[$i] = 'ASC';
								break;
							case 'd':
							case 'D':
								$sortOrder[$i] = 'DESC';
								break;
							default:
								$sortOrder[$i] = 'ASC';
						}
					}
				}
				
				if (is_null($sortOrder)) {
					$sortOder = array_fill(0, count($sortParams), 'ASC');
				}

				$sortInfo = new SortInfo($sortParams, $sortOrder);
			}

			return $sortInfo;
		}

		public function sqlCode(array $columnMap) {
			$orderList = '';
			$separator = '';
			
			for ($i = 0; $i < count($this->sortParams); $i++) {
				$sortParam = $this->sortParams[$i];
				$sortOrder = $this->sortOrder[$i];
				
				if (isset($columnMap[$sortParam])) {
					$orderList .= $separator;
					$orderList .= ' ';
					$orderList .= $columnMap[$sortParam];
					$orderList .= ' ';
					$orderList .= $sortOrder;
					
					$separator = ',';
				}
			}
			
			if ($orderList !== '') {
				$orderList = ' ORDER BY' . $orderList;
			}
			
			return $orderList;
		}

		private function __construct($sortParams, $sortOrder) {
			$this->sortParams = $sortParams;
			$this->sortOrder = $sortOrder;
		}

		private $sortParams;
		private $sordOrder;
	}
}
