<?php

namespace Repositories;



use \Models\Wgs84Coordinates;
use \Models\BaseStation;


class BaseStationRepository {
	public function __construct($dataBase, $restrictedUser, $userId) {
		$this->dataBase = $dataBase;
		$this->restrictedUser = $restrictedUser;
		$this->userId = $userId;
	}
	
	private $dataBase;
	private $restrictedUser;
	private $userId;
	
	public function getList($centerLat, $centerLon, $radius) {
			$query = $this->restrictedUser
				? "CALL SelectBaseStationsWithinRadiusForRestrictedUser($this->userId, $centerLat, $centerLon, $radius)"
				: "CALL SelectBaseStationsWithinRadius($centerLat, $centerLon, $radius)";
				
			$result = $this->dataBase->query($query);
			
			$stationArray = array();
			
			while ($record = $result->fetch_object()) {
				$station = new BaseStation;
				
				$station->InventoryId = $record->hostId;
				$station->Name = $record->name;
				$station->Distance = (int) $record->distance;
				$station->Height = is_null($record->height_agl) ? null : (float) $record->height_agl;
				
				
				$coords = new Wgs84Coordinates;
				$coords->Latitude = is_null($record->latitude) ? null : (float) $record->latitude;
				$coords->Longitude = is_null($record->longitude) ? null : (float) $record->longitude;
				
				$station->Coordinates = $coords;
				
				$stationArray[] = $station;
			}
			
			$result->close();
			
			return $stationArray;
	}
}

?>