<?php

namespace Repositories {
	
	use Framework\Repository;
	use Framework\Filter;
	use Framework\PageInfo;
	use Framework\SortInfo;
	
	use Models\NotificationReceiver;
	
	class NotificationReceiverRepository extends Repository {
		
		public function getList(Filter $filter = null, PageInfo $pageInfo = null, SortInfo $sortInfo = null) {
			$receivers = array();
			
			$query = 'SELECT deviceToken, userId, serviceId, receiverToken FROM NotificationReceivers WHERE userId = ?';
			
			$statement = $this->dataBase->prepare($query);
			$statement->bind_param('i', $this->userId);
			$statement->execute();
			$statement->bind_result($deviceToken, $userId, $serviceId, $receiverToken);
			
			while ($statement->fetch()) {
				$receiver = new NotificationReceiver;
				$receiver->UserId = $userId;
				$receiver->DeviceToken = $deviceToken;
				$receiver->ServiceId = $serviceId;
				$receiver->ReceiverToken = $receiverToken;
				$receivers[] = $receiver;
			}
			
			$statement->close();
			
			return $receivers;
		}
		
		public function getById($itemId) {
			return null;
		}
		
		protected function getItemsFromStatement(\mysql_stmt $statement) {
			return null;
		}
		
		public function createOrUpdate(NotificationReceiver $receiver) {
			$insertOrUpdate = 'INSERT INTO NotificationReceivers (deviceToken, userId, serviceId, receiverToken, lastUpdate) VALUES (?, ?, ?, ?, NOW()) ON DUPLICATE KEY UPDATE userId = ?, receiverToken = ?, lastUpdate = NOW()';
			
			$statement = $this->dataBase->prepare($insertOrUpdate);
			$statement->bind_param('sissis',
				$receiver->DeviceToken,
				$this->userId,
				$receiver->ServiceId,
				$receiver->ReceiverToken,
				$this->userId,
				$receiver->ReceiverToken
			);
			$statement->execute();
			$statement->close();
		}
	}
}

?>