<?php

/**
 * @uri /auth/login
 */
class LoginService extends Framework\Resource {

	protected $isPublic = true;

	/**
	 * @method POST
	 * @accepts application/json
	 * @provides application/json
	 */
	 function doLogin() {
		$data = $this->request->data;
		
		$db = $this->dataBase;
		
		$statement = $db->prepare("SELECT id FROM Users WHERE username=? AND password=MD5(CONCAT(?, 'pD023xJzvpprt81'))");
		
		$statement->bind_param('ss', $data->Username, $data->Password);
		$statement->execute();

		$statement->bind_result($userId);

		if (!$statement->fetch()) {
			return new Tonic\Response(401);
		}
		
		$statement->close();
		
		$permanentSession = 0;
		
		if (isset($data->RememberMe) && (bool) $data->RememberMe) {
			$permanentSession = 1;
		}
		
		$statement = $db->prepare('SELECT CreateSession(?, ?)');
		$statement->bind_param('ii', $userId, $permanentSession);
		$statement->execute();
		
		$statement->bind_result($authToken);
		$statement->fetch();
		$statement->close();
		
		$responseData = new Models\LoginServiceResponse;
		
		$responseData->AuthToken = $authToken;
		$responseData->UserId = (string) $userId;
		
		return new Tonic\Response(200, $responseData);
	}
}

/**
 * @uri /auth/logout
 */
class LogoutService extends Tonic\Resource {

	/**
	 * @method POST
	 */
	function doLogout() {
		$db = $this->dataBase;
		$statement = $db->prepare('DELETE FROM Sessions WHERE authToken=?');
		$statement->bind_param('s', $this->authToken);
		$statement->execute();
		$statement->close();
	}
}

?>
