<?php

/**
 * @uri /inventory/baseStations
 */
 
class BaseStationsCollection extends Framework\Resource {
	/**
	 * @method GET
	 * @provides application/json
	 */
	public function getList() {
	
		if (!isset($_GET['centerLat']) || !isset($_GET['centerLon']) || !isset($_GET['radius'])) {
			return new Tonic\Response(400);
		}
	
		$centerLat = doubleval($_GET['centerLat']);
		$centerLon = doubleval($_GET['centerLon']);
		$radius = intval($_GET['radius']);
	
		$repository = new Repositories\BaseStationRepository(
			$this->dataBase,
			$this->restrictedUser,
			$this->userId
			);
			
		$baseStations = $repository->getList($centerLat, $centerLon, $radius);
			
		return new Tonic\Response(200, $baseStations);
	}
}

?>
