<?php

/**
 * @uri /inventory/interfaces
 */
class GlobalInterfacesCollection extends Framework\Resource {
	/**
	 * @method GET
	 * @provides application/json
	 */
	 
	public function getList() {
		$repository = new Repositories\InterfaceRepository($this->dataBase, $this->restrictedUser, $this->userId);
		$interfaces = $repository->getList($this->filter, $this->pageInfo, $this->sortInfo);
		$response = new Tonic\Response(200, $interfaces);
		return $response;
	}
}

/**
 * @uri /inventory/{inventoryId}/interfaces
 */
class InventoryInterfacesCollection extends Framework\Resource {
	/**
	 * @method GET
	 * @provides application/json
	 */
	public function getList($inventoryId) {
		$repository = new Repositories\InterfaceRepository($this->dataBase, $this->restrictedUser, $this->userId);
		$interfaces = $repository->getById($inventoryId);
		$response = new Tonic\Response(200, $interfaces);
		return $response;
	}
}

?>
