<?php

/**
 * @uri /notificationReceivers
 */

class NotificationReceiversCollection extends Framework\Resource {
	/**
	 * @method GET
	 * @provides application/json
	 */
	public function getList() {
		$repository = new Repositories\NotificationReceiverRepository($this->dataBase, $this->restrictedUser, $this->userId);
		$receivers = $repository->getList();
		return new Tonic\Response(200, $receivers);
	}
	
	/**
	 * @method POST
	 * @accepts application/json
	 */
	public function post() {
		$data = $this->request->data;
		
		$receiver = new Models\NotificationReceiver;

		$receiver->UserId = $this->userId;
		$receiver->DeviceToken = $data->DeviceToken;
		$receiver->ServiceId = $data->ServiceId;
		$receiver->ReceiverToken = $data->ReceiverToken;

		$repository = new Repositories\NotificationReceiverRepository($this->dataBase, $this->restrictedUser, $this->userId);
		
		$repository->createOrUpdate($receiver);
		
		return new Tonic\Response(200);
	}
}


?>