<?php

require_once 'Framework/Autoload.php';

$appConfig = array('load' => array('Resources' . DIRECTORY_SEPARATOR . '*.php'));

$application = new Tonic\Application($appConfig);

$request = new Tonic\Request();

try {
        $resource = $application->getResource($request);
        $response = $resource->exec();
} catch (Tonic\NotFoundException $e) {
        $response = new Tonic\Response(404);
} catch (Tonic\UnauthorizedException $e) {
        $response = new Tonic\Response(401);
} catch (Tonic\Exception $e) {
        $response = new Tonic\Response($e->getCode());
} catch (\Exception $e) {
	$response = new Tonic\Response(500);
}

$response->output();

