<?php

class RepositoryError extends Exception {
  public function __construct($errno, $error) {
    $this->code = $errno;
    $this->message = $error;
  }
};

class Repository {
  protected function __construct(MySQLi $dbConnection) {
    $this->db = $dbConnection;
  }
  
  protected function prepare($query) {
    return $this->db->prepare($query);
  }
  
  protected function query($query) {
    return $this->db->query($query);
  }
  
  protected function fetchObject($query) {
    $result = $this->db->query($query);
    $returnObject = NULL;
    if ($result->num_rows > 0) {
      $returnObject = $result->fetch_object();
    }
    $result->free();

    return $returnObject;
  }
  
  protected function fetchObjects($query) {
    $result = $this->db->query($query);
    $returnArray = array();
    while ($object = $result->fetch_object()) {
      $returnArray[] = $object;
    }
    $result->free();
    
    return $returnArray;
  }
  
  protected $db;
}

?>