<?php

include('lib/sql.php');
include('lib/permissions.php');
include('lib/user.php');
include('lib/manage-alarm.php');

if(!function_exists('alarmProfile_wrapper'))
{

	function alarmProfile_wrapper() {}

	/* Lengths of DB fields in the Networks table */
	$ALARMPROFILE_LEN = array(
				'email'		   => 100,
				'name' 			=> 50,
				'description' 	=> 100);

	$ALARMPROFILE2DEF_LEN = array(
				'severity' 		=> 15);
	
	function handleAlarmProfileAction($action)
	{
		if($action == null)
			error('Unauthorized');

		switch($action)
		{
			case 'create':
				echo tag('results', createAlarmProfile(req('name'), 
									     							req('description'), 
									     							req('email'),
									     							req('notify'),
															      req('alarmDefs')));
			break;
				
			case 'delete':
				echo deleteAlarmProfile(req('id'));
	
			break;

			case 'modify':				
				echo modifyAlarmProfile(req('id'), req('name'), 
							req('description'), 
							req('email'), 
							req('notify'),
							req('alarmDefs'));
			break;

			
			case 'get':
				echo getAlarmProfiles();
			break;

		}

	}

	/****************************************************
	* Get all active alarm profiles
	*
	**/
	function getAlarmProfiles()
	{

		$retVal = "<alarmProfiles>";

		/* Get alarm profiles */
		$query =   " SELECT AlarmProfiles.*, Users.username "	
					. " FROM AlarmProfiles "
					. " Left Join Users "
					. " On Users.id = AlarmProfiles.createdBy ";

		$conn = @getConnection();

		$result = mysql_query($query, $conn);

		if(!$result)
			error("Unable to retrieve alarm profiles from the database! ". mysql_error());
			
		$numrows = mysql_numrows($result);

		$i = 0;

		while($i < $numrows)
		{	
			$row = mysql_fetch_assoc($result);
 			$id = (int)$row['id'];

			$retVal .= "<alarmProfile id='" . $id . "'>";
			
			$notifyFlag = $row['notify'];
			if ($notifyFlag != '1') {
				$notifyFlag = '0';
			}

			$retVal .= tag('name', $row['name'], true); 
			$retVal .= tag('description', $row['description'], true);
			$retVal .= tag('createdOn', $row['createdOn'], true);
			$retVal .= tag('username', $row['username'], true);
			$retVal .= tag('notifyEmail', $row['notifyEmail'], true); 
			$retVal .= tag('notify', $notifyFlag);
			
			$retVal .= tag('id', $id); 

			$retVal .=  getAlarmDefsInProfile($id);

			$retVal .= "</alarmProfile>";
			$i++;
		}

		$retVal .= getBuiltinAlarmDefs();
		$retVal .= "</alarmProfiles>";


		return $retVal;
	}


	/****************************************************
	* Get alarm def XML for alarm profile
	*
	**/
	function getAlarmDefsInProfile($id)
	{
		$id = (int) $id;

		/* For each alarm profile, get the alarm definitions */
		$query = " SELECT * from AlarmProfile2AlarmDef , AlarmDefinition "
				 . " WHERE AlarmProfile2AlarmDef.alarmProfileId = $id "
				 . " AND AlarmDefinition.id = AlarmProfile2AlarmDef.alarmid "
				 . " AND AlarmDefinition.deleted = 0 ";

		$conn = @getConnection();

		$result = mysql_query($query, $conn);

		if(!$result)
			error("Unable to retrieve alarm defs from the database! ". mysql_error());
			
		$numrows = mysql_numrows($result);

		$i = 0;

		// This is the comma delimeted list of alarm defs in the profile 
		// (used in the gui view)

		$list = "";

		$retVal = "";

		while($i < $numrows)
		{	
			$row = mysql_fetch_assoc($result);
 			$id = (int)$row['id'];

			if(strlen($list) > 0)
				$list .= ", ";

			$list .= getStdAlarmDefDisplayName($row['name']);
	
			$notifyFlag = $row['notify'];
			if ($notifyFlag != '1') {
				$notifyFlag = '0';
			}

			$retVal .= "<alarmDef id='" . $id . "'>\n";
			
			$retVal .= tag('name', $row['name'], true); 
			$retVal .= tag('id', $row['id']); 
			$retVal .= tag('display', getStdAlarmDefDisplayName($row['name']), true);

			$retVal .= tag('desc', $row['desc'], true);
			$retVal .= tag('oid', $row['oid'], true);
			$retVal .= tag('threshold', $row['threshold']);
			$retVal .= tag('op', $row['op']); 
			$retVal .= tag('severity', $row['severity']);
			$retVal .= tag('notify', $notifyFlag);
			
			$retVal .= "</alarmDef>\n";
			$i++;
		}

		$retVal = tag('alarmDefs', $retVal);

		$retVal .= tag('alarmDefList', $list); 
		return $retVal;

	}

	
	/******************************************************************
	* Get builtin alarm defs
	* 
	**/
	function getBuiltinAlarmDefs()
	{

		$query = " SELECT * from AlarmDefinition "
				 . " WHERE  AlarmDefinition.custom = 0 ";

		$conn = @getConnection();

		$result = mysql_query($query, $conn);

		if(!$result)
			error("Unable to retrieve built in alarm defs from the database! ". mysql_error());
			
		$numrows = mysql_numrows($result);

		$i = 0;

		$retVal = "";

		while($i < $numrows)
		{	
			$row = mysql_fetch_assoc($result);
 			$id = (int)$row['id'];
 			$name = $row['name'];
			$retVal .= "<alarmDef id='$id'>" . tag('name', $name) . "</alarmDef>\n";
			$i++;
		}
		return tag("builtinAlarmDefs", $retVal);

	}


	/******************************************************************
	* Create an alarm Profile
	* $alarmDefs: format is string of:
	*   alarmDefId, severity: 
	* XXX TODO: does thresh, oid, etc.. need to be copied in or not?
	* Example:  2,critical|3,warning
	**/
	function createAlarmProfile($name, $description, $email, $notify, $alarmDefsStr)
	{
		/* 1. Create alarm profile in AlarmProfiles table. */

		global $currentUserId;
		global $ALARMPROFILE_LEN;
		global  $ALARMPROFILE2DEF_LEN;

		$createdBy 		= (int) $currentUserId;


		$email 			= cleanTrimParam($email, $ALARMPROFILE_LEN['email']);
		$name 			= cleanTrimParam($name, $ALARMPROFILE_LEN['name']);
		$description 	= cleanTrimParam($description, $ALARMPROFILE_LEN['description']);
	
    if ($notify != '1') {
			$notify = '0';
		}
		
		$email = preg_replace("/ *, */", ", ", $email);
		
		$query = "INSERT INTO AlarmProfiles "
				. " (name, description, createdBy, notify, notifyEmail) "
				. " VALUES "
				. " ('$name', '$description', $createdBy, $notify, '$email') ";

		$result = sqlInsert($query);

		if($result['id'] == null || $result['id'] <=0)
			error("Unable to create profile!");

		$alarmProfileId = $result['id'];
		
		/* 2. Add entries in the AlarmProfile2AlarmDef table. */
		
		$alarmDefsArray = explode('|', $alarmDefsStr);

		if(is_array($alarmDefsArray))
		{
			foreach($alarmDefsArray as $alarmDef)
			{
				$pieces = explode(',', $alarmDef);
				
				$itemCount = count($pieces);
				
				if ($itemCount < 2)
				{
					continue;
				}

				$alarmDefId = (int) $pieces[0];
				$severity =  cleanTrimParam($pieces[1], $ALARMPROFILE2DEF_LEN['severity']);
			
				if($severity != 'info' && $severity != 'critical' && $severity != 'warning')
				{
					$severity = 'critical';
				}
				
				$notify = ($itemCount < 3) ? '1' : $pieces[2];
				$notify = ($notify != '1') ? '0' : $notify;

				addAlarmDefToProfile($alarmProfileId, $alarmDefId, $severity, $notify);

			}
		}
		
		applyAlarmDefProfile($alarmProfileId);

		return tag('alarmProfileId', $alarmProfileId);
		
	}


	function removeAlarmDefFromProfile($profileId, $alarmDefId)
	{
			if($alarmDefId == 0) return;

			$query = "DELETE FROM AlarmProfile2AlarmDef "
				. " WHERE "
				. " alarmId = $alarmDefId "
				. " AND alarmProfileId =  $profileId";

			@sqlUpdate($query);
			$error = mysql_error();
			if($error != "")
				error("Unable to alter alarm def ]in alarm profile! " . $error);


	}

	function changeAlarmDefInProfile($profileId, $alarmDefId, $severity, $notify)
	{
			if($alarmDefId == 0) return;

			$query = "UPDATE AlarmProfile2AlarmDef "
				. " SET  severity = '$severity', notify = $notify "
				. " WHERE "
				//. " deleted = 0 "
				. "  alarmId = $alarmDefId "
				. " AND alarmProfileId =  $profileId";
		

			@sqlUpdate($query);
			$error = mysql_error();
			if($error != "")
				error("Unable to alter alarm def in alarm profile! " . $error);
				
				echo "<!-- updated alarm profile entry record to notify=$notify -->";

	}

	/****************************************************
	* Simple transaction to add an alarm def to a profile
	*
	**/
	function addAlarmDefToProfile($profileId, $alarmDefId, $severity, $notify)
	{

			if($alarmDefId == 0) return;

			$query = "INSERT INTO AlarmProfile2AlarmDef "
				. " (alarmId, alarmProfileId, severity, notify) "
				. " VALUES "
				. " ($alarmDefId, $profileId, '$severity', $notify) ";
		

			@sqlInsert($query);
			$error = mysql_error();
			if($error != "")
				error("Unable to add alarm def to alarm profile! " . $error);

	}


	/****************************************************
	* This function takes a modified alarm profile 
	* and makes sure that the alarm defs in the profile
	* are present in Host2Alarm for ALL hosts that 
	* use this profile.  Ugh.
	*
	* If specify a host id, then we'll just check for that host.
	*
	**/
	function applyAlarmDefProfile($alarmProfileId, $hostId=null)
	{

		/* First see if there are any alarms that exist in Host2Alarm and
		 * NOT in AlarmProfile2AlarmDef table
		 * If one does, then remove it from Host2Alarm.
		 */
		
		$alarmProfileId = (int) $alarmProfileId;

		/* If host id is not null and alarmProfileId <=0, it means
		 * that this alarm profile has been removed from the host.
		*/
		if($hostId != null && $hostId > 0 && $alarmProfileId <=0)
		{

			$query = "DELETE FROM Host2Alarm WHERE hostId=$hostId ";

			sqlUpdate($query);

			return tag('result', 'success');
		}

		$query = 
		 " SELECT Host2Alarm.alarmId as alarmDefId, Hosts.id as hostId "
		." FROM Hosts, Host2Alarm "
		." WHERE   "
		." Host2Alarm.hostId = Hosts.id "
		. ($hostId != null ? " AND Hosts.id = $hostId " : "")
		." AND Hosts.alarmProfileId = $alarmProfileId "
		." AND Not Exists "
		." ( SELECT AlarmProfile2AlarmDef.alarmProfileId  "
		."   FROM AlarmProfile2AlarmDef  "
		."   WHERE AlarmProfile2AlarmDef.alarmId = Host2Alarm.alarmId "
		. "  AND AlarmProfile2AlarmDef.alarmProfileID = $alarmProfileId "
		//."         AND AlarmProfile2AlarmDef.deleted = 0 "
		." ) ";


		$conn = @getConnection();

		$result = mysql_query($query, $conn);

		if(!$result)
			error("Unable to apply alarm profile to its hosts! ". mysql_error());
			
		$numrows = mysql_numrows($result);

		$i = 0;

		while($i < $numrows)
		{	
			$row = mysql_fetch_assoc($result);
			$alarmId = (int)$row['alarmDefId'];
			$hostId = (int)$row['hostId'];

			removeHost2AlarmEntry($hostId, $alarmId);
			$i++;
		}
	 
		/* Next lets do opposite.  If one exists in AlarmProfile2AlarmDef (and not 
		 * deleted), then create it in Host2Alarm.
		 */

		$query =
			  " SELECT AlarmProfile2AlarmDef.alarmId , Hosts.id as hostId "
		   . " FROM AlarmProfile2AlarmDef , Hosts "
		   . " WHERE AlarmProfile2AlarmDef.alarmProfileId = Hosts.alarmProfileId "
			. " AND Hosts.alarmProfileId = $alarmProfileId "
		  //. " AND AlarmProfile2AlarmDef.deleted = 0 "
		   .  ($hostId != null ? " AND Hosts.id = $hostId " : "")
		   . " AND NOT EXISTS  "
		   . " ( SELECT Host2Alarm.hostId FROM Host2Alarm  "
		   . "   WHERE Host2Alarm.hostId = Hosts.id "
   		. " AND Host2Alarm.alarmId = AlarmProfile2AlarmDef.alarmId "
		   . " ) ";

		$result = mysql_query($query, $conn);

		if(!$result)
			error("Unable to apply alarm profile to its hosts! ". mysql_error());
	
		$numrows = mysql_numrows($result);

		$i = 0;


		while($i < $numrows)
		{	
			$row = mysql_fetch_assoc($result);
			$alarmId = (int)$row['alarmId'];
			$hostId = (int)$row['hostId'];

			addHost2AlarmEntry($hostId, $alarmId);
			$i++;
		}

		return tag('result', 'success');

	}


	function removeHost2AlarmEntry($hostId, $alarmId)
	{
		$query =  " DELETE FROM Host2Alarm WHERE hostId=$hostId "
				  . " AND alarmId=$alarmId";

		@sqlUpdate($query);
		$error = mysql_error();
		if($error != "") error("Unable to update alarm profile! " . $error);

	}

	function addHost2AlarmEntry($hostId, $alarmId)
	{
		$query =  " INSERT INTO Host2Alarm "
			. " (alarmId, hostId) "
			. " VALUES "
			. " ($alarmId, $hostId) ";

		@sqlUpdate($query);
		$error = mysql_error();
		if($error != "") error("Unable to update alarm profile! " . $error);

	}


	/****************************************************
	* Modify an alarm Profile
	*
	**/
	function modifyAlarmProfile($id, $name, $description, $email, $notify, $newAlarmDefsStr)
	{
		global $ALARMPROFILE_LEN;


		$id		= (int)$id;
		$name		= cleanTrimParam($name,  $ALARMPROFILE_LEN['name']);
		$description 	= cleanTrimParam($description, $ALARMPROFILE_LEN['description']);
		$email		= cleanTrimParam($email,  $ALARMPROFILE_LEN['email']);

		if ($notify != '1') 
		{
			$notify = '0';
		}
		
		$email = preg_replace("/ *, */", ", ", $email);

		$query = "UPDATE AlarmProfiles "
				. " SET name = '$name', description='$description', notify=$notify, notifyEmail='$email' "
				. " WHERE id = $id ";

		sqlUpdate($query);

		/* Load old and new alarm def lists below */
		$newAlarmDefs = array();
		$oldAlarmDefs = array();

		$arr = explode('|', $newAlarmDefsStr);

		foreach($arr as $alarmDefStr)
		{
			$pieces = explode(',', $alarmDefStr);
			
			$itemCount = count($pieces);
			if ($itemCount < 2)
					continue;
					
			
			if ($itemCount >= 3) {
			  $notify = $pieces[2];
			} else {
				$notify = '1';
			}
			
			
			if ($notify != '1') {
			  $notify = '0';
			}

			$alarmDef = array( "id" => (int) $pieces[0],
							  		 "severity" => $pieces[1],
							  		 "notify" => $notify);

			$newAlarmDefs[] = $alarmDef;
		}

		$query = " SELECT AlarmDefinition.id, AlarmProfile2AlarmDef.severity, AlarmProfile2AlarmDef.notify "
				//.  " AlarmProfile2AlarmDef.deleted "
				.  " FROM AlarmDefinition, AlarmProfile2AlarmDef "
				.  " WHERE AlarmDefinition.id = AlarmProfile2AlarmDef.alarmId "
				.  " AND AlarmProfile2AlarmDef.alarmProfileId = $id ";
		
		$conn = @getConnection();

		$result = mysql_query($query, $conn);

		if(!$result)
			error("Unable to retrieve alarm profile from the database! ". mysql_error());
			
		$numrows = mysql_numrows($result);

		$i = 0;

		while($i < $numrows)
		{	
			$row = mysql_fetch_assoc($result);

			$notify = $row["notify"];
			if ($notify != '1') {
			  $notify = '0';
			}
			
			$alarmDef = array( "id" => (int) $row['id'],
							       "severity" => $row['severity'],
							       "notify" => $notify
							       );
							       //"deleted" => (int) $row['deleted']);

			$oldAlarmDefs[] = $alarmDef;
			$i++;
		}

		
		/*
		* For each alarm def in the new list, we need to see if it's still in the
		* the original alarm profile.
		* If it is, then check it's severity.  If they're the same, skip it.
		* If it's not in the alarm profile, then we need to create entry in 
		* AlarmProfile2Alarm.
		*
		* UPDATE 2011-02-25: check the notify flag as well.
		*/

		foreach($newAlarmDefs as $newAlarmDef)
		{
			$result =	getAlarmDefInList($oldAlarmDefs, $newAlarmDef['id']);

			if(!$result)
			{
				 addAlarmDefToProfile($id, $newAlarmDef['id'], $newAlarmDef['severity'], $newAlarmDef['notify']);
			}
			else
			{
				if($result['severity'] ==  $newAlarmDef['severity'] && $result['notify'] == $newAlarmDef['notify']) {
				/* Just continue to next one */
					continue;
				} else {
					changeAlarmDefInProfile($id, $newAlarmDef['id'], $newAlarmDef['severity'], $newAlarmDef['notify']);
				}
			}
		}

		foreach($oldAlarmDefs as $oldAlarmDef)
		{
			$result = getAlarmDefInList($newAlarmDefs, $oldAlarmDef['id']);
			if(!$result)
			{
				// Then need to remove this alarm def from the profile
				
				removeAlarmDefFromProfile($id, $oldAlarmDef['id']);

				
			}
		}

		applyAlarmDefProfile($id);
		
		return tag('result', 'success');
	}

	function getAlarmDefInList($searchList, $id)
	{

		foreach($searchList as $alarmDef)
		{
			if((int)$alarmDef['id'] == $id)
				return $alarmDef;
		}

		return FALSE;
	}

	function removeAlarmProfileFromHost($hostId)
	{
		$hostId = (int) $hostId;

		$query = "DELETE FROM Host2Alarm WHERE hostid = $hostId";


		sqlCmd($query);


	}

	/****************************************************
	* Remove an alarm Profile
	*
	**/
	function deleteAlarmProfile($alarmProfileId)
	{
		$alarmProfileId = (int)$alarmProfileId;
		
		// XXX TODO: What do do for the hosts that use this alarm profile?  Remove 
		// all alarms that that host is reporting on?
		// Set to some default alarm profile?

		// 1. Update device types
		$query = "UPDATE DeviceTypes Set defaultAlarmProfileId = NULL "
				. " WHERE defaultAlarmProfileId = $alarmProfileId ";

		@sqlUpdate($query);
		$error = mysql_error();

		if($error != "")
			error("Unable to remove alarm profile! " . $error);

		
		// 3. Remove all entries in Host2Alarm for hosts that are using
		//    this alarm profile.
		$query =   " DELETE FROM Host2Alarm "
					. " WHERE "
					. "    Exists(SELECT Hosts.id FROM Hosts "
					. "           WHERE Hosts.alarmProfileId = $alarmProfileId "
					. "           AND Host2Alarm.hostId = Hosts.id) ";

		@sqlUpdate($query);
		$error = mysql_error();

		if($error != "")
			error("Unable to remove alarm profile! " . $error);		
		


		// 2. Update hosts
		$query = "UPDATE Hosts Set alarmProfileId = NULL "
				. " WHERE alarmProfileId = $alarmProfileId ";


		@sqlUpdate($query);
		$error = mysql_error();

		if($error != "")
			error("Unable to remove alarm profile! " . $error);		
		

		// 4. Remove all entries in AlarmProfile2AlarmDef 
		//    for this alarm profile.
		$query = "DELETE FROM AlarmProfile2AlarmDef " //SET deleted = 0  "
				. " WHERE alarmProfileId = $alarmProfileId ";

		@sqlUpdate($query);
		$error = mysql_error();

		if($error != "")
			error("Unable to remove alarm profile! " . $error);		
		

		// 5. Update custom registration settings
		$query = "UPDATE CustomRegistrationRules set alarmProfileId = NULL  "
				. " WHERE alarmProfileId = $alarmProfileId ";

		@sqlUpdate($query);
		$error = mysql_error();

		if($error != "")
			error("Unable to remove alarm profile! " . $error);		
		

		// 6. Delete alarm profile

		$query = "DELETE FROM AlarmProfiles  "
				. " WHERE id = $alarmProfileId ";

		@sqlUpdate($query);
		$error = mysql_error();

		if($error != "")
			error("Unable to remove alarm profile! " . $error);		
		

	}
}
?>
