<?php

include('lib/sql.php');
include('lib/task.php');

if(!function_exists('cfgBackup_wrapper'))
{

	function cfgBackup_wrapper() {}

	/*********************************************************************************
	* NOTE: this file is used to handle configs stored in the config history table, 
	* CfgBackup, NOT the managed config table ConfigFiles.  
	*/
	
	function handleCfgBackupAction($action)
	{
		if($action == null)
			error('Unauthorized');

		switch($action)
		{
			case 'task':
				echo createConfigTask(req('hostId'), req('cfg'));

			break;
			case 'delete':
				echo removeCfgBackup(req('id'));
			break;
			case 'modify':
				echo modifyCfgBackup(req('id'), req('cfg'));
			break;
			case 'create':
				echo createCfgBackup(req('hostid'), req('cfg'));
			break;
			case 'download':
				echo downloadCfgBackup(req('id'));
			break;
			case 'get':
				echo viewCfgBackup(req('id'));
			break;

			case 'search':
				echo tag('result', searchCfgBackup(req('hostId'), req('dateStart'), req('dateEnd'),
						req('pageSize'), req('pageNumber'), req('sortField'), req('sortDirection')));
			break;

		}

	}

	function createCfgBackup( $hostId, $cfg)
	{
		$hostId = (int) $hostId;

		$cfg = cleanParam($cfg);

		global $currentUserId;

		$query = "INSERT INTO CfgBackup "
			. " (hostid, cfg, manual, createdBy, editedBy) "
			. " VALUES "
			. " ($hostId, '$cfg', 1, $currentUserId, $currentUserId) ";

		$result = @sqlInsert($query);
	
		if($result == null || $result['rows'] <=0 || $result['id'] <=0)
			error('Unable to create new entry! ' . mysql_error());
		
		$configId = $result['id'];

		return tag('result', tag('configId', $configId));

		
	}

	function modifyCfgBackup( $id, $cfg)
	{
		$id = (int) $id;

		$cfg = cleanParam($cfg);

		global $currentUserId;

		$query = "UPDATE CfgBackup "
			. " SET editedBy = $currentUserId, "
			. " cfg = '$cfg' "
			. " WHERE id = $id ";

		 @sqlUpdate($query);
		sqlError('Unable to save changes! ');
		

		return tag('result', 'success');

		
	}
	
	function searchCfgBackup($hostId, $dateStart, $dateEnd,$pageSize, $pageNumber,
									$sortField, $sortDirection)
	{
		
		$dateStart 	= cleanParam($dateStart);
		$dateEnd 	= cleanParam($dateEnd);

		$hostId = (int) $hostId;
		$pageSize = (int) $pageSize;
		$pageNumber = (int) $pageNumber;
	
		$page = ($pageNumber - 1) * $pageSize;

		$query = "SELECT CfgBackup.*, "
					. " IFNull(Task.name, '') as task,  "
					. " IFNull( u1.username, '') as editedBy, "
					. " IFNull( u2.username, '') as createdBy " ;

		$recordCountQuery = " SELECT Count(CfgBackup.id) as Total ";

		$mainQuery = " FROM CfgBackup  "
					. " LEFT JOIN Task "
					. " ON Task.id = CfgBackup.taskid "
					. " LEFT JOIN Users u1 on CfgBackup.editedBy =  u1.id "
					. " LEFT JOIN Users u2 on CfgBackup.createdBy = u2.id "
					. " WHERE CfgBackup.hostId = $hostId "
					. ($dateEnd != ""?  " AND CfgBackup.date <= '$dateEnd' " : "");
		
	
		if($sortField != "")
		{
			$sortField = getSortByField_cfgHistory($sortField);


			$mainQuery .= " Order By $sortField $sortDirection ";

		}			
		$mainQuery .= " LIMIT $page, $pageSize ";

		$query .= $mainQuery;
		$recordCountQuery .= $mainQuery;

		$conn = getConnection();
		$result = @mysql_query($query, $conn);

		if(!$result)
			error("Unable to retrieve config file list! " . mysql_error());

		$numrows = mysql_numrows($result);

		$retVal = "<configs>";

		$i = 0;

		while($i < $numrows)
		{	
			$config = mysql_fetch_assoc($result);
 			
			$retVal .= "<config>\n";

			$taskId =  (int) $config['taskid'];

			if($taskId >0)
				$readonly = 1;
			else $readonly = 0;

			$info = "";

			$manual = (int) $config['manual'];

			if($taskId && $manual)
			{
				$info = "Created by " . $config['createdBy'] . " for task labeled " . $config['task'];

			}
			else if($taskId <=0 && $manual)
			{
				$info = "Created by " . $config['createdBy'] . " (Draft)";

			}
			else if($manual <=0 && $taskId > 0)
			{
				$info = "Config uploaded via task: " . $config['task'];
			}

			$retVal .= tag('id', $config['id']);
			$retVal .= tag('date', $config['date']);
			$retVal .= tag('taskId', $config['taskid']);
			$retVal .= tag('hostId', $config['hostid']);
			$retVal .= tag('info', $info);
			$retVal .= tag('readonly', $readonly);


			$retVal .= "</config>";
			$i++;
		}
	
		$retVal .= "</configs>";

		$totalRecords = @sqlNumber($recordCountQuery, "Total");

		$retVal .= tag('totalCount', $totalRecords); 
		return $retVal;	
		

	}



	/***************************************************
	* Get the contents of a config file in CfgBackup
	*/
	function viewCfgBackup($id)
	{
		$id  = (int) $id;

		$query = "SELECT CfgBackup.cfg , CfgBackup.date "
				. " FROM CfgBackup  "
				. " WHERE id = $id ";


		$result = @sqlRow($query);

		sqlError("Unable to retrieve config file! ");

		$retVal .= tag('id', $id);
		$retVal .= tag('date', $result['date'], TRUE);
		$retVal .= tag('contents', $result['cfg'], TRUE);

		return tag('config', $retVal, FALSE, " id= '$id' ");	
		
	}


	/***************************************************
	* Download a config file in CfgBackup
	*/
	function downloadCfgBackup($id)
	{
		$id  = (int) $id;

		$query = "SELECT CfgBackup.cfg  "
				. " FROM CfgBackup  "
				. " WHERE id = $id ";

		$content = @sqlString($query, 'cfg');
		
		echo $content;	
		
	}

	/***************************************************
	* Remove a config file from CfgBackup
	*/
	function removeCfgBackup($id)
	{

		$query = "DELETE From CfgBackup WHERE id = $id";

		sqlUpdate($query);

		sqlError("Unable to remove file! ");

		return "success";
	}

	/**************************************************************
	* Translate the client's sort by field to actual DB values
	*
	**************************************************************/	
	function getSortByField_cfgHistory($name)
	{

		$name = strtolower($name);

		switch($name)
		{
			case "date" : return "CfgBackup.date"; 
		}

		return "CfgBackup.date";
			
	}


	
}
?>
