<?php

include('lib/sql.php');
include('lib/user.php');

if(!function_exists('cleanup_wrapper'))
{

	function cleanup_wrapper() {}

	function handleCleanupAction($action)
	{
		if($action == null)
			error('Unauthorized');

		global $currentUserId;

		if(!isUserAdminUser($currentUserId))
		{
			error("You must be an admin to run cleanup tasks.");
			return;
		}


		switch($action)
		{
			case 'run':
				runCleanupTasks(req('tasks'));

			break;
				

		}

	}

	function runCleanupTasks($s_tasks)
	{
		$tasks = explode(',', $s_tasks);

		foreach($tasks as $task)
		{
			$taskOptions = explode('.',$task);
	
			if(count($taskOptions) != 2){
				
				continue;
			}
			$type = $taskOptions[0];
			$date = $taskOptions[1];

			runCleanupTask($type, $date);	
		}

		return tag('result', 'success');
	}

	function runCleanupTask($type, $date)
	{
		if ($date == '')
		{
			return;
		}
		
		switch($type)
		{
			case 'fw':
				$query = "DELETE FROM Task WHERE cleared = 1 and createdOn <= '$date'";

				@sqlUpdate($query);
  				sqlError("Unable to run firmware cleanup task! ");

			break;

			case 'alerts':
			case 'alarms':
				// Clean cleared alarms up through the $date

				$query  = " DELETE FROM Alarms WHERE cleared = 1 and time <= '$date' ";

				@sqlUpdate($query);
  				sqlError("Unable to run alarm cleanup task! ");

			break;

			case 'stats':
				// Clean stats up through the $date
				
				$tableNames = array ("Stats", "Stats_Day", "Stats_Week", "Stats_Month");
				
				foreach ($tableNames as $table)
				{
					$query  = " DELETE FROM $table WHERE time <= '$date' ";
				
					@sqlUpdate($query);
					sqlError("Unable to run stats cleanup task! ");
				}

			break;

		}

	
	}
}
?>
