<?php

include('lib/sql.php');
include('lib/permissions.php');

if(!function_exists('configFile_wrapper'))
{

	function configFile_wrapper() {}

	/* Lengths of DB fields in the ConfigFiles table */
	$CONFIGFILES_LEN = array(
				'name' 		=> 100,
				'description' 	=> 200);

	/*********************************************************************************
	* NOTE: this file is used to handle configs store in both the config history table, 
	* CfgBackup, and the managed config table ConfigFiles.  
	*/
	
	function handleConfigAction($action)
	{
		if($action == null)
			error('Unauthorized');

		switch($action)
		{
			case 'upload':
				echo uploadConfig(req('name') , req('desc'));

			break;
				
			case 'delete':
				echo tag('result', removeConfig(req('id')));
	
			break;

			case 'modify':				
			   echo modifyConfig(req('id'),req('name') , req('desc'),req('cfg'));
			break;

			case 'modifyDescription':
			   echo modifyDescription(req('id'), req('desc'));
			break;

			case 'view':
				echo viewConfig(req('id'));
			break;

			case 'get':
				echo tag('result',  getConfigFiles());
			break;

		
			break;

		}

	}


	/***************************************************
	* Get a list of available config files and description
	* (not the file texts tho)
	*/
	function getConfigFiles()
	{

		$query = "SELECT ConfigFiles.id, ConfigFiles.name, "
				. " ConfigFiles.description, Users.username as addedBy, "
				. " ConfigFiles.addedOn, length(ConfigFiles.cfg) AS fileSize "
				. " FROM ConfigFiles LEFT JOIN Users  "
				. " ON ConfigFiles.addedBy = Users.id ";

		$conn = getConnection();
		$result = @mysql_query($query, $conn);

		if(!$result)
			error("Unable to retrieve config file list! ");

		$numrows = mysql_numrows($result);

		$retVal = "<configFiles>";

		$i = 0;

		while($i < $numrows)
		{	
			$config = mysql_fetch_assoc($result);
 			
			$retVal .= "<config>\n";

			foreach($config as $key=>$value)
			{			
				$tag = tag($key, $value);

				$retVal .= $tag;
			}

			$retVal .= "</config>";
			$i++;
		}
	
		$retVal .= "</configFiles>";

		return $retVal;	
		
	}

	/***************************************************
	* Get the contents of a config file
	*/
	function viewConfig($id)
	{
		$retVal = '';
		$id  = (int) $id;

		$query = "SELECT ConfigFiles.cfg , ConfigFiles.name, "
				. " ConfigFiles.description   "
				. " FROM ConfigFiles  "
				. " WHERE id = $id ";


		$result = @sqlRow($query);

		sqlError("Unable to retrieve config file! ");

		$contents = $result['cfg'];


		$retVal .= tag('name', $result['name'], TRUE);
		$retVal .= tag('id', $id);
		$retVal .= tag('desc', $result['description'], TRUE);

		$retVal .= tag('configContents', $contents, TRUE);

		return tag('result', $retVal);	
		
	}


	/**************************************************************
	* Upload a new config file
	*
	*/
	function uploadConfig($name, $desc)
	{

		global $currentUserId;
		global $CONFIGFILES_LEN;


		$name = cleanTrimParam($name, $CONFIGFILES_LEN['name']);
		$desc = cleanTrimParam($desc, $CONFIGFILES_LEN['description']);

		if($_FILES['Filedata']['size'] <= 0)
		{
			error("Unable to upload file!");
		}
	
		$tmpName = $_FILES['Filedata']['tmp_name'];
		$fileName = $_FILES['Filedata']['name'];

		$fp = fopen($tmpName, 'r');
		$content = fread($fp, filesize($tmpName));
		fclose($fp);

		//$content = base64_encode($content);

		$query = "INSERT INTO ConfigFiles "
				. " (addedby, name, description, cfg) "
				. " VALUES "
				. " ($currentUserId, '$name', '$desc', '$content')";

		sqlInsert($query);

		$error = mysql_error();

		if($error != "")
			error($error);
		return tag('result', 'success');
	}

	/**************************************************************
	* Remove a configuration file from the DB
	* Method perfectly fits to remove one and multiple items
	*/
	function removeConfig($id)
	{

		$query = "UPDATE DeviceTypes Set defaultConfigId = NULL "
				. " WHERE defaultConfigId IN ($id) ";

		@sqlUpdate($query);
		$error = mysql_error();

		if($error != "")
			error("Unable to remove config! " . $error);		

		$query = "DELETE From ConfigFiles WHERE id IN ($id)";

		sqlUpdate($query);

		$error = mysql_error();

		if($error != "")
			error($error);

		return "success";
	}

	/**************************************************************
	* Update a config - assume content is already base 64 encoded
	*
	*/
	function modifyConfig($id, $name, $desc, $content)
	{
		$id = (int) $id;

		global $CONFIGFILES_LEN;

		$name = cleanTrimParam($name, $CONFIGFILES_LEN['name']);
		$desc = cleanTrimParam($desc, $CONFIGFILES_LEN['description']);
		$content = cleanParam($content);

		$query = "UPDATE ConfigFiles "
				. " SET cfg = '$content', name='$name', description='$desc' "
				. " WHERE  id = $id ";

		sqlUpdate($query);

		$error = mysql_error();

		if($error != "")
			error($error);
		else echo tag('result', 'success');
	}

	/**************************************************************
	* Update config description only
	*
	*/
	function modifyDescription($id, $desc)
	{
		$id = (int) $id;

		global $CONFIGFILES_LEN;

		$desc = cleanTrimParam($desc, $CONFIGFILES_LEN['description']);

		$query = "UPDATE ConfigFiles "
				. " SET description='$desc' "
				. " WHERE  id = $id ";

		sqlUpdate($query);

		$error = mysql_error();

		if($error != "")
			error($error);
		else echo tag('result', 'success');
	}
}
?>
