<?php


include('lib/sql.php');
include('lib/settings.php');
include('lib/permissions.php');
include('lib/user.php');

if(!function_exists('customRegistration_wrapper'))
{
	function customRegistration_wrapper() {}

	/* The length of fields in the DB for the CustomRegistrationRules table */
	$RULES_LEN = array(
				'name' 			=> 25,
				'mac' 			=> 30,
				'device' 		=> 50);


	function handleCustomRegistrationAction($action)
	{
		if($action == null)
			error('Unauthorized');

		switch($action)
		{
			case 'get':

				echo getRegistrationInfo();

			break;
				
			case 'update':
				echo updateRegistrationRule(req('id'),  req('downloadConfig'), 
													req('uploadConfig'), req('name'),
  													req('mac'), req('device'), req('networkId'), 
													req('alarmProfileId'), 
													req('statsProfileId'),
													req('configId'), req('deviceTypeId'));

			break;

		  case 'create':
				echo createRegistrationRule(req('downloadConfig'), 
													req('uploadconfig'), req('name'),
  													req('mac'), req('device'), req('networkId'), 
													req('alarmProfileId'), 
													req('statsProfileId'),
													req('configId'), req('deviceTypeId'));

			break;

			case 'update-mode':
				echo updateMode(req('mode'));

			break;

			case 'delete':
				echo deleteRule(req('id'));
			break;
	

		}

	}

	/***************************************************
	* Return registration info
	*/
   function getRegistrationInfo()
	{

	  	$retVal = getRegistrationRules();
		
      $retVal .= tag('registrationMode', getRegistrationMode(), true);
		
		return tag('results', $retVal);


   }

   function getRegistrationMode()
	{
		$retVal = sqlString("SELECT SystemSettings.value from SystemSettings "
						. " WHERE SystemSettings.key like 'RegistrationMode'", "value");
		$error = mysql_error();

		if($error != "")
			error("Unable to retrieve registration mode! " . $error);

		return $retVal;

	
	}


	/***************************************************
	* Return the list of custom registration rules
	*/
   function getRegistrationRules()
	{
		$query =  " SELECT CustomRegistrationRules.*,  "
				. " CASE WHEN Networks.name is null THEN 'No Network' ELSE Networks.name END as network, "
				. " Users.username as user, StatsProfiles.name as statsProfileName, "
				. " AlarmProfiles.name as alarmProfileName, "
				. " CASE WHEN UploadConfig = 1 THEN 'Yes' ELSE 'No' END As uploadConfigDisplay, "
				. " CASE WHEN DownloadConfig = 1 THEN 'Yes' ELSE 'No' END as downloadConfigDisplay "
				. " FROM CustomRegistrationRules  "
				. " Left Join Networks on Networks.Id = CustomRegistrationRules.networkId "
				. " Left Join Users on Users.id = CustomRegistrationRules.createdBy "
				. " Left Join AlarmProfiles on AlarmProfiles.id = CustomRegistrationRules.alarmProfileId "
				. " Left Join StatsProfiles on StatsProfiles.id = CustomRegistrationRules.statsProfileId ";

		$conn = @getConnection();

		$error = mysql_error();

		if($error != "")
			error("Unable to create db connection! " . $error);

		$result = mysql_query($query, $conn);

		if(!$result)
		{
			error("Unable to retrieve list of Custom Registration Rules! ". mysql_error());
			return;
		}
		$numrows = mysql_numrows($result);

		$retVal = "";

		$i = 0;
 
		$retVal = "<registrationRules>";

		while($i < $numrows)
		{	
			$row = mysql_fetch_assoc($result);
 			
			$retVal .= "<registrationRule id='" . $row['id'] . "'>";
			
			$alarmProfileId = (int)$row['alarmProfileId'];
			$statsProfileId = (int)$row['statsProfileId'];
			$configId		 = (int)$row['configId'];
			$deviceTypeId	 = (int)$row['deviceTypeId'];
			$networkId	 = (int)$row['networkId'];


			$retVal .= tag('id', $row['id']);
			$retVal .= tag('downloadConfig', $row['downloadConfig']);
			$retVal .= tag('uploadConfig', $row['uploadConfig']);

			$retVal .= tag('downloadConfigDisplay', $row['downloadConfigDisplay']);
			$retVal .= tag('uploadConfigDisplay', $row['uploadConfigDisplay']);
			$retVal .= tag('name', $row['name'], true);
			$retVal .= tag('mac', $row['mac'], true);
			$retVal .= tag('device', $row['device'], true);
			$retVal .= tag('network', $row['network'], true);
			$retVal .= tag('alarmProfileId', $alarmProfileId);
			$retVal .= tag('statsProfileId', $statsProfileId);

			$retVal .= tag('alarmProfileName', $row['alarmProfileName'], true);
			$retVal .= tag('statsProfileName', $row['statsProfileName'], true);
			$retVal .= tag('configId', $configId);
			$retVal .= tag('user', $row['user'], true);
			$retVal .= tag('createdOn', $row['createdOn'], true);
			$retVal .= tag('deviceTypeId', $deviceTypeId);

			$retVal .= tag('networkId', $networkId);

			$retVal .= "</registrationRule>";
			$i++;
		}


		$retVal .= "</registrationRules>\n";

		return $retVal;

	}

	/************************************************************
	* Create a new custom registration rule.
	*	
	*/
	function createRegistrationRule( $downloadConfig, $uploadConfig, $name,$mac, 
											$device, $networkId, $alarmProfileId, $statsProfileId,
											$configId, $deviceTypeId)
	{

		global $RULES_LEN;
		global $currentUserId;

		$alarmProfileId = (int)$alarmProfileId;
		$statsProfileId = (int)$statsProfileId;
		$configId = (int)$configId;
		$deviceTypeId = (int)$deviceTypeId;

		$downloadConfig = (int)$downloadConfig;
		$uploadConfig = (int)$uploadConfig;

		$networkId = (int)$networkId;

		$name = cleanTrimParam($name, $RULES_LEN['name']);
		$mac = cleanTrimParam($mac, $RULES_LEN['mac']);
		$device = cleanTrimParam($device, $RULES_LEN['device']);


      if($deviceTypeId  <=0)
			$deviceTypeId = 'NULL';

      if($configId  <=0)
			$configId = 'NULL';

      if($alarmProfileId  <=0)
			$alarmProfileId = 'NULL';

      if($statsProfileId  <=0)
			$statsProfileId = 'NULL';

      if($networkId  <=0)
			$networkID = 'NULL';

	   updateMode('custom');

		$query = " INSERT INTO CustomRegistrationRules "
				. " (downloadConfig, uploadConfig, name, mac, device, alarmProfileId, "
				. " statsProfileId, configId, createdBy, deviceTypeId, networkId) "
				. " VALUES "
				. " ($downloadConfig, $uploadConfig, '$name', '$mac', '$device', $alarmProfileId, "
				. " $statsProfileId, $configId, $currentUserId, $deviceTypeId, $networkId) ";

		@sqlInsert($query);

		$error = mysql_error();

		if($error != "")
			error("Unable to create rule! " . $error);

		return tag('result', 'success');
	}

	/************************************************************
	* Modify a custom registration rule.
	*	
	*/
	function updateRegistrationRule($id, $downloadConfig, $uploadConfig, $name,$mac, 
											$device, $networkId, $alarmProfileId, $statsProfileId,
											$configId, $deviceTypeId)
	{

		global $RULES_LEN;
		global $currentUserId;
				
				

		$id = (int)$id;

		$alarmProfileId = (int)$alarmProfileId;
		$statsProfileId = (int)$statsProfileId;
		$configId = (int)$configId;
		$deviceTypeId = (int)$deviceTypeId;


		$downloadConfig = (int)$downloadConfig;
		$uploadConfig = (int)$uploadConfig;

		$networkId = (int)$networkId;

		$name = cleanTrimParam($name, $RULES_LEN['name']);
		$mac = cleanTrimParam($mac, $RULES_LEN['mac']);
		$device = cleanTrimParam($device, $RULES_LEN['device']);

      if($deviceTypeId  <=0)
			$deviceTypeId = 'NULL';

      if($configId  <=0)
			$configId = 'NULL';

      if($alarmProfileId  <=0)
			$alarmProfileId = 'NULL';

      if($statsProfileId  <=0)
			$statsProfileId = 'NULL';


      if($networkId  <=0)
			$netorkId = 'NULL';


		updateMode('custom');

		$query = " UPDATE CustomRegistrationRules "
				. " SET "
				. " downloadConfig= $downloadConfig, "
				. " uploadConfig= $uploadConfig, "
				. " name= '$name', "
				. " mac= '$mac' , "
				. " device= '$device', "
				. " networkId= $networkId , "
				. " alarmProfileId= $alarmProfileId, "
				. " statsProfileId= $statsProfileId, "
				. " configId= $configId, "
				. " deviceTypeId = $deviceTypeId "
				. " WHERE id = $id";

		@sqlUpdate($query);

		$error = mysql_error();

		if($error != "")
			error("Unable to update rule! " . $error);

		return tag('result', 'success');
	}


	function updateMode($newMode)
	{

		global $currentUserId;

		if(!isUserAdminUser($currentUserId))
					error("Unauthorized attempt to write database settings!");

		setDefaultMode();

		$query  =  "UPDATE SystemSettings "
					. " SET SystemSettings.value = '" . cleanParam($newMode) . "' "
					. " WHERE  SystemSettings.key = 'RegistrationMode' ";

		@sqlUpdate($query);

		$error = mysql_error();

		if($error != "")
			error("Unable to update registration mode! $error");

		return tag('result', 'success');
	}

   /**************************************************
	* If registration mode settings doesn't exist, 
 	* let's create them now.
	*/
	function setDefaultMode()
	{
			$query = " SELECT SystemSettings.key FROM SystemSettings "
			    		. " WHERE SystemSettings.key like 'RegistrationMode' ";

			$currentKey = sqlString( $query, "key");

			if($currentKey == "" || $currentKey == null)
			{

			   $query = "INSERT INTO SystemSettings "
							. " (SystemSettings.key, SystemSettings.value) " 
							. " VALUES "
						   . " ('RegistrationMode', '" . cleanParam($value) . "') ";

				// then create the setting
				sqlInsert($query);

			}
					 
	}

	function deleteRule($id)
	{	
		$id = (int) $id;
		
		$query = "DELETE FROM CustomRegistrationRules WHERE id = $id";

		@sqlUpdate($query);
		$error = mysql_error();

		if($error != "")
			error($error);

		return tag('result', 'success');	
	}
}

?>
