<?php

include('lib/sql.php');
include('lib/permissions.php');
include('lib/user.php');

if(!function_exists('deviceTypes_wrapper'))
{

	function deviceTypes_wrapper() {}

	/* Lengths of DB fields in the DeviceTypes table */
	$DEVICETYPES_LEN = array(
				'mfg' 	=> 30,
				'name' 	=> 25);

	function handleDeviceTypeAction($action)
	{
		if($action == null)
			error('Unauthorized');

		switch($action)
		{
			case 'create':
				echo tag('result', createDeviceType(req('name'), req('mfg'), 
															    req('firmwareId'), 
									  							 req('configId'), req('statsProfileId'), 
									  							 req('alarmProfileId'), req('dclass')));
			break;
				
			case 'delete':
				deleteDeviceType(req('id'));
	
			break;

			case 'modify':				
				echo modifyDeviceType(
									  req('id'), req('name'), req('mfg'), req('firmwareId'), 
									  req('configId'), req('statsProfileId'), 
									  req('alarmProfileId'), req('dclass'));
			break;

			
			case 'get':
				echo tag('result',  getDeviceTypes());
			break;

		}

	}

	/******************************************************************
	* Create a Device Type
	*
	**/
	function createDeviceType($name, $mfg, $firmwareId, $configId, 
										$statsProfileId, $alarmProfileId,
										$class) 
	{

		global $DEVICETYPES_LEN;

		$name 	= cleanTrimParam($name,  $DEVICETYPES_LEN['name']);
		$mfg 		= cleanTrimParam($mfg,  $DEVICETYPES_LEN['mfg']);
		$class	= cleanParam($class);

		$firmwareId 		= (int) $firmwareId;
		$configId 			= (int) $configId;
		$statsProfileId 	= (int)$statsProfileId;
		$alarmProfileId 	= (int)$alarmProfileId;
	
		/* values MUST be null instead of 0 */

		if($firmwareId 	 <=0)		$firmwareId 	 = 'NULL';
 		if($configId 		 <=0)		$configId 		 = 'NULL';
 		if($statsProfileId <=0) 	$statsProfileId = 'NULL';
 		if($alarmProfileId <=0) 	$alarmProfileId = 'NULL';

		$query = "INSERT INTO DeviceTypes "
				. " (name, mfg, defaultFirmwareId, defaultConfigId, "
				. "  defaultStatsProfileId, defaultAlarmProfileId, class) "
				. " VALUES "
				. " ('$name', '$mfg', $firmwareId, $configId, $statsProfileId, "
				. "  $alarmProfileId, '$class') ";

		$result = sqlInsert($query);

		if($result['id'] == null || $result['id'] <=0)
			error("Unable to create device type! " . mysql_error());

		$deviceTypeId = $result['id'];
		
		return tag('deviceTypeId', $deviceTypeId);
		
	}

	/****************************************************
	* Modify a Device Type
	*
	**/
	function modifyDeviceType($deviceTypeId, $name, $mfg, $firmwareId, $configId, 
									  $statsProfileId, $alarmProfileId, $class)
	{

		global $DEVICETYPES_LEN;

		$name 	= cleanTrimParam($name,  $DEVICETYPES_LEN['name']);
		$mfg 		= cleanTrimParam($mfg,  $DEVICETYPES_LEN['mfg']);
		$class	= cleanParam($class);

		$firmwareId 		= (int) $firmwareId;
		$configId 			= (int) $configId;
		$statsProfileId 	= (int)$statsProfileId;
		$alarmProfileId 	= (int)$alarmProfileId;
		$deviceTypeId 		= (int)$deviceTypeId;
	
		/* values MUST be null instead of 0 */

		if($firmwareId 	 <=0)		$firmwareId 	 = 'NULL';
 		if($configId 		 <=0)		$configId 		 = 'NULL';
 		if($statsProfileId <=0) 	$statsProfileId = 'NULL';
 		if($alarmProfileId <=0) 	$alarmProfileId = 'NULL';
 
		$query = "UPDATE DeviceTypes "
				. " SET "
				. " name = '$name', "
				. " mfg = '$mfg', "
				. " defaultFirmwareId=$firmwareId, "
				. " defaultConfigId=$configId, "
				. " defaultStatsProfileId=$statsProfileId, "
				. " defaultAlarmProfileId=$alarmProfileId, "
				. " class='$class' "
				. " WHERE id = $deviceTypeId ";

		sqlUpdate($query);

		return tag('result', 'success');

	}


	/****************************************************
	* Remove a device type
	*
	**/
	function deleteDeviceType($deviceTypeId)
	{
		$deviceTypeId = (int)$deviceTypeId;
	
		// Get all hosts that use this device type and set to null

		$query = 	" UPDATE Hosts SET deviceTypeId = NULL "
					.  " WHERE deviceTypeId = $deviceTypeId ";

		sqlUpdate($query);

		// Update custom registration settings
		$query = 	" UPDATE CustomRegistrationRules "
					. "  SET deviceTypeId = NULL "
					.  " WHERE deviceTypeId = $deviceTypeId ";


		sqlUpdate($query);

		// Do final delete
		$query = "DELETE FROM DeviceTypes WHERE id = $deviceTypeId";

		sqlUpdate($query);

		sqlError("Unable to delete device type! ");

		return tag('result', 'success');
	}

	/****************************************************
	* Remove an alarm Profile
	*
	**/
	function getDeviceTypes()
	{
		$query =   " SELECT  "
					. " DeviceTypes.*, "
					. " CASE WHEN FirmwareFiles.name is null then 'n/a' "
					. "      ELSE FirmwareFiles.name END AS firmware, "
					. " CASE WHEN ConfigFiles.name is null then 'n/a' "
					. "      ELSE ConfigFiles.name END AS config, "
					. " CASE WHEN AlarmProfiles.name is null then 'n/a' "
					. "      ELSE AlarmProfiles.name END as alarmProfile, "
					. " CASE WHEN StatsProfiles.name is null then 'n/a' "
					. "      ELSE  StatsProfiles.name END as statsProfile "
					. " FROM DeviceTypes "
					. " LEFT JOIN ConfigFiles "
					. " ON DeviceTypes.defaultConfigid = ConfigFiles.id "
					. " LEFT JOIN FirmwareFiles "
					. " ON DeviceTypes.defaultFirmwareId = FirmwareFiles.id "
					. " LEFT JOIN AlarmProfiles "
					. " ON DeviceTypes.defaultAlarmProfileId = AlarmProfiles.id "
					. " LEFT JOIN StatsProfiles "
					. " ON DeviceTypes.defaultStatsProfileId = StatsProfiles.id ";

		
		$conn = getConnection();
		$result = @mysql_query($query, $conn);

		if(!$result)
			error("Unable to device types! ");

		$numrows = mysql_numrows($result);

		$retVal = "<deviceTypes>";

		$i = 0;

		while($i < $numrows)
		{	
			$deviceType = mysql_fetch_assoc($result);
 			
			$retVal .= "<deviceType>\n";

			foreach($deviceType as $key=>$value)
			{			
				if($key == 'class')
					$key = 'dclass'; // stupid class keyword in flex

				$deviceTag = tag($key, $value);

				$retVal .= $deviceTag;
			}

			$retVal .= "</deviceType>";
			$i++;
		}
	
		$retVal .= "</deviceTypes>";
		return $retVal;	
	}


}
?>
