<?php

include('lib/sql.php');

if(!function_exists('firmware_wrapper'))
{

	function firmware_wrapper() {}

	/* Lengths of DB fields in the FirmwareFiles table */
	$FIRMWAREFILES_LEN = array(
				'name' 			=> 100,
				'description' 	=> 100);

	
	function handleFirmwareAction($action)
	{
		if($action == null)
			error('Unauthorized');

		switch ($action)
		{
			case 'upload':
				uploadFirmware(req('name'), req('desc'));
				break;

			case 'delete':
				echo tag('result', removeFirmware(req('id')));
				break;

			case 'update':
				updateFirmware(req('id'), req('desc'));
				break;

			case 'get':
				echo tag('result', getFirmwareList());
				break;
		}

	}

	/***************************************************
	* Get a list of available firmware files and description
	* (not the image bytes tho)
	*/
	function getFirmwareList()
	{

		$query = "SELECT FirmwareFiles.id, FirmwareFiles.name, "
				. " FirmwareFiles.description, Users.username as addedBy, "
				. " FirmwareFiles.addedOn, length(FirmwareFiles.contents) AS fileSize "
				. " FROM FirmwareFiles LEFT JOIN Users  "
				. " ON FirmwareFiles.addedBy = Users.id ";

		$conn = getConnection();
		$result = @mysql_query($query, $conn);

		if(!$result)
			error("Unable to retrieve firmware file list! ");

		$numrows = mysql_numrows($result);

		$retVal = "<firmwareFiles>";

		$i = 0;

		while($i < $numrows)
		{	
			$config = mysql_fetch_assoc($result);
 			
			$retVal .= "<firmware>\n";

			foreach($config as $key=>$value)
			{			
				$tag = tag($key, $value);

				$retVal .= $tag;
			}

			$retVal .= "</firmware>";
			$i++;
		}
		$retVal .= "</firmwareFiles>";

		return $retVal;	
		
	}

	/**************************************************************
	* Upload a new firmware file
	*
	*/
	function uploadFirmware($name, $desc)
	{

		global $currentUserId;
		global $FIRMWAREFILES_LEN;

		$name = cleanTrimParam($name, $FIRMWAREFILES_LEN['name']);
		$desc = cleanTrimParam($desc, $FIRMWAREFILES_LEN['description']);


		if($_FILES['Filedata']['size'] <= 0)
		{
			error("Unable to upload file!");
		}
	
		$tmpName = $_FILES['Filedata']['tmp_name'];
		$fileName = $_FILES['Filedata']['name'];

		$fp = fopen($tmpName, 'r');
		
		$content = fread($fp, filesize($tmpName));
		fclose($fp);

		if(!get_magic_quotes_gpc())
			$fileName = addslashes($fileName);

		//$content = base64_encode($content);
		$content = cleanParam($content);

		$query = "INSERT INTO FirmwareFiles "
				. " (addedby, name, description, contents) "
				. " VALUES "
				. " ($currentUserId, '$name', '$desc', '$content')";

		sqlInsert($query);

		$error = mysql_error();

		if($error != "")
			error($error);
		else echo tag('result', 'success');
	}

	/********
	 * Update firmware description.
	 * File and it's name is not updated, only description may be updated
	 */
	function updateFirmware($id, $desc)
	{
		$desc = cleanTrimParam($desc, 100);

		$query = "UPDATE FirmwareFiles SET description='$desc' " .
				" WHERE id=$id";
		@sqlUpdate($query);

		$error = mysql_error();

		if ($error != "")
		{
			error($error);
		}
		else
		{
			echo tag('result', 'success');
		}
	}


	/**************************************************************
	* Remove a firmware file from the DB
	* Method perfectly fits to remove one and multiple items
	*/
	function removeFirmware($id)
	{

		// First let's update the device types that use this firmware file

		$query = "UPDATE DeviceTypes Set defaultFirmwareId = NULL "
				. " WHERE defaultFirmwareId IN ($id) ";

		@sqlUpdate($query);
		$error = mysql_error();

		if($error != "")
			error("Unable to remove firmware! " . $error);		

		$query = "DELETE From FirmwareFiles WHERE id IN ($id)";

		sqlUpdate($query);

		$error = mysql_error();

		if($error != "")
			error($error);

		return "success";
	}

}
?>
