<?php

include('lib/sql.php');

if(!function_exists('graphCollection_wrapper'))
{

	function graphCollection_wrapper() { }

	$COLORS = array(6731535, 14063670, 5137407, 15356725, 10329501, 8174335);
	
	function handleGraphCollectionAction($action)
	{
		if($action == null)
			error('Unauthorized');

		switch($action)
		{
			
			case 'get':
				global $currentUserId;
				echo getUsersGraphReports($currentUserId);
			break;

			case 'delete':
				echo deleteGraphCollection(req('id'));
			break;

			case 'add-graph':
				// add a new graph to a collection
				echo addGraphToGroup(req('graphGroupId'), req('statsDefId'), req('title'), req('autoScale'),
											req('showVerticalLabel'), req('verticalLabel'),
											req('axisType'),
											req('upper'), req('lower'), 
											req('hosts'), req('useDelta'), req('multiplier'));

			break;

			case 'modify-graph':
				// modify graph settings
				echo modifyGraph(req('graphId'), req('statsDefId'), req('title'), req('autoScale'),
											req('showVerticalLabel'), req('verticalLabel'),
											req('axisType'),
											req('upper'), req('lower'), 
											req('hosts'), req('useDelta'), req('multiplier'));

			break;

			case 'remove-graph':
				echo removeGraphFromGroup(req('graphId'));

			break;

			case 'bulk-add':
				echo bulkAddGraphs(req('graphGroupId'), req('stats'), req('hosts'));
			break;

			case 'create':
				echo createGraphCollection(req('name'));
			break;
			case 'order':
				echo reOrderGraphs(req('graphs'));
			break;
			case 'update':
				echo modifyGraphCollection(req('id'), req('name'));

			break;

		}

	}

	/***********************************************************************
	* Reorder graphs in a graph collection
	*
	*/
	function reOrderGraphs($graphs)
	{

		$graphs = base64_decode($graphs);
					
		$doc = new DOMDocument();
		$doc->loadXML($graphs);
		
		$list =$doc->getElementsByTagName('graph');

		foreach($list as $item)
		{
			$id = (int) ($item->getAttribute('id'));
			$index =   (int) ($item->getAttribute('index'));

			$query = "Update UserGraphs "
					. " SET displayIndex = $index "
					. " WHERE id = $id ";

			@sqlUpdate($query);
			sqlError("Unable to update graphs! ");

		}
	}

	/***********************************************************************
	* Get a list of graphs for the given group
	*
	*/
	function getGraphsInGroup($groupId)
	{
		$groupId = (int) $groupId;

		
		$query = "Select UserGraphs.id FROM UserGraphs "
					. " WHERE userGraphGroupId = $groupId "
					. " Order By displayIndex ";

		$conn = getConnection();
		$result = @mysql_query($query, $conn);
		sqlError("Unable to get user's graph reports! ");

		$numrows = mysql_numrows($result);

		$i = 0;

		$retVal = "";

		while($i < $numrows)
		{	
			$row = mysql_fetch_assoc($result);
 	
			$retVal .= "<graph id='" . $row['id'] . "' />\n";

			$i++;
		}

		return $retVal;
	}

	/***********************************************************************
	* Get a list of graph reports for the given user.
	*
	*/
	function getUsersGraphReports($userId)
	{
		$userId = (int) $userId;

		$retVal = "<graphGroups>";
		
		$query = "SELECT * FROM UserGraphGroup "
			. " WHERE userId = $userId ";

		$conn = getConnection();
		$result = @mysql_query($query, $conn);
		sqlError("Unable to get user's statistic reports! ");

		$numrows = mysql_numrows($result);

		$i = 0;

		while($i < $numrows)
		{	
			$row = mysql_fetch_assoc($result);
 			
			$groupId = (int) $row['id'];

			$retVal .= "<graphGroup id='$groupId'> ";

			$retVal .= tag('name', $row['name'], true);
			$retVal .= tag('id', $groupId);

			$retVal .= getGraphsInGroup($groupId);

			$retVal .= "</graphGroup>";

			$i++;
		}

		$retVal .= "</graphGroups>";

		return $retVal;
	
	}

	

	function removeGraphFromGroup($graphId)
	{

		$graphId= (int) $graphId;

		$query = "DELETE FROM UserGraphSeries "
				. " WHERE UserGraphSeries.userGraphId  = $graphId ";

		@sqlUpdate($query);
		sqlError("Unable to remove graph! ");

		$query = "DELETE FROM UserGraphs WHERE id = $graphId ";

		@sqlUpdate($query);
		sqlError("Unable to remove graph! ");

		return tag('result', 'success');


	}

	/********************************************************************8
	* Update this graph 
	* Using xml for the hosts data cause im lazy.
	*/
	function modifyGraph($graphId, $statsDefId, $title, $autoScale, 
									$showVertLabel, $vertLabel, $axisType,
									$upper, $lower,
									$hosts, $useDelta, $multiplier)
	{
		$graphId = (int)$graphId;
		$statsDefId = (int)$statsDefId;
		$upper = (double) $upper;
		$lower = (double) $lower;
		$multiplier = (double) $multiplier;
		$useDelta = (int) $useDelta;
		
		$vertLabel = cleanParam($vertLabel);
		$autoScale = (int)$autoScale;
		$showVertLabel = (int)$showVertLabel;
		$title = cleanParam($title);
		$axisType = cleanParam($axisType);
		
		$hosts = base64_decode($hosts);

		if($graphId <=0)
			error("Please select a graph.");

		/* Update graph in DB */
		$query = "UPDATE UserGraphs "
				. " SET  statsDefId=$statsDefId, "
				. " title ='$title', " 
				. " upper = $upper, " 
				. " lower = $lower, "
				. " verticalLabel = '$vertLabel', "
				. " showVerticalLabel = $showVertLabel, "
				. " verticalAxisType = '$axisType', "
				. " autoScale = $autoScale, "
				. " multiplier = $multiplier, "
				. " useDelta = $useDelta "
				. " WHERE id = $graphId ";

		$result = @sqlUpdate($query);
		sqlError("Unable to update graph! ");
		
		sqlUpdate("DELETE FROM UserGraphSeries WHERE userGraphId = $graphId");

		addDataSeries($graphId, $hosts);

		
	}

	function addDataSeries($graphId, $hosts)
	{
		/* Now create the series for this graph if hosts is XML */

			$hosts = "<?xml version=\"1.0\" encoding=\"utf-8\"?> " .$hosts;

			$doc = new DOMDocument();
			$doc->loadXML($hosts);
		
			$list =$doc->getElementsByTagName('host');
			foreach($list as $item)
			{
				$hostId = (int) ($item->getAttribute('id'));
				$enabled =  ($item->getAttribute('enabled'))== 'true' ? 1 : 0;
				$color = (int) ($item->getAttribute('color'));
				$graphType = cleanParam($item->getAttribute('graphType'));
		
				$query = "INSERT INTO UserGraphSeries "
						. " (userGraphId, hostId, color, graphType, enabled) "
						. " VALUES "
						. " ($graphId, $hostId, $color, '$graphType', $enabled) ";

				@sqlUpdate($query);
				sqlError("Unable to create graph! ");

			}
		
	}

	function modifyGraphCollection($id, $name)
	{

		$id = (int) $id;
	
		$query = "UPDATE UserGraphGroup "	
			. " SET name = '$name'  "
			. " WHERE id = $id ";

		@sqlUpdate($query);
		sqlError("Unable to alter report!");

		return tag('result', 'success');

	}


	/********************************************************************8
	* Bulk add graphs to a report.  
	* If the host doesn't listen for the given stats def then we won't add
	* it to the graph. 
	* The display paramters will be based off of the graph display template
	* for the stats def. If none is specified, then use default values.
	*/
	function bulkAddGraphs($groupId, $sstats, $shosts)
	{
		global $COLORS;

		$groupId= (int) $groupId;

		$stats = explode(',', $sstats);
		$hosts = explode(',', $shosts);
		
		foreach($stats as $statsId)
		{
			$statsId = (int)$statsId;

			if($statsId <= 0) continue;
			
			// 1. First get the graph template for the stats def.
			//    If doesn't exist use default values

			$row = getDisplayTemplate($statsId);
			
			if (!$row)
			{
				$color = $COLORS[0];
				$graphType = 'line';
				$showVertLabel = 0;
				$verticalAxisType = 'linear';
				$autoScale = 1;
				$multiplier = 1;
				$useDelta = 0;
				$upper = 0;
				$lower = 0;
				$title = getStatsDefName($statsId);
				$vertLabel = "";


			}
			else
			{
				$color =  $row['color'];
				$graphType = $row['graphType'];
				$showVertLabel = (int) $row['showVerticalLabel'] ;
				$verticalAxisType = $row['verticalAxisType'];			
				$autoScale = (int) $row['autoScale'] ;
				$multiplier = $row['multiplier'] ;
				$useDelta = (int) $row['useDelta'] ;
				$upper = $row['upper'] ;
				$lower = $row['lower'] ;
				$title = $row['title'];
				$vertLabel = $row['verticalLabel'];
				
				if ($title == '') {
					$title = getStatsDefName($statsId);
				}
			}		

			$hostData = getHostData($hosts, $statsId, $color, $graphType);
		
			if ($hostData)
			{
				addGraphToGroup($groupId, $statsId, $title, $autoScale, 
					$showVertLabel, $vertLabel, $verticalAxisType,
					$upper, $lower, $hostData, $useDelta, $multiplier, 0);
			}
		}


		echo tag('result', 'success');
				
	}

	function getStatsDefName($statsDefId)
	{
		return sqlString("SELECT name from StatsDef "
					. " WHERE id = $statsDefId", "name");

	}

	function getNextDefaultColor($i)
	{

		global $COLORS;

		if($i >= count($COLORS))
			return $COLORS[count($COLORS) -1 ];

		return $COLORS[$i];

	}


	/********************************************************
	* When adding graphs in bulk, use this function to get the
	* host display paramters in XML
	*
	*/
	function getHostData($hostIds, $statsDefId, $defaultColor, $graphType)
	{

		// If host doesn't listen for this stats def, DONT add it!

		$i = 0;
		$retVal = "";

		foreach($hostIds as $hostId)
		{

			// Don't let add more than 5 hosts to a graph.
			if($i >=5)
				break;

			$hostId = (int) $hostId;	
			if($hostId <=0) continue;

			if(!doesHostHaveStat($hostId, $statsDefId)) continue;

			$color = 0;

			if($i == 0)
				$color = $defaultColor;
			else 
				$color = getNextDefaultColor($i);
			
			$retVal .= "<host id='$hostId' enabled='true' color='$color' graphType='$graphType' />";
		
			$i++;

		}

		// Don't add this graph if we have no valid hosts.
		if($i ==0)
			return FALSE;

		return tag('hosts', $retVal);


	}

	function getDisplayTemplate($statsDefId)
	{
		$statsDefId = (int ) $statsDefId;

		$query = "SELECT GraphTemplate.* "
				. " From GraphTemplate, StatsDef  "
				. " WHERE StatsDef.id = $statsDefId "
				. " AND StatsDef.defaultGraphTemplateId = GraphTemplate.id ";

		$conn = getConnection();

		$row = sqlRow($query);

		if (!$row)
		{
			sqlError("Unable to get graph templates information! ");
			return FALSE;
		}

		return $row;
	}

	/********************************************************************8
	* Determine if this host listens for this stats def.
	*
	*/
	function doesHostHaveStat($hostId, $statsDefId)
	{	
		$id = sqlNumber("SELECT hostid from Host2Stats "
				. " WHERE hostid = $hostId AND statsid = $statsDefId", 
				"hostid"); 

		return ($id > 0);
	}

	/********************************************************************8
	* Add this graph to the group.
	* If $hostsIsArray ==0 then Using xml for the hosts data 
	*/
	function addGraphToGroup($groupId, $statsDefId, $title, $autoScale, 
									$showVertLabel, $vertLabel, $axisType,
									$upper, $lower,
									$hosts, $useDelta, $multiplier, $hostsIsEncoded=1)
	{
		$groupId = (int)$groupId;
		$statsDefId = (int)$statsDefId;
		$upper = (double) $upper;
		$lower = (double) $lower;
		$multiplier = (double) $multiplier;
		$useDelta = (int) $useDelta;

		$vertLabel = cleanParam($vertLabel);
		$autoScale = (int)$autoScale;
		$showVertLabel = (int)$showVertLabel;
		$title = cleanParam($title);
		$axisType = cleanParam($axisType);
		
		$index = getNextIndex($groupId);

		if($hostsIsEncoded)
		{
			$hosts = base64_decode($hosts);
		}

		if($groupId <=0)
			error("Please put this graph into a group.");

		/* Insert graph into DB */
		$query = "INSERT INTO UserGraphs "
				. " (userGraphGroupId, statsDefId, title, upper, lower, "
				. " verticalLabel, showVerticalLabel, verticalAxisType, "
				. " autoScale, useDelta, multiplier, displayIndex) "
				. " VALUES "
				. " ($groupId, $statsDefId, '$title', $upper, $lower, '$vertLabel', "
				. "  $showVertLabel, '$axisType', $autoScale, $useDelta, $multiplier, "
				. "  $index) ";

		$result = @sqlInsert($query);

	
		$graphId = (int)$result['id'];

		if($graphId <=0) error("Unable to insert graph!");

		addDataSeries($graphId, $hosts);

	}

	function getNextIndex($groupId)
	{
		$num = sqlNumber("SELECT MAX(displayIndex) as idx FROM UserGraphs "
					. " WHERE userGraphGroupId = $groupId", "idx");

		if($num == null)
			return 0;

		else return ($num + 1);
	}

	function createGraphCollection($name)
	{
		global $currentUserId;

		$query = "INSERT INTO UserGraphGroup "	
			. " (name, userid) "
			. " VALUES "
			. " ('$name', $currentUserId)";

		@sqlInsert($query);
		sqlError("Unable to create group!");

		return tag('result', 'success');

	}

	/***
	 * Remove graph collections
	 * Should fit for single and multiple items removing
	 * @param  $id
	 * @return string
	 */
	function deleteGraphCollection($id)
	{
		$query = "DELETE FROM UserGraphSeries "
				. " WHERE exists (SELECT id FROM UserGraphs "
				. "               WHERE userGraphGroupId IN ($id) "
				. " 					AND UserGraphs.id = UserGraphSeries.userGraphId ) ";

		@sqlUpdate($query);
		sqlError("Unable to remove report! ");

		$query = "DELETE FROM UserGraphs WHERE userGraphGroupId IN ($id)";

		@sqlUpdate($query);
		sqlError("Unable to remove report! ");

		$query = "DELETE FROM UserGraphGroup WHERE id IN ($id)";

		@sqlUpdate($query);
		sqlError("Unable to remove report! ");


		return tag('result', 'success');

	}

}

?>
