<?php

include('lib/sql.php');

if(!function_exists('graphTemplate_wrapper'))
{

	function graphTemplate_wrapper() {}

		
	function handleGraphTemplateAction($action)
	{
		if($action == null)
			error('Unauthorized');

		switch($action)
		{
			case 'create':
				echo createGraphTemplate(req('name'), req('title'), req('autoScale'),
											req('showVerticalLabel'), req('verticalLabel'),
											req('axisType'),
											req('upper'), req('lower'), 
											req('color'), req('graphType'), req('useDelta'), 
											req('multiplier'));

			break;

			case 'modify':
 				echo modifyGraphTemplate(req('id'), req('name'), req('title'), req('autoScale'),
											req('showVerticalLabel'), req('verticalLabel'),
											req('axisType'),
											req('upper'), req('lower'), 
											req('color'), req('graphType'), req('useDelta'), 
											req('multiplier'));

			break;

			case 'delete':
				echo deleteTemplate(req('id'));
			break;

			case 'get':
				echo getTemplates();
			break;

			 

		}
	}

	/*************************************************************
	* Create a new graph template in the DB.
	*
	*/
	function createGraphTemplate($name, $title, $autoScale, 
									$showVertLabel, $vertLabel, $axisType,
									$upper, $lower, $color, $graphType, $useDelta,
									$multiplier)
	{
		$upper = (double) $upper;
		$lower = (double) $lower;
		$multiplier = (double) $multiplier;
		$useDelta = (int) $useDelta;

		$vertLabel = cleanParam($vertLabel);
		$autoScale = (int)$autoScale;
		$showVertLabel = (int)$showVertLabel;
		$title = cleanParam($title);
		$name = cleanParam($name);
		$axisType = cleanParam($axisType);
		$graphType = cleanParam($graphType);
		$color = (int) $color;

		/* Insert graph into DB */
		$query = "INSERT INTO GraphTemplate "
				. " (name, title, upper, lower, "
				. " verticalLabel, showVerticalLabel, verticalAxisType, "
				. " autoScale, graphType, color, useDelta, multiplier) "
				. " VALUES "
				. " ('$name', '$title', $upper, $lower, '$vertLabel', "
				. "  $showVertLabel, '$axisType', $autoScale, '$graphType', $color, "
				. "  $useDelta, $multiplier) ";

		@sqlInsert($query);
		sqlError("Unable to create graph template! ");

		return tag('result', 'success');

	}


	/*************************************************************
	* Create a new graph template in the DB.
	*
	*/
	function modifyGraphTemplate($id, $name, $title, $autoScale, 
									$showVertLabel, $vertLabel, $axisType,
									$upper, $lower, $color, $graphType,
									$useDelta, $multiplier)
	{
		$id = (int) $id;

		$upper = (double) $upper;
		$lower = (double) $lower;
		$useDelta = (int) $useDelta;
		$multiplier = (double) $multiplier;
		
		$vertLabel = cleanParam($vertLabel);
		$autoScale = (int)$autoScale;
		$showVertLabel = (int)$showVertLabel;
		$title = cleanParam($title);
		$name = cleanParam($name);
		$axisType = cleanParam($axisType);
		$graphType = cleanParam($graphType);
		$color = (int) $color;

		$query = "UPDATE GraphTemplate "
				. " SET  name='$name', "
				. " title ='$title', " 
				. " upper = $upper, " 
				. " lower = $lower, "
				. " verticalLabel = '$vertLabel', "
				. " showVerticalLabel = $showVertLabel, "
				. " verticalAxisType = '$axisType', "
				. " autoScale = $autoScale, "
				. " color = $color, "
				. " graphType = '$graphType', "
				. " multiplier = $multiplier, "
				. " useDelta = $useDelta "
				. " WHERE id = $id ";


		@sqlUpdate($query);
		sqlError("Unable to create graph template! ");

		return tag('result', 'success');

	}

	function deleteTemplate($id)
	{

		$id = (int) $id;

		$query = "UPDATE StatsDef SET defaultGraphTemplateId = NULL "
					. " WHERE defaultGraphTemplateId = $id ";

		sqlUpdate($query);
		sqlError("Unable to delete graph template! ");

		$query = "DELETE FROM GraphTemplate WHERE id = $id";

		sqlUpdate($query);
		sqlError("Unable to delete graph template! ");
	}

	function getTemplates()
	{
		$query = "SELECT * From GraphTemplate ";

		$conn = getConnection();
		$result = @mysql_query($query, $conn);
		sqlError("Unable to get graph templates! ");

		$numrows = mysql_numrows($result);

		$i = 0;

		$retVal = "";
		while($i < $numrows)
		{	
			$row = mysql_fetch_assoc($result);

			$attr = " id='" . $row['id'] . "' "
					. " color='" . $row['color'] . "' "
					. " graphType='" . $row['graphType'] . "' "
					. " showVerticalLabel='" . ($row['showVerticalLabel']  > 0 ? 'true' : 'false'). "' "
					. " verticalAxisType='" . $row['verticalAxisType'] . "' "
					. " autoScale='" . ($row['autoScale'] > 0? 'true' : 'false'). "' "
					. " useDelta='" . ($row['useDelta'] > 0? 'true' : 'false'). "' "
					. " multiplier='" .$row['multiplier']  . "' "
					. " upper='" . $row['upper']	. "' "
					. " lower='" . $row['lower'] . "' ";

			$tags = tag('name', $row['name'], true);
			$tags .= tag('title', $row['title'], true);
			$tags .= tag('verticalLabel', $row['verticalLabel'], true);
			$tags .= tag('createdOn', $row['createdOn']);
 
			$retVal .= tag('graphTemplate', $tags, FALSE, $attr);


			$i++;
		}

		
		return tag('graphTemplates', $retVal);	
	}

}


?>
