<?php

include('lib/sql.php');
include('lib/user.php');
include('lib/alarm-profile.php');
include('lib/stats-profile.php');
include('lib/manage-alarm.php');

if(!function_exists('host_wrapper'))
{

	/* Lengths of DB fields in the Hosts table */
	$HOSTS_LEN = array(
				'name' 			=> 50);


	function host_wrapper() { }

	function handleHostsAction($action)
	{
		if($action == null)
			error('Unauthorized');

		switch($action)
		{
			case 'create':
				
			break;
				
			case 'delete':
				echo deleteHosts(req('hosts'));

			;
			break;

			case 'modify':

				echo modifyHost(req('hostid'), req('name'), req('networkid'), req('lat'),
							req('lon'), req('heightAGL'), req('hbinterval'), req('alarmProfileId'), 
							req('statsProfileId'), req('deviceTypeId'), req('registered'),
							req('map'), req('topo'));
			break;
		
			case 'qsearch':
				echo getHosts(false);
			break;
			case 'search':				
				echo getHosts(true);
			break;

			case 'csv':
				echo getHosts(req('isQuickSearch') == 0, 'csv');
			break;

			case 'alarmSearch':
			echo searchAlarmHistory(req('hostid'), req('status'),req('dateStart'), 
						req('dateEnd' ), req('alarmDefId'), 
						req('severities'), req('pageNumber'), req('pageSize'), req('hideInactive'),
						req('sortField'), req('sortDirection'));			
			break;
			case 'taskSearch':
			echo searchTaskHistory(req('hostid'), req('dateStart'), 
						req('dateEnd' ), req('pageNumber'), req('pageSize'),
						req('sortField'), req('sortDirection'));			
			break;
			case 'details':

			$hostId = (int) req('hostid');
			$alarms = (int) req('alarms');

			$retVal = "<result>\n"
					. getHostDetails($hostId)
					//. ($alarms > 0?  getHostAlarms($hostId) : "")
					. "</result>";
			echo $retVal;
			break;

			case 'maxHB':

			echo tag('result', tag('max', getMaxHB(req('hosts'))));
				
			break;

			case 'autoComplete':

			echo tag('result', getAutoCompleteByName(req('str')));
			break;

		}

	}

	/**************************************************************
	* Retreive details for a single host. (display in host details popup)
	*	
	*/
	function getHostDetails($hostId)
	{
		global $currentUserId;

		$hostId = (int) $hostId;

		// 1. Get host info.
		// 2. Get current alarms for the host	
	
		if(!canAccessHost($currentUserId, $hostId))
		{
			error("Unathorized access to device.");
			return;
		}

		$query = " SELECT Hosts.id, Hosts.name as friendly, Hosts.location, Hosts.lastContact, Networks.name as network, "
				.  " Networks.id as networkId, Hosts.mac,  Hosts.serialno as serial, "
				.  " IFNULL(Hosts.longitude_local, Hosts.longitude) AS longitude, "
				.  " IFNULL(Hosts.latitude_local, Hosts.latitude) AS latitude, "
				.  " IFNULL(Hosts.height_agl_local, Hosts.height_agl) AS heightAGL, "
				.  " Hosts.firmware, Hosts.registered, "
				.  " Hosts.hbinterval , Hosts.topology, Hosts.map, "

				.  " CASE WHEN Hosts.isdown > 0 THEN 'Down' Else 'Up' END As availability, "

				// Number of critical alerts
				.  "   CASE WHEN EXISTS  (SELECT Alarms.* "
				.  "      FROM AlarmProfile2AlarmDef, Alarms "
				. 	" 		Left Join ActiveAlarm ON Alarms.id  = ActiveAlarm.alarm_id "
				.  "     WHERE  "
				.  "     Alarms.cleared = 0 "
				. 	"		AND (ActiveAlarm.alarm_id is not null) "
				.  "   	AND Alarms.hostId = Hosts.id "
				.  "   	AND Alarms.alarmId = AlarmProfile2AlarmDef.alarmId "
				.  " 		AND AlarmProfile2AlarmDef.alarmProfileId = Hosts.alarmProfileId "
				.  "   	AND AlarmProfile2AlarmDef.severity = 'critical' "
				. 	"     ) THEN 1 ELSE 0 END as criticalAlerts, "

				// Number of warning alerts
				.  "   CASE WHEN EXISTS  (SELECT Alarms.* "
				.  "      FROM AlarmProfile2AlarmDef, Alarms  "
				. 	" 		Left Join ActiveAlarm ON Alarms.id  = ActiveAlarm.alarm_id "
				.  "     WHERE  "
				.  "     Alarms.cleared = 0 "
				. 	"		AND (ActiveAlarm.alarm_id is not null) "
				.  "   	AND Alarms.hostId = Hosts.id "
				.  "   	AND Alarms.alarmId = AlarmProfile2AlarmDef.alarmId "
				.  " 		AND AlarmProfile2AlarmDef.alarmProfileId = Hosts.alarmProfileId "
				.  "   	AND AlarmProfile2AlarmDef.severity = 'warning' "
				. 	"     ) THEN 1 ELSE 0 END as warningAlerts, "

				.  "   CASE WHEN EXISTS  (SELECT Alarms.* "
				.  "      FROM AlarmProfile2AlarmDef, Alarms  "
				.  "     WHERE  "
				.  "     Alarms.cleared = 0 "
				.  "   	AND Alarms.hostId = Hosts.id "
				.  "   	AND Alarms.alarmId = AlarmProfile2AlarmDef.alarmId "
				.  " 		AND AlarmProfile2AlarmDef.alarmProfileId = Hosts.alarmProfileId "
				.  "   	AND (AlarmProfile2AlarmDef.severity = 'warning' OR AlarmProfile2AlarmDef.severity = 'critical') "
				. 	"     ) THEN 1 ELSE 0 END as hasUnclearedAlerts, "


				// Check to see if we have some uncleared alerts that aren't all 'info'.  (if no open critical or warning, show this as blue)
				//. 	" CASE WHEN EXISTS (Select Alarms.* FROM Alarms WHERE Alarms.cleared = 0  "
				//. 	"	AND Alarms.hostId = Hosts.id) THEN 1 ELSE 0 END AS hasUnclearedAlerts, "

				.  " INET_NTOA(Hosts.ipaddr) as ip, " 
				.  " Hosts.alarmProfileId, Hosts.statsProfileId, Hosts.deviceTypeId, "
				.  " Hosts.isdown, "
				
				// The host state section 

				.  " HostState.uptime, "
				.  " HostState.frequency, "
				.  " IF(HostState.channelWidthAboveBelow IS NULL, channelWidth, CONCAT('20.000/', channelWidth, channelWidthAboveBelow)) AS channelWidth, "
				.  " HostState.dataRate, "
				.  " HostState.transmitPower, "
				.  " HostState.wirelessStatus, "
				.  " HostState.ethernetStatus, "
				.  " HostState.ethernetSpeed, "
				.  " HostState.ethernetFullDuplex, "
				.  " HostState.encryptionEnabled, "
				.  " CONCAT_WS('/', HostState.signalLevel0, HostState.signalLevel1, HostState.signalLevel2) AS signalLevel, "
				.  " INET_NTOA(remoteIPAddress) AS remoteIPAddress, "
				.  " CONCAT_WS('/',  HostState.remoteSignalLevel0, HostState.remoteSignalLevel1, HostState.remoteSignalLevel2) AS remoteSignalLevel, "
				.  " HostState.remoteTransmitPower "
      
         // End of (dummy) host state section
         
				.  " FROM Hosts "
				.  " LEFT JOIN Networks ON Hosts.networkId = Networks.id "
				.  " LEFT JOIN HostState ON HostState.hostId = Hosts.id "
				.  " WHERE Hosts.id = $hostId ";

		 
		$retVal = "<details>";

		$host = @sqlRow($query);
			
		if(!$host)
			error("Unable to retrieve host details: " . mysql_error());

		foreach($host as $key=>$value)
		{
			if($key == 'warningAlerts' || $key == 'criticalAlerts')
				continue;

			$detailTag = tag($key, $value);
			
			$retVal = $retVal . $detailTag;
		}

		$retVal .= tag('severity', getSeverity($host));

		$retVal .= "</details>";

		return $retVal;
	}

	/**************************************************************
	* Translate the client's sort by field to actual DB values
	*
	**************************************************************/
	function getSortByField($name)
	{

		$name = strtolower($name);

		switch($name)
		{
			case "name" : return "Hosts.name"; 
			case "network": return "Networks.name";
			case "mac": return "Hosts.mac";
			case "ip": return "INET_NTOA(Hosts.ipaddr)";
			case "serial": return "Hosts.serialno";
			case "availability": return "Hosts.isdown";
			case "status": return "Hosts.registered"	;	
			case "firmware": return "Hosts.firmware"	;	

		}

		return "";
			
	}

	/**************************************************************
	* Translate the client's sort by field to actual DB values
	*
	**************************************************************/	
	function getSortByField_alarmHistory($name)
	{

		$name = strtolower($name);

		switch($name)
		{
			case "name" : return "AlarmDef.name"; 
			case "desc" : return "AlarmDef.desc"; 
			case "severity": return "AlarmProfile2AlarmDef.severity";
			case "time": return "Alarms.time";
			case "msg": return "Alarms.msg";
			case "cleareddisplay": return "Alarms.cleared";
			case "status": return "Alarms.status";

		}

		return "";
			
	}

	/**************************************************************
	* Translate the client's sort by field to actual DB values
	*
	**************************************************************/	
	function getSortByField_taskHistory($name)
	{

		$name = strtolower($name);

		switch($name)
		{
			case "name" : return "Task.name"; 
			case "type" : return "Task.type"; 
			case "createdby": return "Users.username";
			case "executedate": return "Host2Task.dateExecute";
			case "cleareddisplay": return "Task.cleared";
			case "datecompleted": return "Host2Task.datecompleted";

		}

		return "";
			
	}

	/**************************************************************
	* Get a host's current alarms 
	*	
	*/
	function getHostAlarms($hostId)
	{

		$query =  " SELECT Alarms.msg, Alarms.time, AlarmDef.name,  "
					. " 		 AlarmDef.desc, Alarms.id, AlarmProfile2AlarmDef.severity "
					. " FROM  Alarms, AlarmDefinition as AlarmDef, AlarmProfile2AlarmDef, "
					. "       AlarmProfiles, Hosts "
					. " WHERE "
					. " Alarms.hostid = $hostId "
					. " AND Alarms.alarmid = AlarmDef.id "
					. " AND Alarms.cleared = 0 "
					. " AND AlarmProfile2AlarmDef.alarmId = AlarmDef.id "
					. " AND Hosts.alarmProfileId = AlarmProfile2AlarmDef.alarmProfileId "
					. " AND Hosts.id = $hostId "
					. " Order By Alarms.time DESC ";

	
		$conn = getConnection();

		$result = @mysql_query($query, $conn);

		if(!$result)
		{
			error("Unable to retrieve host's alarm list! ". mysql_error());
			return;
		}
		$numrows = mysql_numrows($result);

		$retVal = "";

		$i = 0;

		while($i < $numrows)
		{	
			$alarm = mysql_fetch_assoc($result);
 			
			$retVal .= "<alarm>\n";
			foreach($alarm as $key=>$value)
			{			
				$val = $value;

				if($key == 'name')
				{
					$val = getStdAlarmDefDisplayName($value);
				}

				$retVal .= tag($key, $val);

			}

			$retVal .= "</alarm>";
			$i++;
		}
		return tag('alarms', $retVal);

	}

	/**************************************************************
	* Get alarm history for a host.
	*	$status: Either 'cleared', 'uncleared', or 'both'
	*  $severities: String of 'critical|warning|info', etc...
	*		
	*/
	function searchAlarmHistory($hostId, $status, $dateStart, $dateEnd, 
										$alarmDefId, $s_severities, $pageNumber,
										$pageSize, $hideInactive, $sortField,
										$sortDirection)
	{

		$status 	= cleanParam($status);
		$dateStart 	= cleanParam($dateStart);
		$dateEnd 	= cleanParam($dateEnd);
		$s_severities 	= cleanParam($s_severities);
		$sortField 	= cleanParam($sortField);
		$sortDirection 	= cleanParam($sortDirection);

		$hostId 	= (int)$hostId;
		$alarmDefId 	= (int)$alarmDefId;
		$pageSize = (int) $pageSize;
		$pageNumber = (int) $pageNumber;
		$hideInactive = (int) $hideInactive;
	
		$page = ($pageNumber - 1) * $pageSize;

		if(strlen($status) <=0) $status = 'both';
		if(strlen($s_severities) <=0) $s_severities = 'critical|warning|info';
		
		$severities = explode('|', $s_severities);

		$severityQuery = "";

		foreach($severities as $severity)
			{
				if(strlen($severity) < 2)
					continue;

				if(strlen($severityQuery) > 0)
					$severityQuery .= " OR ";

				$severityQuery .= " AlarmProfile2AlarmDef.severity = '" . $severity . "' ";
			
			}

		$recordCountQuery = " SELECT Count(Alarms.id) as Total ";

		/* IF CHANGE ANY FIELD NAMES BELOW MAKE SURE TO CHANGE THE SORT BY FIELD FUNCTIONS */
		$query = "SELECT Alarms.msg, Alarms.status, Alarms.time, Alarms.status, AlarmDef.name, Alarms.cleared, "
					. " CASE WHEN Alarms.cleared > 0 THEN 'Yes' ELSE 'No' END as clearedDisplay, "
					. " AlarmDef.desc, Alarms.id, AlarmProfile2AlarmDef.severity  ";

		$mainquery =
					 " FROM AlarmDefinition as AlarmDef, "
					. " AlarmProfile2AlarmDef, Hosts, Alarms "
					. ($hideInactive ? "Left Join ActiveAlarm ON ActiveAlarm.alarm_id = Alarms.id " : "")
					. " WHERE 1 "
					. ($hideInactive ?  " AND (ActiveAlarm.alarm_id is not null OR Alarms.status like 'inactive') " : "")
					. ($status == 'uncleared' 		? " AND Alarms.cleared = 0 " : "") 
					. ($status == 'cleared'   		? " AND Alarms.cleared = 1 " : "")
					. (strlen($severityQuery) >0  ? " AND ($severityQuery) " : "")
					. ($dateEnd != ""?  " AND Alarms.time <= '$dateEnd' " : "")
					. ($dateStart != ""? " AND Alarms.time >= '$dateStart' " : "")
					. " AND Alarms.hostId = Hosts.id "
					. " AND Alarms.alarmId = AlarmDef.id "
					. " AND AlarmProfile2AlarmDef.alarmId = AlarmDef.id "
					. " AND AlarmProfile2AlarmDef.alarmProfileId = Hosts.alarmProfileId "
					. " AND Hosts.id = $hostId ";

		if($sortField  == ''){
			$sortField = "Alarms.time";
			$sortDirection = "DESC";
		}
		else{
			$sortField = getSortByField_alarmHistory($sortField);			
		}

		$recordCountQuery .= $mainquery;
		$query .= $mainquery;
		$query .= " Order By $sortField $sortDirection LIMIT $page, $pageSize ";

		$conn = @getConnection();

		$result = @mysql_query($query, $conn);

		if(!$result)
		{
			error("Unable to retrieve host's alarm history list! ". mysql_error());
			return;
		}
		$numrows = mysql_numrows($result);

		$retVal = "";

		$i = 0;

		while($i < $numrows)
		{	
			$alarm = mysql_fetch_assoc($result);
 			
			$retVal .= "<alarm>\n";

			foreach($alarm as $key=>$value)
			{			
				$val = $value;

				if($key == 'name')
				{
					$val = getStdAlarmDefDisplayName($value);
				}

				$alarmTag = tag($key, $val);

				$retVal .= $alarmTag;
			}

			$retVal .= "</alarm>";
			$i++;
		}

		$totalRecords = @sqlNumber($recordCountQuery, "Total");

		return tag('result',  tag('alarms', $retVal). tag('totalCount', $totalRecords));

	}

	/**************************************************************
	* Get task history for a host.
	* This will go through the end date.	
	*/
	function searchTaskHistory($hostId,  $dateStart, $dateEnd, 
										  	$pageNumber, $pageSize, 
											$sortField, $sortDirection)
	{

		global $currentUserId;

		$dateStart 	= cleanParam($dateStart);
		$dateEnd 	= cleanParam($dateEnd);
		$hostId 	= (int)$hostId;
		$pageSize = (int) $pageSize;
		$pageNumber = (int) $pageNumber;
	
		$page = ($pageNumber - 1) * $pageSize;
	
		$isNetworkUser = isUserNetworkUser($currentUserId);
		
		$networkFilter = "";

		if($isNetworkUser)
		{
			$networkFilter = " AND (0 ";
			$allowedNetworkIds = getAllowableNetworkIds($currentUserId);

			foreach ($allowedNetworkIds as $networkId)
			{
				$networkId = (int) $networkId;			

				$networkFilter .= " OR Hosts.networkId = $networkId ";

			}
			$networkFilter .= ")";
		}

		$recordCountQuery = " SELECT Count(Task.id) as Total ";

		$query = "SELECT Task.type, Task.name, Task.id as taskId, Hosts.id as hostId, "
					. " Users.username as createdBy, "
					. " CASE WHEN Task.cleared >0 THEN 'Yes' ELSE 'No' END as clearedDisplay, "
					. "  Task.createdOn, Host2Task.dateExecute as executeDate, "
					. "  Host2Task.status, Host2Task.dateCompleted, "
					. " Host2Task.message , "
				   . " CfgBackup.cfg is not null AS hasConfig, "
				   . " Hosts.license is not null as hasLicense, "
				   . " TroubleshootFile.data is not null as hasTroubleFile ";
				

		$mainquery =
					 " FROM  Users, Hosts , Host2Task"
 					. " Left Join Task  "
					. " ON Host2Task.idtask = Task.id "
 					. " Left Join CfgBackup  "
				 	. " On CfgBackup.hostid  = Host2Task.idhost  "
				 	. " AND CfgBackup.taskid = Host2Task.idtask "
					. " Left Join TroubleshootFile "
					. " On TroubleshootFile.taskid = Host2Task.idtask "
					. " AND TroubleshootFile.hostid = Host2Task.idhost "					
					. " WHERE Host2Task.idhost = $hostId  "			
					. " AND Task.createdBy = Users.id  "		
					. " AND Hosts.id = $hostId  "
					. ($dateEnd != ""?  " AND Host2Task.dateExecute <= '$dateEnd' " : "")
					. ($dateStart != ""? " AND Host2Task.dateExecute >= '$dateStart' " : "")					
					. ($isNetworkUser ? " HAVING (SELECT Count(Host2Task.idhost) FROM Host2Task  "
												. " WHERE Host2Task.idtask = Task.id) " 
												. " =  "
												. " (SELECT Count(Host2Task.idhost) FROM Host2Task, Hosts  "
												. " WHERE Host2Task.idTask = Task.id AND Host2Task.idHost = $hostId  "
												. " AND Hosts.id = Host2Task.idhost   $networkFilter )" : "");

		$recordCountQuery .= $mainquery;
		$query .= $mainquery;

		if($sortField == '')
		{
			$sortField = "Task.createdOn";
			$sortDirection = "DESC";

		}else

		{
			$sortField = getSortByField_taskHistory($sortField);

		}

		$query .= " Order By $sortField $sortDirection ";
		$query .= " LIMIT $page, $pageSize ";

		$conn = @getConnection();

		$result = @mysql_query($query, $conn);

		if(!$result)
		{
			error("Unable to retrieve host's task history list! ". mysql_error());
			return;
		}
		$numrows = mysql_numrows($result);

		$retVal = "";

		$i = 0;

		$remove = 0;
		while($i < $numrows)
		{	
		
			$task = mysql_fetch_assoc($result);
 		
			

			$retVal .= "<task>\n";

			foreach($task as $key=>$value)
			{			
				$tag = tag($key, $value);

				$retVal .= $tag;
			}

			$retVal .= "</task>";
			$i++;
		}

		$totalRecords = @sqlNumber($recordCountQuery, "Total");
		$totalRecords += -1* $remove;

		return tag('result',  tag('tasks', $retVal). tag('totalCount', $totalRecords));

	}
	/**************************************************************
	* Update a host's configurable details.
	*
	*/
	function modifyHost( $hostId, $name, $networkId, $lat, $lon, $hgt, $hbinterval,
								$alarmProfileId, $statsProfileId, $deviceTypeId, 
								$registered, $showOnMap, $showOnTopo)
	{
		global $currentUserId;
		global $HOSTS_LEN;

		$hostId    = (int) $hostId;
		$latitude  = $lat != "" ? "'" . (double) $lat . "'" : "NULL";
		$longitude = $lon != "" ? "'" . (double) $lon . "'" : "NULL";
		$height    = $hgt != "" ? "'" . (double) $hgt . "'" : "NULL";

		$hbinterval = (int) $hbinterval;
		$registered = (int) $registered;
		$deviceTypeId = (int) $deviceTypeId;
		$alarmProfileId = (int) $alarmProfileId;
		$statsProfileId = (int) $statsProfileId;
		$networkId = (int) $networkId;

		$showOnMap = (int) $showOnMap;
		$showOnTopo = (int) $showOnTopo;

		$name = cleanTrimParam($name, $HOSTS_LEN['name']);

		$row = sqlRow("SELECT statsProfileId, alarmProfileId FROM Hosts "
				. " WHERE id = $hostId ");

		$oldStatsProfileId = (int)$row['statsProfileId'];
		$oldAlarmProfileId = (int)$row['alarmProfileId'];


		if(!canAccessHost($currentUserId, $hostId))
		{
			error("Unathorized access to device.");
			return;
		}

		$query = " UPDATE Hosts "
				.  " SET "
				.  " height_agl_local  = $height, "
				.  " latitude_local    = $latitude, "
				.  " longitude_local   = $longitude, "
				.  " registered =  $registered, "
				.  " effectiveHBInterval = IFNULL(effectiveHbInterval, NULLIF(hbInterval, $hbinterval)), "
				.  " hbInterval =  $hbinterval, "
				.  " networkid  =  $networkId, "
				.  " deviceTypeId =   " . ($deviceTypeId > 0    ? " $deviceTypeId,   " : " null, ")
				.  " alarmProfileId = " . ($alarmProfileId > 0  ? " $alarmProfileId, " : " null, ")
				.  " statsProfileId = " . ($statsProfileId > 0  ? " $statsProfileId, " : " null, ")
				.  " topology = $showOnTopo, "
				.  " map = $showOnMap , "
				.  " name = '$name' "
				.  " WHERE Hosts.id = $hostId ";


		sqlUpdate($query);

		$error = mysql_error();

		if($error != "")
			error($error);

		/* If we've changed profiles, let's delete any entries in 
		* Host2Alarms and Host2Stats before we continue.
		*/

		if($oldAlarmProfileId != $alarmProfileId)
			removeAlarmProfileFromHost($hostId);

		if($oldStatsProfileId != $statsProfileId)
			removeStatsProfileFromHost($hostId);


		applyAlarmDefProfile($alarmProfileId, $hostId);
		applyStatsDefProfile($statsProfileId, $hostId);

		return tag('result', 'success');

	}

	/**************************************************************
	* This cleans params and stuff before performing the real search.
	*
	*/
	function getHosts($isAdvanced, $format='xml')
	{

		global $currentUserId;

		/* initialize search parameter array */
		$query = array();
	
		$snetworkIds = cleanParam(req('networkIds'));
		$sstatDefIds = cleanParam(req('statDefIds'));


		$networkIds = array();
		if(strlen($snetworkIds) >= 1)
			$networkIds = explode("|", $snetworkIds);
		else if(!$isAdvanced){
			$networkIds = getAllowableNetworkIds($currentUserId);
			
		}

		if(strlen($sstatDefIds) >= 1)
			$statDefIds = explode(",", $sstatDefIds);
		else 
			$statDefIds = array();
		
		$query['networkids'] = $networkIds;

		$query['quick'] 	= !$isAdvanced;

		
		$query['sortField'] = cleanParam(req('sortField'));
		$query['sortDirection'] = cleanParam(req('sortDirection'));
		$query['mac'] 	= cleanParam(req('mac'));
		$query['ip'] 	= cleanParam(req('ip'));
		$query['name'] 	= cleanParam(req('name'));
		$query['firmware'] = cleanParam(req('fw'));
		$query['serial']   = cleanParam(req('sn'));
		$query['status']   = cleanParam(req('status'));
		$query['avail']    = cleanParam(req('avail'));
		$query['deviceId']   = (int) req('deviceId');
		$query['searchNoNet']= false;
		$query['statDefIds'] = $statDefIds;
		$query['location'] = cleanParam(req('location'));

		$pageNumber = (int) req('pageNumber');
		$pageSize   = (int) req('pageSize');


		if($format == 'xml')
		{
		$retVal = '<result>'
		. hostsSearch($pageNumber, $pageSize, $query)
		. '</result>';
		}
		else
		{
		$retVal = hostsSearch($pageNumber, $pageSize, $query, 'csv');
		}
		return $retVal;
	}

	/**************************************************************
	* Get a list of hosts to display in the inventory search list.
	* ASSUMING EVERYTHING HAS BEEN CLEANED AT THIS POINT!!! 
	*/
	function hostsSearch($pageNumber, $pageSize, $query, $format='xml')
	{
		global $currentUserId;

		/* PARAMETERS */
		$quick		= $query['quick'];
		$networkids = $query['networkids'];
		$mac 		= $query['mac'];		/* Allow seperate 'OR' entries seperated by commas */
		$ip		= $query['ip'];			/* Allow seperate 'OR' entries seperated by commas */
		$name		= $query['name'];		/* Allow seperate 'OR' entries seperated by commas */
		$location	= $query['location'];
		$firmware	= $query['firmware'];		/* Allow seperate 'OR' entries seperated by commas */
		$serial   	= $query['serial'];		/* Allow seperate 'OR' entries seperated by commas */
		$status		= $query['status'];		/* Options are registered, unregistered, and both */
		$avail		= $query['avail'];		/* Options are up, down, and both   */
		$deviceId	= $query['deviceId'];   	/* One id or none                   */
		$statDefIds	= $query['statDefIds'];  	/* Empty to not filter by stats def */
		$sortField 	= $query['sortField'];  	/* Field to sort by */
		$sortDirection 	= $query['sortDirection'];  	/* Field to sort by */

		$xml = $format == 'xml';

		if(is_array($networkids) && isUserNetworkUser($currentUserId))
		{
			/* make sure that this user is allowed to see hosts in
			 the given lists of networks.
			*/

			$allowedNetworkIds = getAllowableNetworkIds($currentUserId);

			foreach ($networkids as $networkId)
			{
				$networkId = (int) $networkId;
			

				if($networkId > 0 && !in_array($networkId, $allowedNetworkIds))
				{	
					error("Unauthorized access to network.");
					return;
				}
			}
		}

		$search = array();

		$search['includeMAC'] = (strlen($mac) > 0);
		$search['includeIP']  = (strlen($ip) > 0);
		$search['includeName']= (strlen($name) > 0);
		$search['includeLocation'] = (strlen($location) > 0);
		$search['includeSN']  = (strlen($serial) > 0);
		$search['includeFW']  = (strlen($firmware) > 0);

		$search['includeNetwork'] = false;

		$search['searchNoNet']  = false;


		$networkIdsQuery = "";

		if(is_array($networkids) && count($networkids) > 0)
		{
		
			$search['includeNetwork'] = true;
				
			foreach($networkids as $networkid)
			{

				if(strlen($networkid) == 0)
					continue;
			
				$networkid =(int)$networkid;
		
				if($networkid == 0)
				{			
					
					$search['searchNoNet']  = true;
					continue;
				}

				if($networkid <0)
					continue;

				if(strlen($networkIdsQuery) > 0)
					$networkIdsQuery .= " OR ";

				$networkIdsQuery .= " Networks.id = " . $networkid . " ";
			
			}
		}	
		else 
		{  
			$search['includeNetwork']  = true;
			$search['searchNoNet']  = true;
		}


		
		/* If search devices with no network, specify below */

		if($search['searchNoNet'])
		{

			if(strlen($networkIdsQuery) > 0)
					$networkIdsQuery .= " OR ";

				$networkIdsQuery .= " Networks.id = 0 OR Networks.id is null ";

		}

	
		/* There will be two queries - one to get the number of records in the search query, and 
		*  one to get the records (limited by page number)
		*/

		/* Whether or not we need to include stat defs in this search 
		 * This is used when searching for devices/stats to show on a graph */
		$includeStats =  ((is_array($statDefIds) && count($statDefIds) > 0) ? 1 : 0);


		$page = ($pageNumber - 1) * $pageSize;
	

		$recordCountQuery = 
					" SELECT "
				. 	" COUNT(Hosts.id) as total "
				.  " FROM Hosts LEFT JOIN Networks "
				.  " ON "
				.  " Hosts.networkId =  Networks.id "
				.  ($includeStats? " LEFT JOIN Host2Stats ON Hosts.id = Host2Stats.hostid "
				.                  " LEFT JOIN StatsDef ON StatsDef.id = Host2Stats.statsid " : "")		
				.  " WHERE 1  ";

		$query = " SELECT "

				// Number of critical alerts
				.  "   CASE WHEN EXISTS  (SELECT Alarms.* "
				.  "      FROM AlarmProfile2AlarmDef, Alarms "
				. 	" 		Left Join ActiveAlarm ON Alarms.id  = ActiveAlarm.alarm_id "
				.  "     WHERE  "
				.  "     Alarms.cleared = 0 "
				. 	"		AND (ActiveAlarm.alarm_id is not null) "
				.  "   	AND Alarms.hostId = Hosts.id "
				.  "   	AND Alarms.alarmId = AlarmProfile2AlarmDef.alarmId "
				.  " 		AND AlarmProfile2AlarmDef.alarmProfileId = Hosts.alarmProfileId "
				.  "   	AND AlarmProfile2AlarmDef.severity = 'critical' "
				. 	"     ) THEN 1 ELSE 0 END as criticalAlerts, "

				// Number of warning alerts
				.  "   CASE WHEN EXISTS  (SELECT Alarms.* "
				.  "      FROM AlarmProfile2AlarmDef, Alarms  "
				. 	" 		Left Join ActiveAlarm ON Alarms.id  = ActiveAlarm.alarm_id "
				.  "     WHERE  "
				.  "     Alarms.cleared = 0 "
				. 	"		AND (ActiveAlarm.alarm_id is not null) "
				.  "   	AND Alarms.hostId = Hosts.id "
				.  "   	AND Alarms.alarmId = AlarmProfile2AlarmDef.alarmId "
				.  " 		AND AlarmProfile2AlarmDef.alarmProfileId = Hosts.alarmProfileId "
				.  "   	AND AlarmProfile2AlarmDef.severity = 'warning' "
				. 	"     ) THEN 1 ELSE 0 END as warningAlerts, "


				.  "   CASE WHEN EXISTS  (SELECT Alarms.* "
				.  "      FROM AlarmProfile2AlarmDef, Alarms  "
				.  "     WHERE  "
				.  "     Alarms.cleared = 0 "
				.  "   	AND Alarms.hostId = Hosts.id "
				.  "   	AND Alarms.alarmId = AlarmProfile2AlarmDef.alarmId "
				.  " 		AND AlarmProfile2AlarmDef.alarmProfileId = Hosts.alarmProfileId "
				.  "   	AND (AlarmProfile2AlarmDef.severity = 'warning' OR AlarmProfile2AlarmDef.severity = 'critical') "
				. 	"     ) THEN 1 ELSE 0 END as hasUnclearedAlerts, "

				// Check to see if we have some uncleared alerts.  (if no open critical or warning, show this as blue)
				//. 	" CASE WHEN EXISTS (Select Alarms.* FROM Alarms WHERE Alarms.cleared = 0 "
				//. 	"	AND Alarms.hostId = Hosts.id) THEN 1 ELSE 0 END AS hasUnclearedAlerts, "
				. 	" Hosts.id, Hosts.serialno as serial, Hosts.name, Hosts.location, Hosts.mac, Hosts.firmware, "
				.  " INET_NTOA(Hosts.ipaddr) as ip, "
				.  " CASE when Hosts.registered > 0 THEN 'Registered' ELSE 'Unregistered' END as status, "
				.  " CASE WHEN Hosts.isdown > 0 THEN 'Down' Else 'Up' END As availability, "
				.  " CASE WHEN Networks.name is null THEN '' ELSE Networks.name END as network "
				.  ($includeStats? ", StatsDef.id as statsDefId, StatsDef.oid as statsDefOid, StatsDef.name as statsDef " : "")		
				.  " FROM Hosts Left JOIN Networks "
				.  " ON "
				.  " Hosts.networkId = Networks.id "
				.  ($includeStats? " LEFT JOIN Host2Stats ON Hosts.id = Host2Stats.hostid "
				.                  " LEFT JOIN StatsDef ON StatsDef.id = Host2Stats.statsid " : "")		
				.  " WHERE 1 "
				.  " AND (Hosts.networkId IS NOT NULL OR (Hosts.firmware NOT LIKE 'Sweap v%' AND Hosts.firmware NOT LIKE 'SWEAP v%'))"
				;


	
		if($includeStats)
		{
		 		$statsDefQuery = " AND ( 0  ";

				foreach($statDefIds as $statDefId)
				{
					$statsDefQuery .= " OR Host2Stats.statsid  = $statDefId  ";
				}

				$statsDefQuery .= ")";

				$recordCountQuery .= $statsDefQuery;			
				$query .= $statsDefQuery;
		}

		if($quick)
		{
			$quickQuery =   
					($search['includeNetwork'] ? " AND (" . $networkIdsQuery . ") " : "") 
				. " AND  ( 0 "
				.  ($search['includeMAC']     ? " OR Hosts.mac like '" . $mac . "' " : "")
				.  ($search['includeSN']      ? " OR Hosts.serialno like '" . $serial . "' " : "")
				.  ($search['includeName']    ? " OR " . getOrSubQuery($name, 'Hosts.name like ') . " ": "")
				.  ($search['includeLocation']? " OR " . getOrSubQuery($location, 'Hosts.location like ') . " " : "")
				.  ($search['includeFW']      ? " OR Hosts.firmware like '" . $firmware . "' " : "")
				.  ($search['includeIP']      ? " OR INET_NTOA(Hosts.ipaddr) like '" . $ip . "' " : "") 
				. " ) ";

			$query 				.= $quickQuery;
			$recordCountQuery .= $quickQuery;
		}
		else
		{ 
			$advQuery =   
					($search['includeNetwork'] ? " AND (" . $networkIdsQuery . ") " : "") 
				.  ($search['includeMAC']     ? " AND " . getOrSubQuery($mac, 'Hosts.mac like ') . " " : "")
				.  ($search['includeSN']      ? " AND " . getOrSubQuery($serial, 'Hosts.serialno like ' ) . " " : "")
				.  ($search['includeName']    ? " AND " . getOrSubQuery($name, 'Hosts.name like ') . " ": "")
				.  ($search['includeLocation']? " AND " . getOrSubQuery($location, 'Hosts.location like ') . " " : "")
				.  ($search['includeFW']      ? " AND " . getOrSubQuery($firmware, 'Hosts.firmware like ') . " " : "")
				.  ($search['includeIP']      ? " AND " . getOrSubQuery($ip, 'INET_NTOA(Hosts.ipaddr) like ') . " ": "") 
				.  ($avail  == 'up'	  ? " AND Hosts.isdown = 0 "     : "")
				.  ($avail  == 'down'  ? " AND Hosts.isdown = 1 "     : "")
				.  ($status == 'registered'	  	? " AND Hosts.registered = 1 " : "")
				.  ($status == 'unregistered' 	? " AND (Hosts.registered = 0 OR Hosts.registered is null) " : "")
				.  ($deviceId > 0      				? " AND Hosts.deviceTypeId = $deviceId " : "");


			$query 				.= $advQuery;
			$recordCountQuery .= $advQuery;

		}
				
		

		$totalRecordCount = sqlNumber($recordCountQuery, "total");

		// If current page specified is out of thes range of the data, then set page to max
		// Example, if user is on 3rd page, then user checks some filters and
		// presses search again search will assume page 3, BUT we only have 2 pages, so need 
		// to use page 2 instead.
		
		if($totalRecordCount < ($pageNumber)* $pageSize)
		{

			$page = floor($totalRecordCount/$pageSize)*$pageSize;
		}

		if($sortField != ""){

			$sortField = strtolower($sortField);

			// For these numeric ones sort differently 
			if($sortField == 'availability' || $sortField == 'status')
			{
				$sortDirection = ($sortDirection == "DESC" ? "ASC" : "DESC");

			}

			$sortField = getSortByField($sortField);

			$query .= " Order By $sortField $sortDirection ";
		}

		$query.= " LIMIT $page, $pageSize ";


		$conn = getConnection();

		$result = mysql_query($query, $conn);

		if(!$result)
			error("Unable to retrieve devices. " . mysql_error($conn));

		$numrows = mysql_numrows($result);

		if($xml)
			$retVal =  "<hosts>";

		$i = 0;

		$headersNoPrint =  array('criticalAlerts' , 'warningAlerts' , 'hasUnclearedAlerts');


		// XXX TODO - make output hosts seperate functions - one for XML one for CSV
		while($i < $numrows)
		{	
			$host = mysql_fetch_assoc($result);
 			
			$hostId = $host['id'];
		
			// Then go ahead and print out header columns first
			if($i == 0 && $format == 'csv')
			{
				foreach($host as $key=>$value)
				{
					if(in_array($key, $headersNoPrint))
						continue;

					if(strlen($retVal) >0)
						$retVal .= ",";

					$retVal .= $key;
				}
				$retVal .= "\n";
			}

			if($xml)
				$retVal .= "<host id='$hostId'>\n";

			foreach($host as $key=>$value)
			{
			
				if(in_array($key, $headersNoPrint))
					continue;

				if($xml)
				{

					$hostTag = tag($key, $value);
			
					$retVal = $retVal . $hostTag;
				}
				else if($format == 'csv')
				{
					$retVal .= $value . ',';
				}
			
			}
			
			$severity = getSeverity($host);
			
			if($xml)	{		
				$retVal .= tag('severity', $severity);				
				$retVal .= "</host>\n";
				}	
			else 
				$retVal .= "\n";

			$i++;
		}

		if($xml){
			$retVal .= "</hosts>";

			$retVal .= tag('totalCount', $totalRecordCount);
		}
		// Get stats info (if exists)

		// Get alarm profile info (if exists)

		return $retVal;
	}

	function getSeverity($host)
	{
			$critical = $host['criticalAlerts'];
			$warning = $host['warningAlerts'];
			$status = $host['availability'];
			$hasUnCleared = $host['hasUnclearedAlerts'];

			$severity = 'ok';

			if($critical > 0 || $status == 'Down')
					$severity = 'critical';
			else if($warning > 0)
					$severity = 'warning';
			else if($hasUnCleared > 0)
					$severity = 'uncleared';	

			return $severity;

	}

	/**************************************************************
	* If given an search parameter that has commas in it,
	* break it up in to an OR statement
	* Example:  device name field contains: bob%, ligo%ptp, 
	*			   and phrase is 'Hosts.name like '
	* Will product the statement 
	* (Hosts.name like 'bob%' OR Hosts.name like 'ligo%ptp') 
	*/
	function getOrSubQuery($s_list, $phrase)
	{

		$list = explode(',', $s_list);

		$retVal = '';

		$i = -1;
		foreach($list as $item)
		{
			$i++;

			$item = trim($item);

			if($item == '')
				continue;

			if($i > 0)
			{
				$retVal .= " OR " ;
			}

			$retVal .= $phrase . " '" . $item . "' ";
			
		}


		if($i >=0)
			$retVal = "($retVal)";


		return $retVal;

	}

	/**************************************************************
	* Get datasource for auto complete text field on quick search
	*	
	*/
	function getAutoCompleteByName($str)
	{
		global $currentUserId;

		$networkQuery = '';
		$i = 0;

		$str = cleanParam($str);

		$networkIds = getAllowableNetworkIds($currentUserId);

		// Make sure to search those with no network as well
		//$networkIds[] = 0;

		$query = "SELECT Hosts.name FROM Hosts Left Join Networks "
				. " On Hosts.networkid = Networks.id "
				. " WHERE Hosts.name like '%$str%' ";

		$networkQuery .= " AND (0 ";
			
		foreach($networkIds as $networkid)
			{
				$networkQuery .= " OR ";

				$networkQuery .= " Networks.id = $networkid ";

				$i++;
			}		
		
		$networkQuery .= ")";
	
		$query .=$networkQuery . " LIMIT 50 ";

		$conn = getConnection();
		$result = @mysql_query($query, $conn);

		if(!$result)
		{
			// EH... don't do anything
			return;
		}

		$numrows = mysql_numrows($result);

		$retVal = "";

		$i = 0;

		while($i < $numrows)
		{	
			
			$host = mysql_fetch_assoc($result);
			$retVal .= tag('name', $host['name'], true);
			$i++;
		}

		return tag('names', $retVal);

	}


	/**************************************************************
	* Remove multiple hosts at one time.
	*	
	*/
	function deleteHosts($s_hostIds)
	{
		$hostIds = explode(',', $s_hostIds);

		foreach($hostIds as $hostId)
		{

			$hostId = (int) $hostId;

			if($hostId > 0)
				deleteHost($hostId);				

		}

		return tag('result', 'success');

	}

	/**************************************************************
	* Remove a host.
	*	
	*/
	function deleteHost($hostId)
	{
		global $currentUserId;

		if(!canAccessHost($currentUserId, $hostId))
		{
			error("Unathorized access to device.");
			return;
		}

		/*  XXX TODO 
			Does this need to be soft or hard delete?  What happens to task
			history for example when a host has been deleted?? */
		
		/* We're gonna start out with hard delete - let's remove everything */

		/* 1. Alarm History */

		$query = "DELETE FROM Alarms WHERE hostid = $hostId ";
		@sqlUpdate($query);
		sqlError("Unable to remove device! ");

		/* 2. Alarm Defs */

		$query = "DELETE FROM Host2Alarm WHERE hostid = $hostId ";
		@sqlUpdate($query);
		sqlError("Unable to remove device! ");


		/* 3. Stats History */

		$query = "DELETE FROM Stats WHERE hostid = $hostId ";
		@sqlUpdate($query);
		sqlError("Unable to remove device! ");

		$query = "DELETE FROM Stats_Day WHERE hostid = $hostId ";
		@sqlUpdate($query);
		sqlError("Unable to remove device! ");

		$query = "DELETE FROM Stats_Month WHERE hostid = $hostId ";
		@sqlUpdate($query);
		sqlError("Unable to remove device! ");

		$query = "DELETE FROM Stats_Week WHERE hostid = $hostId ";
		@sqlUpdate($query);
		sqlError("Unable to remove device! ");

		$query = "DELETE FROM Stats_Year WHERE hostid = $hostId ";
		@sqlUpdate($query);
		sqlError("Unable to remove device! ");

		/* 4. Stats Defs */

		$query = "DELETE FROM Host2Stats WHERE hostid = $hostId ";
		@sqlUpdate($query);
		sqlError("Unable to remove device! ");

	   	/* 5. Cfg Backups */

		$query = "DELETE FROM CfgBackup WHERE hostid = $hostId ";
		@sqlUpdate($query);
		sqlError("Unable to remove device! ");

		 /* 6. Troubleshooting files */

		$query = "DELETE FROM TroubleshootFile WHERE hostid = $hostId ";
		@sqlUpdate($query);
		sqlError("Unable to remove device! ");


		/* 7. Tasks */

		$query = "DELETE FROM Host2Task WHERE idhost = $hostId ";
		@sqlUpdate($query);
		sqlError("Unable to remove device! ");


		/* 8. Links */

		$query = "DELETE FROM Links WHERE fromHostId = $hostId OR toHostId = $hostId ";
		@sqlUpdate($query);
		sqlError("Unable to remove device! ");

		/* 9. Graph Reports */

		$query = "DELETE FROM UserGraphSeries WHERE hostId = $hostId  ";
		@sqlUpdate($query);
		sqlError("Unable to remove device! ");

		/* And now finally the host */

		$query = "DELETE FROM Hosts WHERE id = $hostId  ";
		@sqlUpdate($query);
		sqlError("Unable to remove device! ");

		return tag('result','success');
	}

	/**************************************************************
	* Get the max HB interval for the given host ids
	*
	*/
	function getMaxHB($shosts)
	{

		$hosts = explode("|", $shosts);

		$val = 1;

		$query = "Select MAX(hbinterval) as max FROM Hosts  WHERE  0 ";

		$count = 0;

		if(is_array($hosts) && count($hosts) > 0)
		{ 
			
			foreach ($hosts as $hostId)
			{

				if($hostId <=0)
					continue;

				$query .= " OR Hosts.id = $hostId ";

				$count++;

			}			

		}

		if($count > 0)
		{
			$val = sqlNumber($query, "max");
		}

		return $val;
	}
}

?>
