<?php

include('lib/sql.php');
include('lib/permissions.php');
include('lib/user.php');

if(!function_exists('alarmDef_wrapper'))
{

	function alarmDef_wrapper() {}

	/* Lengths of DB fields in the AlarmDefinition table */
	$ALARMDEF_LEN = array(
				'name' 		=> 50,
				'oid' 		=> 50,
				'op' 		   => 20,
				'desc' 		=> 50);

	
	function handleAlarmDefinitionAction($action)
	{
		if($action == null)
			error('Unauthorized');

		switch($action)
		{
			case 'create-custom':
				echo  createAlarmDef(req('name'),  req('desc'),
											req('oid'), req('threshold'),
											req('op'));
			break;
				
			case 'delete-custom':
				echo deleteAlarmDef(req('id'));
	
			break;

			case 'modify-custom':				
				echo modifyAlarmDef(req('id'),req('name'),  req('desc'),
									 req('oid'), req('threshold'), req('op'));
			break;

			
			case 'get':
				$alarms =  tag('custom',getAlarmDefs(1)) . tag('std',getAlarmDefs(0));
				echo tag('results', $alarms);
			break;

		}

	}

	/******************************************************************
	* Get a list of current custom alarm definition
	*
	**/
	function getAlarmDefs($custom)
	{
		$query = "SELECT * FROM AlarmDefinition "
				. " WHERE custom = $custom AND deleted = 0";

		
		$conn = @getConnection();

		$result = mysql_query($query, $conn);

		if(!$result)
			error("Unable to retrieve alarm definitions! ". mysql_error());
			
		$numrows = mysql_numrows($result);

		$i = 0;
 
		$retVal = "<alarmDefs>";

		while($i < $numrows)
		{	
			$row = mysql_fetch_assoc($result);
 			
			$retVal .= "<alarmDef id='" . $row['id'] . "'>";

			$retVal .= tag('name', $row['name'], true); 
			$retVal .= tag('display',getStdAlarmDefDisplayName($row['name']), true); 
			$retVal .= tag('desc', $row['desc'], true);
			$retVal .= tag('oid', $row['oid'], true);
			$retVal .= tag('threshold', $row['threshold']);
			$retVal .= tag('op', $row['op']); 
			
			$retVal .= "</alarmDef>";
			$i++;
		}

		$retVal .= "</alarmDefs>";
		return $retVal;
	}

	/******************************************************************
	* See if another alarm def has this name.
	*
	**/
	function doesAlarmDefExist($name, $oid, $threshold)
	{
		$name = cleanParam($name);
		$oid  = cleanParam($oid);
		$threshold =  (int)$threshold;

		$id = sqlNumber("SELECT id FROM AlarmDefinition "
						  . " WHERE name = '$name' "
						  . " AND oid = '$oid' "
						  . " AND threshold = $threshold ",
							 'id');		
	
		
		// XXX TODO: What happens when soft delete alarm def, but want to create
		// another one with the same name???

		//$deleted = sqlNumber("SELECT deleted FROM AlarmDefinition "
		//				  . " WHERE name like '$name' ", 
		//					 'id');

		return ($id > 0);

	}

	/******************************************************************
	* Create a custom alarm definition
	*
	**/
	function createAlarmDef($name, $desc, $oid, $threshold, $op)
	{

		global $ALARMDEF_LEN;


		if(doesAlarmDefExist($name, $oid, $threshold))
		{
			error("An alarm with that name, oid, and threshold already exists!");
			return;
		}

		$name 	= cleanTrimParam($name, $ALARMDEF_LEN['name']);
		$desc 	= cleanTrimParam($desc, $ALARMDEF_LEN['desc']);
		$oid   	= cleanTrimParam($oid, $ALARMDEF_LEN['oid']);
		$threshold = (int) $threshold;
		
		
		if($op != 'above' && $op != 'below' && $op != 'equal')
			error(" Invalid threshold operation value. (values must be "
				 . " above, equal, or below).  Yours was $op");

		// desc = DESCENDING in sql
		$query = "INSERT INTO AlarmDefinition "
				. " (name, AlarmDefinition.desc, oid, threshold, op, custom) "
				. " VALUES "
				. " ('$name', '$desc', '$oid', $threshold, '$op', 1) ";

		$result = @sqlInsert($query);

		if($result['id'] == null || $result['id'] <=0)
			error("Unable to create alarm def! " . mysql_error());
	
		return tag('result', 'success');
		
	}


	/******************************************************************
	* Modify a custom alarm definition
	*
	**/
	function modifyAlarmDef($id, $name, $desc, $oid, $threshold, $op)
	{

		global $ALARMDEF_LEN;
		$id = (int) $id;

		/* First lets make sure we're not changing our params to something
		 * that would cause a duplicate key problem in the DB
		 */

		$query = "SELECT * From AlarmDefinition where id = $id";

		$row = @sqlRow($query);

		if(!$row)
			error("Unable to retrieve alarm definition: " . mysql_error());

		$originalName = $row['name'];
		$originalOid = $row['oid'];
		$originalThreshold = $row['threshold'];
		
		if($originalName != $name 
		|| $originalOid != $oid 
		|| $originalThreshold  != $threshold)
		{
			 if(doesAlarmDefExist($name, $oid, $threshold))
			{
				error("An alarm with these parameters already exists!");
				return;
			}
		}
		
		$name 	= cleanTrimParam($name,  $ALARMDEF_LEN['name']);
		$desc 	= cleanTrimParam($desc, $ALARMDEF_LEN['desc']);
		$oid   	= cleanTrimParam($oid, $ALARMDEF_LEN['oid']);
		$threshold = (int) $threshold;
		
		if($op != 'above' && $op != 'below' && $op != 'equal')
			error(" Invalid threshold operation value. (values must be "
				 . " above, equal, or below)");

		$query = "UPDATE AlarmDefinition "
				. " SET name = '$name', AlarmDefinition.desc = '$desc', "
				. " oid = '$oid', "
				. " threshold = $threshold, op = '$op' "
				. " WHERE "
				. " id = $id ";

		$result = @sqlUpdate($query);

		$error = mysql_error();

		if($error != '')
			error("Unable to modify alarm def! " . $error);
	
		return tag('result', 'success');
		
	}

	/****************************************************
	* Remove a custom alarm definintion
	*
	**/
	function deleteAlarmDef($id)
	{

		$id = (int) $id;
		global $currentUserId;


		//if(!isUserAdminUser($currentUserId))
		//	error("Must be an administrator to delete alarm definitions.");


		$custom = sqlNumber(   "SELECT custom "
					. " FROM AlarmDefinition "
					. " WHERE id = $id ", 'custom');

		if($custom == 0)
			error("Not allowed to delete built-in alarm definitions!");

		/* 1. Just set the deleted flag */
		$query = "UPDATE AlarmDefinition "
				. " SET deleted = 1 "
				. " WHERE  id = $id ";

		@sqlUpdate($query);

		$error = mysql_error();
		if($error != '')
			error("Unable to remove alarm definition! $error");

	   	/* 2. Remove this custom alarm from all alarm profiles */
		$query = "DELETE FROM AlarmProfile2AlarmDef "
				. " WHERE alarmId = $id ";

		@sqlUpdate($query);

		$error = mysql_error();
		if($error != '')
			error("Unable to remove alarm definition! $error");

		/* 3. Remove this custom alarm from Host2Alarm */
		$query = "DELETE FROM Host2Alarm "
				. " WHERE alarmId = $id ";

		@sqlUpdate($query);

		$error = mysql_error();
		if($error != '')
			error("Unable to remove alarm definition! $error");

		return (tag('result', 'success'));
	}

	/******************************************************************
	* If the standard alarm defs dont exist when we login, then create 
	* them now.
	* 
	**/
	function createStandardAlarmDefs()
	{
		$defs = array( "etherstatus"  => 
							 array('name'=>'etherstatus', 'op'=>'equal', 'thresh'=> '1'),
							"radiostatus"  => 
							 array('name'=>'radiostatus', 'op'=>'equal', 'thresh'=> '1'),							
							"up_and_down"  => 
							 array('name'=>'up_and_down', 'op'=>'equal', 'thresh'=> '1'),
							"freqchange"  => 
							 array('name'=>'freqchange', 'op'=>'equal', 'thresh'=> '1'),
							"reboot"  => 
							 array('name'=>'reboot', 'op'=>'equal', 'thresh'=> '1') );
		
		foreach($defs as $key=>$values)
		{
			$query = " SELECT AlarmDefinition.id FROM AlarmDefinition "
					. " WHERE AlarmDefinition.name like '$key' ";

			$currentId = sqlNumber( $query, "id");

			if($currentId <=0 )
			{

			   $query = "INSERT INTO AlarmDefinition "
							. " (name, threshold, op, custom, deleted) " 
							. " VALUES "
						   . " ('$key', " . $values['thresh'] . ", '" . $values['op'] . "', 0, 0) ";

				// then create the alarmDef
				sqlInsert($query);

			}

		}
				
	}

	/******************************************************************
	* Get a more readable name for the alarm def
	* 
	**/
	function getStdAlarmDefDisplayName($name)
	{
	  /*
		switch($name)
		{
		case 'radiopeercount':
			return "Radio Peer Count";
		break;
		case 'rssi':
			return 'RSSI';
		break;
		case 'noise':
			return 'Noise Level';
		break;
		case 'rxdrop_pct':
			return 'RX Packet Drop %';
		break;
		case 'rxdrop':
			return 'RX Packets Dropped';
		break;
		case 'txretry_pct':
			return "TX Retry %";
		break;
		case 'txretry':
			return 'TX Retries';
		break;
		case 'etherstatus':
			return 'Ethernet Port Status';
		break;
		case 'freqchange':
			return 'Frequency Change';
		break;
		case 'reboot':
			return 'Reboot';
		break;
		case 'radiostatus':
			return 'Radio Status';
		break;
		case 'up_and_down':
		case 'availability':
			return 'Device Availability (up/down)';
		break;
		case 'configchange':
			return 'Device Config Changed';
		break;
		}
		*/

    /* 
     * This is very dirty and suboptimal right now and needs to be fixed --
     * the code that calls this should actually do the JOIN in the SQL query
     * so that calling this function is no longer necessary.
     */
     
    $name = mysql_real_escape_string($name);

    return sqlString(
        "SELECT Translations.`text` AS displayName " .
        "FROM AlarmName2Translation, " .
        "  Translations, " .
        "  SystemSettings " .
        "WHERE " .
        "  SystemSettings.`key` = 'SystemLanguageId' " .
        "  AND Translations.languageId = SystemSettings.value " .
        "  AND Translations.phraseId = AlarmName2Translation.phraseId " .
        "  AND AlarmName2Translation.name = '$name' " .
        "UNION " .
        "SELECT '$name' AS displayName",
        "displayName"
      );
	}

}
?>
