<?php

include('lib/sql.php');
include('lib/utils.php');

if(!function_exists('permissions_wrapper'))
{
	function permissions_wrapper(){}


    function xml_entities($text)
    {
        $text = htmlentities($text, ENT_QUOTES, "UTF-8");
        return str_replace("&#039;", "&apos;", $text);
    }

	/********************************************
	*	Write out tab permissions XML
	*
	**********************************************/
	function getTabPermissionsXML($userid)
	{
		$userid = (int) $userid;

		$conn = getConnection();

		if(isUserAdminUser($userid))
			$defaultPermissionLevel = 0; // Which is all permissions.
		else
			$defaultPermissionLevel = 2; // Which is no permissions.

		$query = 
<<<EOQ
			SELECT
				Tabs.id AS TabId,
				Tabs.description AS Description,
				Tabs.name AS Name,
				IFNULL(TabPermissions.permissionLevel, {$defaultPermissionLevel}) AS PermissionLevel
			FROM
				Tabs
			LEFT JOIN
				TabPermissions
			ON 
				TabPermissions.tabId = Tabs.id
				AND TabPermissions.userId = {$userid}
			WHERE
				Tabs.ordinal IS NOT NULL
			ORDER BY
				Tabs.ordinal
EOQ;

		$result = mysql_query($query, $conn);

		if(!$result)
			error("Unable to connect to the database.");

		$numrows = mysql_numrows($result);

		$retVal = "";

		$i = 0;
		while($i < $numrows)
		{	

			$level = mysql_result($result, $i, "PermissionLevel");
			$name  = mysql_result($result, $i, "Name");
			$tabid = mysql_result($result, $i, "TabId");
			$desc  = mysql_result($result, $i, "Description");

			$retVal .= "<permission name='$name' value='$level'  id='$tabid' desc='$desc' />\n";

			$i++;
		}

		return $retVal;

	}

	
	/**************************************************
	* Get list of allowed network ids for the user
	*
	**************************************************/
	function getAllowableNetworkIds($userid)
	{
		$userid = (int) $userid;

		$conn = getConnection();

		$retVal = array();

		$isNetworkUser = isUserNetworkUser($userid);
		if($isNetworkUser) 
		{
				$query =   " SELECT Networks.id "
							. " FROM Networks, User2Network "
							. " WHERE User2Network.UserId = $userid "
							. " AND User2Network.NetworkId = Networks.Id";
		}
		else
		{
				$query = " SELECT Networks.id FROM Networks ";
		}

		$query .= " ORDER BY Networks.name";
		
		$result = mysql_query($query, $conn);

		if(!$result)
			error("Database error! Unable to retrieve network info.");

		$numrows = mysql_numrows($result);

		$i = 0;

		while($i < $numrows)
		{	
			$retVal[$i] = mysql_result($result, $i, 'id');
			$i++;
		}

		// Add "no network" for non-network users
		if(!$isNetworkUser)
			$retVal[] = 0;

		return $retVal;
	}


	/*********************************************************************
	*  Get nested children of network.
	*
	**********************************************************************/
	function getNetworkChildren($networkid, $isrestricted, $userid, $networkids)
	{
		$conn = getConnection();

		$query =   " SELECT Networks.* FROM Networks "
					. " WHERE Networks.parentid = $networkid "
					. " ORDER BY Networks.name";

		$result = mysql_query($query, $conn);
		$numrows = mysql_numrows($result);

		$retVal = "";

		$i = 0;

		while($i < $numrows)
		{	
			$newid  = mysql_result($result, $i, "id") ;
			$add = TRUE;

			if($isrestricted)
			{
				$add = FALSE;
				if(in_array($newid, $networkids)) 
					$add = TRUE;
			}	

			if($add)
			{
				$retVal .= "<network status='CRITICAL' "
							. " id='" . mysql_result($result, $i, "id") . "' "
							. " name='" . xml_entities(mysql_result($result, $i, "name"))  . "' "
							. ">\n";
			}
			$retVal .= getNetworkChildren($newid, $isrestricted, $userid, $networkids);

			if($add)
			{
				$retVal .= "</network>\n";
			}
			$i++;
		}
		
		$retVal .= "<!-- What is this? -->";

		return $retVal;
	}


	/*********************************************************************
	*  Get nested children of network.  Add "checked" attribute 
	*  to non-restricted networks.
	*  $forceall: TRUE to get ALL networks, even if user isn't 
	*  a member of them (admin list).
	**********************************************************************/
	function getSelectableNetworkChildren($networkid, $isrestricted, $userid, $networkids)
	{
		$conn = getConnection();

		$query =   " SELECT Networks.* FROM Networks "
						. " WHERE Networks.parentid = $networkid "
						. " ORDER BY Networks.name";
		
		$result = mysql_query($query, $conn);
		$numrows = mysql_numrows($result);

		$retVal = "";

		$i = 0;

		while($i < $numrows)
		{	
			$allowed = '0';

			$newid  = mysql_result($result, $i, "id") ;

			// If network user and this network id is contained in the
			// allowable netowrk id list, then put allowed = 1.
			if($isrestricted)
			{
				if(in_array($newid, $networkids)) 
					$allowed = '1';
			}
			else $allowed = '1';

			$retVal .= "<network allowed='$allowed'  "
							. " id='" . mysql_result($result, $i, "id") . "' "
							. " name='" . xml_entities(mysql_result($result, $i, "name"))  . "' "
							.">\n";
			
			$retVal .= getSelectableNetworkChildren($newid, $isrestricted, $userid, $networkids);

			$retVal .= "</network>\n";

			$i++;
		}

		return $retVal;
	}


	/****************************************************
	*	Get a list of the networks available to this user
	*
	*****************************************************/
	function getAllowableNetworksXML($userid)
	{
		$userid = (int) $userid;

	
		$isrestricted = isUserNetworkUser($userid);
		$networkids = array();
		
		if($isrestricted)
			$networkids = getAllowableNetworkIds($userid);

		$networks = getNetworkChildren(0, $isrestricted, $userid, $networkids);

		return $networks;
	}

	/****************************************************
	*	Get a list of the networks available to this user
	*  as a subset of all networks (for the checkbox 
	*  control)
	*****************************************************/
	function getSelectableNetworksXML($userid)
	{
		$userid = (int) $userid;

		$networkids = getAllowableNetworkIds($userid);
		$networks = getSelectableNetworkChildren(0, isUserNetworkUser($userid), $userid, $networkids);

		
		return $networks;
	}


	/****************************************************
	*	Get a list of the networks available to this user
	*
	*****************************************************/
	function _getAllowableNetworksXML($userid)
	{
		$userid = (int) $userid;

		$conn = getConnection();

		if(isUserNetworkUser($userid)) 
		{
			$query =   " SELECT Networks . * "
						. " FROM Networks, User2Network "
						. " WHERE User2Network.UserId = $userid "
						. " AND User2Network.NetworkId = Networks.Id";
		}
		else
		{
			$query =  "SELECT Networks.* FROM Networks";
		}

		$result = mysql_query($query, $conn);
		$numrows = mysql_numrows($result);

		$retVal = "";

		$i = 0;

		while($i < $numrows)
		{	
			$retVal .= "<network>\n";

			// XXX: Handle CDATA
			$retVal .= tag("name", mysql_result($result, $i, "name"), TRUE) . "\n";
			$retVal .= tag("id", mysql_result($result, $i, "id")). "\n";
			$retVal .= tag("description", mysql_result($result, $i, "description"), TRUE) . "\n";
			$retVal .= "<centerlat>" . mysql_result($result, $i, "centerlat") . "</centerlat>\n";
			$retVal .= "<centerlon>" . mysql_result($result, $i, "centerlon") . "</centerlon>\n";

			$retVal .= "</network>\n";

			$i++;
		}

		return $retVal;

	}

	
	/********************************************************
	* removeAllPermissions: remove all of users tab permissions.
	*
	*********************************************************/
	function removeAllPermissions($userid)
	{

		$userid = (int) $userid;

		sqlCmd("DELETE FROM TabPermissions WHERE userid = $userid");

	}


	/********************************************************
	* isUserNetworkUser: determine if this user is a network
	* 		restricted user.
	*********************************************************/
	function isUserNetworkUser($userid)
	{
	
		$group = getUsersGroup($userid);

		return $group == "NETWORK";

	}

	/********************************************************
	* isUserAdminUser: determine if this user is an admin user.
	*********************************************************/
	function isUserAdminUser($userid)
	{
		$group = getUsersGroup($userid);

		return $group == "ADMIN";

	}


	/********************************************************
	* canAccessNetwork: determine if this user allowed to
	* modify or read the given netowrk.
	*********************************************************/
	function canAccessNetwork($userid, $networkid)
	{
		$userid = (int) $userid;
		$networkid = (int) $networkid;

		if($userid <= 0 || $networkid <= 0){
			return FALSE;
		}

		if(!isUserNetworkUser($userid))
			return TRUE;

		$networkids = getAllowableNetworkIds($userid);

		return in_array($networkid, $networkids);

	}

	/********************************************************
	* canAccessHost: determine if this user allowed to
	* modify or read the given host.
	*********************************************************/
	function canAccessHost($userId, $hostId)
	{
		$userId = (int) $userId;
		$hostId = (int) $hostId;

		if($userId <=0)
 			return FALSE;

		if($hostId <= 0)
			return TRUE;

		if(!isUserNetworkUser($userId))
			return TRUE;

		$query =   " SELECT  Hosts.id FROM Hosts, User2Network "
					. " WHERE Hosts.id = $hostId " 
					. " AND Hosts.networkId = User2Network.networkId "
					. " AND User2Network.userid = $userId  LIMIT 1 ";



		$id = sqlNumber($query, "id");

		return $id > 0;
	}

	/******************************************************************
	* If the standard tabs dont exist when we login, then create 
	* them now.
	* 
	**/
	function createStandardTabs()
	{
		$defs = array(
			"home" => array('name' => 'home', 'desc' => 'Dashboard Tab'),
			"inventory" => array('name' => 'inventory', 'desc' => 'Inventory Tab'),
			"networks" => array('name' => 'networks', 'desc' => 'Networks Tab'),
			"system" => array('name' => 'system', 'desc' => 'SystemTab'),
			/*"preferences" => array('name' => 'preferences', 'desc' => 'User Preferences Tab'),*/
			"alarms" => array('name' => 'alarms', 'desc' => 'Alerts tab'),
			"tasks" => array('name' => 'tasks', 'desc' => 'Tasks Tab'),
			"stats" => array('name' => 'stats', 'desc' => 'Stats and Reports Tab'));


		foreach($defs as $key=>$values)
		{
			$query = " SELECT Tabs.id FROM Tabs "
					. " WHERE Tabs.name like '$key' ";

			$currentId = sqlNumber( $query, "id");

			if($currentId <=0 )
			{
			   $query = "INSERT INTO Tabs "
							. " (name, description) " 
							. " VALUES "
						   . " ('$key', '" . $values['desc'] . "') ";

				// then create the tab
				sqlInsert($query);

			}

		}
				
	}
}
?>
