<?php

include('lib/utils.php');

if(!function_exists('settings_wrapper'))
{
	function settings_wrapper() {}

	$sql_host 		= '';
	$sql_username 	= '';
	$sql_password 	= '';
	$sql_dbname 	= '';
	
	/* Used for hashing passwords and whatnot */
	$salt 			=  'pD023xJzvpprt81'; 

	/* Path to WNMS config file */
	$config_path = '/etc/wnms/wnms.conf';
	$portal_config_path = '/etc/wnms/wnms_portal.conf';
 

	/***************************************************************
	* Load db settings from the wnms config file.
	*
	*/
	function readDBSettings()
	{
		global $config_path;

		global $sql_host;
		global $sql_username;
		global $sql_password;
		global $sql_dbname;

		// If already set for this session, don't reload.
		if($sql_host     != ''     && $sql_username != '' 
		&& $sql_password != ''     && $sql_dbname   != '')
			return;

		$file = fopen($config_path, 'r');
		$contents = fread($file, filesize($config_path));
		fclose($file);

		// Parse out wnmsDbParams line

		$contents = "_" . $contents;

		$paramIndex = strrpos($contents, 'wnmsDbParams');
		
		if(!$paramIndex)
			error("Unable to retrieve database settings.");

		$quoteStart = strpos($contents, "\"", $paramIndex);

		$quoteEnd = strpos($contents, "\"", $quoteStart + 1);


		$line = substr($contents, $quoteStart +1, $quoteEnd - $quoteStart-1);

		$params = explode(',', $line);

		foreach($params as $param)
		{
			$paramName = "";
			$paramValue = "";
			list($paramName, $paramValue) = explode('=', $param);
		
			switch($paramName)
			{
				case 'Host':
				case 'host':
				case 'HOST':
						$sql_host = $paramValue;
						// solution for win7 localhost issue
						if($sql_host == 'localhost')
						{
							$sql_host = '127.0.0.1';
						}
				break;

				case 'User':
				case 'user':
				case 'USER':
						$sql_username = $paramValue;
				break;

				case 'Pass':
				case 'pass':
				case 'PASS':
						$sql_password = $paramValue;
				break;

				case 'Dbname':
				case 'dbname':
				case 'DBNAME':
						$sql_dbname = $paramValue;
				break;

			}
		}
	}

	/***************************************************************
	* Update database settings in the wnms config file.
   * Try not to overwrite anything else... :|
	*
	*/
	function writeDBSettings($newHost, $newUsername, 
									 $newPassword, $newDbName)
	{
		/// XXX TODO: should we create a backup file before?

		global $config_path;
		global $portal_config_path;

		global $sql_host;
		global $sql_username;
		global $sql_password;
		global $sql_dbname;

		$sql_host = $newHost;
		$sql_username = $newUsername;
		$sql_password = $newPassword;
		$sql_dbname = $newDbName;

		$file = @fopen($config_path, 'r+');

		if(!$file)
			error("WNMS Config file doesn't exist or you dont have permission to edit it!");

		$contents = fread($file, filesize($config_path));
		
		$newLine  = "wnmsDbParams \"host=$newHost,user=$newUsername,"
					.  "pass=$newPassword,dbname=$newDbName\"";

		// Find line that contains wnmsDbParams 

		$paramIndex = strpos($contents, 'wnmsDbParams');
		
		if(!$paramIndex)
			$contents = $contents . "\n" . $newLine;
		else
		{
			$quoteStart = strpos($contents, "\"", $paramIndex);

			$quoteEnd = strpos($contents, "\"", $quoteStart + 1);

			$originalLine = substr($contents, $paramIndex, $quoteEnd - $paramIndex+1);
		
			$contents = str_replace($originalLine,  $newLine, $contents);

		}

		ftruncate($file, 0);
		rewind($file);
		fwrite($file, $contents);

		fclose($file);
		
		// Now rewrite the portal configuration file as it uses a different
		// syntax for the connection string. Portal config and WNMS config
		// are the same file on Windows, meaning that it will get rewritten
		// twice by this function.
		
		$portalConfig = file_get_contents($portal_config_path);
		$portalConfig = preg_replace("/DBPARAMS:[^],]+/", "DBPARAMS:$newHost:$newUsername:$newPassword:$newDbName", $portalConfig);
		file_put_contents($portal_config_path, $portalConfig);
	}


}
?>
