<?php

include('lib/sql.php');

if(!function_exists('snmp_wrapper'))
{

	function snmp_wrapper() { }
 

	function handleSnmpAction($action)
	{
		if($action == null)
			error('Unauthorized');

		switch($action)
		{
			case 'upload':
				parseCSV();
			break;

			case 'download':
				outputCSV();
			break;


			case 'get':
				echo getSnmpOids();
			break;
		}
	
	}

	/*******************************************
	* Take CSV file and store contents in DB.
	*
	*/
	function parseCSV()
	{
		
		if($_FILES['Filedata']['size'] <= 0)
		{
			error("Unable to upload file!");
		}

		$tmpName  = $_FILES['Filedata']['tmp_name'];

		$fp = fopen($tmpName, 'r');
		$text = fread($fp, filesize($tmpName));

		fclose($fp);

		$lineDelim = "\r\n";
		$entryDelim = ',';

		/* Delete all entries */

		sqlCmd("DELETE FROM SnmpOids");

		$pos = (int)strpos($text, $lineDelim) ;

		if($pos <=0)
		{
			$lineDelim = "\n";			
		}

	

		if(strpos($text, ';'))
			$entryDelim = ';';

		$lines = explode($lineDelim, $text);
		
		$i = 0;


		foreach($lines as $line)
		{
			$i++;

			if($i == 1){
				continue;
			}

			$entries = explode($entryDelim, $line);
	
			if(count($entries) < 3)
				continue;
		
			$name = cleanParam( $entries[0]);
			$desc =  cleanParam($entries[1]);
			$oid =  cleanParam($entries[2]);

			$query = "INSERT INTO SnmpOids"
					. " (name, SnmpOids.desc, oid) "
					. " VALUES "
					. " ('$name', '$desc', '$oid') ";

			@sqlInsert($query);

		}		

		echo tag('result', 'success');

	}

	/*************************************************************
	*  Output the CSV form of SNMP oids
	*
	*/
	function outputCSV()
	{
		$query = "SELECT * FROM SnmpOids";
	
		$conn = @getConnection();

		$result = mysql_query($query, $conn);

		if(!$result)
		{
			error("Unable to read SNMP Data! ". mysql_error());
			return;
		}

		$numrows = mysql_numrows($result);
		$i = 0;

		echo "SNMP Object Names,Description,SNMP OID" . "\n";

		while($i < $numrows)
		{	
			
			$row = mysql_fetch_assoc($result);

			echo $row['name']. ','. $row['desc'] . ','. $row['oid'] . "\n";


			$i++;
		}

	}

	/*************************************************************
	*  Output SNMP in normal form of XML
	*
	*/
	function getSnmpOids()
	{
		$query = "SELECT * FROM SnmpOids";
	
		$conn = @getConnection();

		$result = mysql_query($query, $conn);

		if(!$result)
		{
			error("Unable to read SNMP Data! ". mysql_error());
			return;
		}

		$numrows = mysql_numrows($result);
		$i = 0;

		$retVal = "<snmp>";

		while($i < $numrows)
		{	
			
			$row = mysql_fetch_assoc($result);

			$value = tag("name", $row['name'], true)
					. tag("desc", $row['desc'], true)
					. tag("oid", $row['oid'], true);

			$retVal .= tag('entry', $value);

			$i++;
		}

		$retVal .= "</snmp>";

		return $retVal;
	}

}



?>
