<?php

include('lib/settings.php');
include('lib/utils.php');

if(!function_exists('sql_wrapper'))
{

	function sql_wrapper() {}

	/**********************************************************
	* Clean params before adding them to a query.
	*
	*/
	function cleanParam($param)
	{

		if(is_numeric($param))
			return $param;

		if(get_magic_quotes_gpc())
			$param = stripslashes($param);

		return mysql_real_escape_string($param, getConnection());
	}

	/**********************************************************
	* Cleans and trims params before adding them to a query.
	*
	*/
	function cleanTrimParam($param, $maxLen)
	{
		if(is_numeric($param))
			return $param; // Eh... oh well!

		$param = mysql_real_escape_string($param, getConnection());

		if(get_magic_quotes_gpc())
			$param = stripslashes($param);

		if(strlen($param) > $maxLen)
			$param = substr($param, 0, $maxLen);

		return $param;
	}

	/**********************************************************
	* Return a SQL Connection to the wnms DB.
	*
	*/
	function getConnection($catchError=true)
	{

		global $sql_username;
		global $sql_password;
		global $sql_host;
		global $sql_dbname;

		if($sql_dbname == '' && $sql_username == '' && $sql_host == '')
			readDBSettings();

		// This number allows us to return multiple result sets
		$conn = mysql_connect($sql_host, $sql_username, $sql_password, false,131072);

		if(!$conn)
			error('Could not connect to SQL Server! ' . mysql_error());

		$selected = mysql_select_db($sql_dbname, $conn);

		if($catchError && !$selected)
			error("Error: (" . $sql_dbname . ") " . mysql_error());
			
		mysql_set_charset('utf8', $conn);

		return $conn;
	

	}

	function sqlVal($result, $fieldname)
	{
		return mysql_result($result, 0, $fieldname);

	}

	function sqlObj($query, $fieldname)
	{
		$conn = getConnection();
		
		$result = mysql_query($query, $conn);

		$numrows = mysql_numrows($result);

		if($numrows == 0)	
			return null;

		$value = mysql_result($result, 0, $fieldname);

		return $value;

	}

	
	function sqlString($query, $fieldname)
	{
		$result = sqlObj($query, $fieldname);

		if($result == null || !$result) return "";

		else return $result;
	}

	function sqlNumber($query, $fieldname, $nullValue=0)
	{
		$result = sqlObj($query, $fieldname);

		if($result == null) return $nullValue;
		if(!is_numeric($result)) return $nullValue;

		return $result;
	}

	
	function sqlRow($query)
	{
		$conn = getConnection();
		
		$result = @mysql_query($query, $conn);

		$error = mysql_error();
		
		if($error != "")
			error($error);

		$numrows = mysql_numrows($result);

		if($numrows <= 0)	
			return FALSE;

		return mysql_fetch_assoc($result);

	}

	function sqlInsert($query)
	{		
		$conn = getConnection();

		@mysql_query($query, $conn);


		$lastid = @mysql_insert_id($conn);
		$numrows= @mysql_affected_rows($conn);
		
		$obj = array();

		$obj['id'] = $lastid;
		$obj['rows'] = $numrows;

		return $obj;
	}	

	function sqlCmd($query)
	{
		@sqlUpdate($query);
	}

	function sqlUpdate($query)
	{		
		$conn = getConnection();
		@mysql_query($query, $conn);

		$numrows= @mysql_affected_rows($conn);
		
		return $numrows;
	}	
	
	/***********************************************************************
	* This will check for a sql error and error out of php if one is found.
	*
	*/
	function sqlError($msg='')
	{
		$error = mysql_error();
		if($error != "")
		error($msg . $error);
	}
}

?>
