<?php

include('lib/sql.php');

if(!function_exists('statsDef_wrapper'))
{

	function statsDef_wrapper() {}

	/* Lengths of DB fields in the StatsDef table */
	$STATSDEF_LEN = array(
				'name' 		=> 32,
				'oid' 		=> 50);

	
	function handleStatsDefAction($action)
	{
		if($action == null)
			error('Unauthorized');

		switch($action)
		{
			case 'create':
				echo  createStatsDef(req('name'), req('oid'), req('graphTemplateId'));
			break;
				
			case 'delete':
				echo deleteStatsDef(req('id'));
	
			break;

			case 'modify':				
				echo modifyStatsDef(req('id'),req('name'), req('oid'), 
										req('graphTemplateId'));
			break;

			
			case 'get':
				echo getStatsDefs();
			break;

		}

	}

	/******************************************************************
	* Get a list of current stats definitions
	*
	**/
	function getStatsDefs()
	{
		$query = "SELECT StatsDef.*, GraphTemplate.name as graphTemplate "
					. "  FROM StatsDef  "
					. " LEFT JOIN GraphTemplate "
					. " ON GraphTemplate.id = StatsDef.defaultGraphTemplateId ";

		
		$conn = @getConnection();

		$result = mysql_query($query, $conn);

		if(!$result)
			error("Unable to stats definitions! ". mysql_error());
			
		$numrows = mysql_numrows($result);

		$i = 0;
 
		$retVal = "<statsDefs>";

		while($i < $numrows)
		{	
			$row = mysql_fetch_assoc($result);
 			
			$retVal .= "<statsDef id='" . $row['id'] 
						. "' graphTemplateId='" . $row['defaultGraphTemplateId'] . "'>";

			$graphTemplate = $row['graphTemplate'];
			if($graphTemplate == NULL)
				$graphTemplate = 'None';

			$retVal .= tag('name', $row['name'], true); 
			$retVal .= tag('graphTemplate', $graphTemplate, true); 
			$retVal .= tag('oid', $row['oid'], true);
			$retVal .= tag('id', $row['id']);
			
			$retVal .= "</statsDef>";
			$i++;
		}

		$retVal .= "</statsDefs>";
		return $retVal;
	}

	/******************************************************************
	* See if another stats def has this name and oid.
	*
	**/
	function doesStatsDefExist($name, $oid)
	{
		$name = cleanParam($name);
		$oid = cleanParam($oid);
		// only oid is unique
		$id = sqlNumber("SELECT id FROM StatsDef "
						  . " WHERE oid = '$oid' ",
							 'id');		
	
		return ($id > 0);

	}

	/******************************************************************
	* Create a stats definition
	*
	**/
	function createStatsDef($name, $oid, $graphId)
	{
		$graphId = (int) $graphId;

		global $STATSDEF_LEN;

		if(doesStatsDefExist($name, $oid))
		{
			error("An definition with that oid already exists!");
			return;
		}

		$name 	= cleanTrimParam($name, $STATSDEF_LEN['name']);
		$oid   	= cleanTrimParam($oid, $STATSDEF_LEN['oid']);
		
		$query = "INSERT INTO StatsDef "
				. " (name,  oid, defaultGraphTemplateId) "
				. " VALUES "
				. " ('$name', '$oid', $graphId) ";

		$result = @sqlInsert($query);

		if($result['id'] == null || $result['id'] <=0)
			error("Unable to create stats def! " . mysql_error());
	
		return tag('result', 'success');
		
	}


	/******************************************************************
	* Modify a stats definition
	*
	**/
	function modifyStatsDef($id, $name, $oid, $graphId)
	{

		global $STATSDEF_LEN;
		$id = (int) $id;
		$graphId = (int) $graphId;

		/* First lets make sure we're not changing our params to something
		 * that would cause a duplicate key problem in the DB
		 */

		$query  = "SELECT * From StatsDef where id = $id";

		$row = @sqlRow($query);

		if(!$row)
			error("Unable to retrieve stats definition: " . mysql_error());

		$originalName = $row['name'];
		$originalOid = $row['oid'];
		
		if( $originalOid != $oid )
		{
			 if(doesStatsDefExist($name, $oid))
			 {
				error("A definition with these parameters already exists!");
				return;
			 } 
		}
		
		$name 	= cleanTrimParam($name,  $STATSDEF_LEN['name']);
		$oid   	= cleanTrimParam($oid, $STATSDEF_LEN['oid']);
		

		$query = "UPDATE StatsDef "
				. " SET name = '$name', "
				. " oid = '$oid', "
				. " defaultGraphTemplateId = $graphId "
				. " WHERE "
				. " id = $id ";

		$result = @sqlUpdate($query);

		$error = mysql_error();

		if($error != '')
			error("Unable to modify stats def! " . $error);
	
		return tag('result', 'success');
		
	}

	/****************************************************
	* Remove a stats definintion
	*
	**/
	function deleteStatsDef($id)
	{

		$id = (int) $id;
		global $currentUserId;


	   /* 2. Remove this def from all stat profiles */
		$query = "DELETE FROM StatsProfile2StatsDef "
				. " WHERE statsDefId = $id ";

		@sqlUpdate($query);

		$error = mysql_error();
		if($error != '')
			error("Unable to remove stats definition! $error");

		/* 3. Remove from Host2Stats */
		$query = "DELETE FROM Host2Stats "
				. " WHERE statsId = $id ";

		@sqlUpdate($query);

		$error = mysql_error();
		if($error != '')
			error("Unable to remove stats definition! $error");

		/* Last. Delete the def */
		$query = "DELETE  FROM StatsDef "
				. " WHERE  id = $id ";

		@sqlUpdate($query);

		$error = mysql_error();
		if($error != '')
			error("Unable to remove stats definition! $error");


		return (tag('result', 'success'));
	}


}
?>
