<?php

include('lib/sql.php');
include('lib/permissions.php');
include('lib/user.php');

if(!function_exists('statsProfile_wrapper'))
{

	function statsProfile_wrapper() {}

	/* Lengths of DB fields in the StatsProfiles table */
	$STATSPROFILES_LEN = array(
				'name'		   => 50);

	
	function handleStatsProfileAction($action)
	{
		if($action == null)
			error('Unauthorized');

		switch($action)
		{
			case 'create':
				echo  createStatsProfile(req('name'),  req('statsDefs'));
			break;
				
			case 'delete':
				echo deleteStatsProfile(req('id'));
	
			break;

			case 'modify':				
				echo modifyStatsProfile(req('id'), req('name'), 
											  req('statsDefs'));
			break;

			
			case 'get':
				echo getStatsProfiles();
			break;

		}

	}

	/****************************************************
	* Get all active stat profiles
	*
	**/
	function getStatsProfiles()
	{

		$retVal = "<statsProfiles>";

		/* Get Stats profiles */
		$query =   " SELECT StatsProfiles.*, Users.username "	
					. " FROM StatsProfiles "
					. " Left Join Users "
					. " On Users.id = StatsProfiles.createdBy "
					. " ORDER BY StatsProfiles.ordinal, StatsProfiles.id ";

		$conn = @getConnection();

		$result = mysql_query($query, $conn);

		if(!$result)
			error("Unable to retrieve stat profiles from the database! ". mysql_error());
			
		$numrows = mysql_numrows($result);

		$i = 0;

		while($i < $numrows)
		{	
			$row = mysql_fetch_assoc($result);
 			$id = (int)$row['id'];

			$retVal .= "<statsProfile id='" . $id . "'>";

			$retVal .= tag('name', $row['name'], true); 
			$retVal .= tag('id', $row['id']); 
			$retVal .= tag('createdOn', $row['createdOn'], true);
			$retVal .= tag('username', $row['username'], true);
			

			$retVal .=  getStatDefsInProfile($id);

			$retVal .= "</statsProfile>";
			$i++;
		}

		$retVal .= "</statsProfiles>";


		return $retVal;
	}


	/****************************************************
	* Get stat def XML for stat profile
	*
	**/
	function getStatDefsInProfile($id)
	{
		$id = (int) $id;

		/* For each stat profile, get the stat definitions */
		$query = " SELECT * from StatsProfile2StatsDef , StatsDef "
				 . " WHERE StatsProfile2StatsDef.statsProfileId = $id "
				 . " AND StatsDef.id = StatsProfile2StatsDef.statsDefId "
				 . " ORDER BY ordinal, statsDefId";

		$conn = @getConnection();

		$result = mysql_query($query, $conn);

		if(!$result)
			error("Unable to retrieve stat defs from the database! ". mysql_error());
			
		$numrows = mysql_numrows($result);

		$i = 0;

		$retVal = "";

		while($i < $numrows)
		{	
			$row = mysql_fetch_assoc($result);
 			$id = (int)$row['id'];

			$retVal .= "<statsDef id='" . $id . "'>\n";
			
			$retVal .= tag('name', $row['name'], true); 
			$retVal .= tag('id', $row['id']); 
			$retVal .= tag('oid', $row['oid'], true);
			
			$retVal .= "</statsDef>\n";
			$i++;
		}

		$retVal = tag('statsDefs', $retVal);

		return $retVal;

	}


	/******************************************************************
	* Create an stats Profile
	* $statDefs: format is string of:
	*   statDefId: 
	* Example:  2,3
	**/
	function createStatsProfile($name,  $statsDefsStr)
	{
		/* 1. Create stat profile in StatsProfiles table. */

		global $currentUserId;
		global $STATSPROFILES_LEN;

		$createdBy 		= (int) $currentUserId;


		$name 			= cleanTrimParam($name, $STATSPROFILES_LEN['name']);
	
		$query = "INSERT INTO StatsProfiles "
				. " (name,  createdBy) "
				. " VALUES "
				. " ('$name',  $createdBy) ";

		$result = sqlInsert($query);

		if($result['id'] == null || $result['id'] <=0)
			error("Unable to create profile!" . mysql_error());

		$statsProfileId = $result['id'];
		
		/* 2. Add entries in the StatsProfile2StatsDef table. */
		
		$statsDefsArray = explode(',', $statsDefsStr);

		if(is_array($statsDefsArray))
			foreach($statsDefsArray as $statsDefId)
			{
				$statsDefId = (int)$statsDefId;
				if($statsDefId <=0 )
					continue;

				addStatsDefToProfile($statsProfileId, $statsDefId);

			}
		
		applyStatsDefProfile($statsProfileId);

		return tag('statsProfileId', $statsProfileId);
	

	}

	/****************************************************
	* Simple transaction to add an stat def to a profile
	*
	**/
	function addStatsDefToProfile($profileId, $statsDefId)
	{

			if($statsDefId == 0) return;

			$query = "INSERT INTO StatsProfile2StatsDef "
				. " (statsDefId, statsProfileId) "
				. " VALUES "
				. " ($statsDefId, $profileId) ";
		

			@sqlInsert($query);
			$error = mysql_error();
			if($error != "")
				error("Unable to add stats def to stats profile! " . $error);

	}


	/****************************************************
	* This function takes a modified stat profile 
	* and makes sure that the stat defs in the profile
	* are present in Host2Stats for ALL hosts that 
	* use this profile.  Ugh.
	*
	* If specify a host id, then we'll just check for that host.
	*
	**/
	function applyStatsDefProfile($statsProfileId, $hostId=null)
	{

		/* First see if there are any stats that exist in Host2Stats and
		 * NOT in StatsProfile2StatsDef table
		 * If one does, then remove it from Host2Stats.
		 */
		
		$statsProfileId = (int) $statsProfileId;

		/* If host id is not null and statsProfileId <=0, it means
		 * that this stats profile has been removed from the host.
		*/
		if($hostId != null && $hostId > 0 && $statsProfileId <=0)
		{

			$query = "DELETE FROM Host2Stats WHERE hostId=$hostId ";

			sqlUpdate($query);

			return tag('result', 'success');
		}

		$query = 
		 " SELECT Host2Stats.statsid as statsDefId, Hosts.id as hostId "
		." FROM Hosts, Host2Stats "
		." WHERE   "
		." Host2Stats.hostid = Hosts.id "
		. ($hostId != null ? " AND Hosts.id = $hostId " : "")
		." AND Hosts.statsProfileId = $statsProfileId "
		." AND Not Exists "
		." ( SELECT StatsProfile2StatsDef.statsProfileId  "
		."   FROM StatsProfile2StatsDef  "
		."   WHERE StatsProfile2StatsDef.statsDefId = Host2Stats.statsid "
		."   AND StatsProfile2StatsDef.statsProfileId = $statsProfileId "
		." ) ";

		$conn = @getConnection();

		$result = mysql_query($query, $conn);

		if(!$result)
			error("Unable to apply stat profile to its hosts! ". mysql_error());
			
		$numrows = mysql_numrows($result);

		$i = 0;

		while($i < $numrows)
		{	
			$row = mysql_fetch_assoc($result);
			$statsDefId = (int)$row['statsDefId'];
			$hostId = (int)$row['hostId'];

			removeHost2StatsEntry($hostId, $statsDefId);
			$i++;
		}
	 
		/* Next lets do opposite.  If one exists in StatsProfile2StatsDef (and not 
		 * deleted), then create it in Host2Stats.
		 */

		$query =
			 " SELECT StatsProfile2StatsDef.statsDefId , Hosts.id as hostId"
		  . " FROM StatsProfile2StatsDef , Hosts "
		  . " WHERE StatsProfile2StatsDef.statsProfileId = Hosts.statsProfileId "
		  .  ($hostId != null ? " AND Hosts.id = $hostId " : "")
			." AND Hosts.statsProfileId = $statsProfileId "
		  . " AND NOT EXISTS  "
		  . " ( SELECT Host2Stats.hostId FROM Host2Stats  "
		  . "   WHERE Host2Stats.hostId = Hosts.id "
		  . "   AND Host2Stats.statsId = StatsProfile2StatsDef.statsDefId "
		  . "  AND StatsProfile2StatsDef.statsProfileId = $statsProfileId "
		  . " ) ";

		$result = mysql_query($query, $conn);

		if(!$result)
			error("Unable to apply stats profile to its hosts! ". mysql_error());
	
		$numrows = mysql_numrows($result);

		$i = 0;

		while($i < $numrows)
		{	
			$row = mysql_fetch_assoc($result);
			$statsDefId = (int)$row['statsDefId'];
			$hostId = (int)$row['hostId'];

			addHost2StatsEntry($hostId, $statsDefId);
			$i++;
		}

		return tag('result', 'success');

	}


	function removeHost2StatsEntry($hostId, $statsDefId)
	{
		$query =  " DELETE FROM Host2Stats WHERE hostId=$hostId "
				  . " AND statsId=$statsDefId";

		@sqlUpdate($query);
		$error = mysql_error();
		if($error != "") error("Unable to update stats profile!");

	}

	function addHost2StatsEntry($hostId, $statsDefId)
	{
		$query =  " INSERT INTO Host2Stats "
				  . " (statsid, hostId) "
				  . " VALUES "
	           . " ($statsDefId, $hostId) ";

		@sqlUpdate($query);
		$error = mysql_error();
		if($error != "") error("Unable to update stats profile!");

	}


	/****************************************************
	* Modify a Stats Profile
	*
	**/
	function modifyStatsProfile($id, $name, $newStatsDefsStr)
	{
		global $STATSPROFILES_LEN;

		$id 				= (int)$id;
		$name 			= cleanTrimParam($name,  $STATSPROFILES_LEN['name']);

		$query = "UPDATE StatsProfiles "
				. " SET name = '$name' "
				. " WHERE id = $id ";

		sqlUpdate($query);

		$error = mysql_error();
		if($error != "")
			error("Unable to update stats profile! " . $error);

		/* Load old and new stats def lists below */
		$newStatsDefs = array();
		$oldStatsDefs = array();

		$arr = explode(',', $newStatsDefsStr);

		foreach($arr as $statsDefId)
		{
			$statsDefId = (int) $statsDefId;

			if($statsDefId <=0)
					continue;

			$newStatsDefs[] = $statsDefId;
		}

		$query = " SELECT DISTINCT StatsDef.id "
				.  " FROM StatsDef, StatsProfile2StatsDef "
				.  " WHERE StatsDef.id = StatsProfile2StatsDef.statsDefId "
				.  " AND StatsProfile2StatsDef.statsProfileId = $id ";
		
		$conn = @getConnection();

		$result = mysql_query($query, $conn);

		if(!$result)
			error("Unable to retrieve a stat profile from the database! ". mysql_error());
			
		$numrows = mysql_numrows($result);

		$i = 0;

		while($i < $numrows)
		{	
			$row = mysql_fetch_assoc($result);
			$statsDefId = (int) $row['id'];

			$oldStatsDefs[] = $statsDefId;
			$i++;
		}

		
		/*
		*  For each stats def in the new list, we need to see if it's still in the
		* the original stat profile.
		*/

		foreach($newStatsDefs as $newStatsDefId)
		{
			$result =	isStatsDefInList($oldStatsDefs, $newStatsDefId);

			if(!$result)
			{
				 addStatsDefToProfile($id, $newStatsDefId);
			}
		}


		foreach($oldStatsDefs as $oldStatsDefId)
		{
			$result = isStatsDefInList($newStatsDefs, $oldStatsDefId);
			if(!$result)
			{
				// Then need to remove this stats def from the profile
				
				removeStatsDefFromProfile($id, $oldStatsDefId);

				
			}
		}

		applyStatsDefProfile($id);
		
		return tag('result', 'success');
	}


	function isStatsDefInList($searchList, $idToFind)
	{

		foreach($searchList as $statsDefId)
		{
			if($statsDefId == $idToFind)
				return TRUE;
		}

		return FALSE;
	}

	function removeStatsDefFromProfile($profileId, $statsDefId)
	{
			if($statsDefId <= 0) return;

			$query = "DELETE FROM StatsProfile2StatsDef "
				. " WHERE "
				. " statsDefId = $statsDefId "
				. " AND statsProfileId =  $profileId";

			@sqlUpdate($query);
			$error = mysql_error();
			if($error != "")
				error("Unable to alter stats def in stats profile! " . $error);


	}

	function removeStatsProfileFromHost($hostId)
	{
		$hostId = (int) $hostId;
		$query = "DELETE FROM Host2Stats WHERE hostid = $hostId";

		sqlCmd($query);


	}

	/****************************************************
	* Remove an Stats Profile
	*
	**/
	function deleteStatsProfile($statsProfileId)
	{
		$statsProfileId = (int)$statsProfileId;
		

		// 1. Update device types
		$query = "UPDATE DeviceTypes Set defaultStatsProfileId = NULL "
				. " WHERE defaultStatsProfileId = $statsProfileId ";

		@sqlUpdate($query);
		$error = mysql_error();

		if($error != "")
			error("Unable to remove stats profile! " . $error);

		
		// 3. Remove all entries in Host2Stats for hosts that are using
		//    this stats profile.
		$query =   " DELETE FROM Host2Stats "
					. " WHERE "
					. "    Exists(SELECT Hosts.id FROM Hosts "
					. "           WHERE Hosts.statsProfileId = $statsProfileId "
					. "           AND Host2Stats.hostId = Hosts.id) ";

		@sqlUpdate($query);
		$error = mysql_error();

		if($error != "")
			error("Unable to remove stats profile! " . $error);		
		


		// 2. Update hosts
		$query = "UPDATE Hosts Set statsProfileId = NULL "
				. " WHERE statsProfileId = $statsProfileId ";

		@sqlUpdate($query);
		$error = mysql_error();

		if($error != "")
			error("Unable to remove stats profile! " . $error);		
		

		// 4. Remove all entries in StatsProfile2StatsDef 
		//    for this stat profile.
		$query = "DELETE FROM StatsProfile2StatsDef " 
				. " WHERE statsProfileId = $statsProfileId ";

		@sqlUpdate($query);
		$error = mysql_error();

		if($error != "")
			error("Unable to remove stats profile! " . $error);		
		

		// 5. Update custom registration settings
		$query = "UPDATE CustomRegistrationRules set statsProfileId = NULL  "
				. " WHERE statsProfileId = $statsProfileId ";

		@sqlUpdate($query);
		$error = mysql_error();

		if($error != "")
			error("Unable to remove stats profile! " . $error);		
		

		// 6. Delete stats profile

		$query = "DELETE FROM StatsProfiles  "
				. " WHERE id = $statsProfileId ";

		@sqlUpdate($query);
		$error = mysql_error();

		if($error != "")
			error("Unable to remove stats profile! " . $error);		
		

	}
}
?>
