<?php

include('lib/sql.php');
include('lib/graph-collection.php');
include('lib/timezone.php');

if(!function_exists('stats_wrapper'))
{

	function stats_wrapper() { }

	
	function handleStatsAction($action)
	{
		if($action == null)
			error('Unauthorized');

		switch($action)
		{
			
			case 'get':
				
				echo getGraph(req('graphId'), req('type'));
			break;

			case 'get-device':
				echo getDeviceGraph(req('hostId'), req('statsDefId'), req('type'), req('hb'));
			break;

		}

	}

	/**********************************************************
	* Get all details for a graph for a device - display + stats
	*
	*/
	function getDeviceGraph($hostId, $statsDefId, $type, $hb)
	{
		$retVal = "";

		$hostId = (int) $hostId;
		$statsDefId = (int) $statsDefId;

		$statsDefName = sqlString("SELECT StatsDef.name, StatsDef.oid from StatsDef WHERE id = $statsDefId", "name");


		/* Get graph display information */
		$query = " SELECT GraphTemplate.*, StatsDef.oid  "
		. " FROM GraphTemplate, StatsDef "
		. " WHERE StatsDef.id = $statsDefId "
		. " AND StatsDef.defaultGraphTemplateId = GraphTemplate.id ";

		$result = sqlRow($query);
		
		if(!$result)  // use defaults
		{
			$display = "<display statsDefId='0' "
					. " showVerticalLabel='false' "
					. " upper='0' "
					. " lower='0' "
					. " verticalAxisType='linear' "
					. " autoScale='true' "
					. " useDelta='false' "
					. " multiplier='1' "
					. " >";

				$display .= tag('title', $statsDefName, true);
				$display .= tag('oid', "", true);
				$display .= tag('verticalLabel', "", true);

				$graphType = 'line';

				$useDelta = 0;
				$multiplier = 1;
				$color = 16737792 ;
		}
		else
		{
				$useDelta = (int) $result['useDelta'];
				$multiplier = (double) $result['multiplier'];
			
				if($multiplier == 0) $multiplier  = 1;

				$display = "<display statsDefId='0' "
					. " showVerticalLabel='" . ($result['showVerticalLabel'] == 1? 'true' : 'false') . "' "
					. " upper='" . $result['upper'] . "' "
					. " lower='" . $result['lower'] . "' "
					. " verticalAxisType='" . $result['verticalAxisType'] . "' "
					. " autoScale='" . ($result['autoScale'] == 1? 'true' : 'false') . "' "
					. " useDelta='" . ($result['useDelta'] == 1? 'true' : 'false') . "' "
					. " multiplier='$multiplier' "
					. " >";

				$title = $result['title'];
				if($title == '' || $title == null) $title = $statsDefName;

				$display .= tag('title', $title , true);
				$display .= tag('oid', $result['oid'], true);
				$display .= tag('verticalLabel', $result['verticalLabel'], true);

				$color = (int) $result['color']  ;
				$graphType = $result['graphType']  ;
		} 

		$hosts .= "<host id='$hostId' color='$color' graphType='$graphType' "
					. "enabled='true'>" . tag('name', $statsDefName, true)  . "</host>\n";
			
		$stats .= getStats($hostId, $type, $statsDefId,$useDelta,$multiplier, $hb );

		$hosts = tag('hosts', $hosts);
		$stats = tag('data', $stats);
		$display .= $hosts . "</display>";

		$retVal = tag('graph',
							$display .  $stats);

		return $retVal;
	}

	/**********************************************************
	* Get all details for a graph - display + stats
	*
	*/
	function getGraph($graphId, $type)
	{
		$retVal = "";

		$graphId = (int) $graphId;

		/* Get graph display information */
		$query = " SELECT UserGraphs.*, StatsDef.oid FROM UserGraphs, StatsDef "
				 . " WHERE UserGraphs.id = $graphId "		
				 . " AND UserGraphs.statsDefId = StatsDef.id ";
		
		$graph = sqlRow($query);
		$statsDefId = $graph['statsDefId'];

		$useDelta = (int) $graph['useDelta'];
		$multiplier = (double) $graph['multiplier'];

		if($multiplier == 0) $multiplier  = 1;

		$display = "<display statsDefId='" . $graph['statsDefId']. "' "
					. " showVerticalLabel='" . ($graph['showVerticalLabel'] == 1? 'true' : 'false') . "' "
					. " upper='" . $graph['upper'] . "' "
					. " lower='" . $graph['lower'] . "' "
					. " verticalAxisType='" . $graph['verticalAxisType'] . "' "
					. " autoScale='" . ($graph['autoScale'] == 1? 'true' : 'false') . "' "
					. " useDelta='" . ($graph['useDelta'] == 1? 'true' : 'false') . "' "
					. " multiplier='$multiplier' "
					. " >";

		$display .= tag('title', $graph['title'], true);
		$display .= tag('oid', $graph['oid'], true);
		$display .= tag('verticalLabel', $graph['verticalLabel'], true);


		/* Next get the hosts shown on this graph */
		$query =   " SELECT UserGraphSeries.*, "
					. " Hosts.name ,  INET_NTOA( Hosts.ipaddr)  as ip, "
					. " Hosts.hbinterval as hb "
					. " FROM UserGraphSeries, Hosts "
					. " WHERE UserGraphSeries.userGraphId = $graphId "
					. " AND Hosts.id = UserGraphSeries.hostId ";

		$conn = @getConnection();

		$result = mysql_query($query, $conn);

		if(!$result)  error("Unable to retrieve graph series! ". mysql_error());
			
		$numrows = mysql_numrows($result);

		$i = 0;
		$hosts = "";
		$stats = "";

		while($i < $numrows)
		{					
			$row = mysql_fetch_assoc($result);
			$hostId = $row['hostId'];
			$color  = $row['color'];
			$graphType = $row['graphType'];
			$enabled = ($row['enabled'] == 1 ? 'true' : 'false');
			$hostName = $row['name'];
			$ip = $row['ip'];
			$hb = (double)$row['hb'];

			if($ip != '')
				$hostName .= ", $ip";
			
			$hosts .= "<host id='$hostId' color='$color' graphType='$graphType' "
					. "enabled='$enabled'>" . tag('name', $hostName, true)  . "</host>\n";
			
			if($enabled == 'true')
				$stats .= getStats($hostId, $type, $statsDefId,$useDelta,$multiplier, $hb );

			$i++;
		}

		$hosts = tag('hosts', $hosts);
		$stats = tag('data', $stats);
		$display .= $hosts . "</display>";

		$retVal = tag('graph',
							$display .  $stats);


		return $retVal;
	}

	

	/**********************************************************
	*  Output stats xml for a single data series in a graph.
	*	type = 'day', 'hour', 'month', 'year', 'week'
	*
	*  If we're using deltas (like for throughput), AND type is day or hour, 
	*  check to make sure that the hb of the device isn't greater than the
	*  granularity we're using. 
	*/
   function getStats($hostId, $type, $statsDefId, $useDelta, $multiplier, $hb)
	{
		$hostId = (int) $hostId;
		$statsDefId = (int) $statsDefId;

		$date = date("Y-m-d H:i");

		$retVal = "<stats hostId='$hostId'>";

		$end = $date;


		switch($type)
		{	
			case 'hour':

			// if HB of host is greater than 1 min, then use hb as interval.

			$num = 60;
			$int = 60;

			if($hb > 60){
				$int = $hb;
				$num = (60 / ($hb/60));

			}

			$start = strtotime(date("Y-m-d H:i", strtotime($date)) . " -1 hour");
			
			$start = date("Y-m-d H:i", $start);

			// every 1 minutes, so interval is 60 seconds
			$retVal .= outputStats($hostId, $statsDefId, $start, $end, $num,  $useDelta, $int, $multiplier);
					

			break;

			case 'day':

			$start = strtotime(date("Y-m-d H:i", strtotime($date)) . " -1 day");
			$start = date("Y-m-d H:i", $start);
			
			// 96 times a day = 900 seconds
			$retVal .= outputStats($hostId, $statsDefId, $start, $end, 96, $useDelta, 900, $multiplier);
					
			break;

			case 'year':

			$start = strtotime(date("Y-m-d H:i", strtotime($date)) . " -366 days");
			$start = date("Y-m-d H:i", $start);
			
			
			// Now Stats_Year stores every 3 days i think
			$retVal .= outputStats($hostId, $statsDefId, $start, $end, 122,  $useDelta, 259200, $multiplier );
			
		
			break;
			
			case 'week':

			$start = strtotime(date("Y-m-d H:i", strtotime($date)) . " -7 days");
			$start = date("Y-m-d H:i", $start);
		
			// (7 days in a week * 86400 seconds in a day)/ 200 intervals
			// New Stats_Week table records stats 8 times a day
			$retVal .= outputStats($hostId, $statsDefId, $start, $end, 56, $useDelta, 10800, $multiplier);
			
			break;

			case 'month':
			

			$start = strtotime(date("Y-m-d H:i", strtotime($date)) . " -30 days");
			$start = date("Y-m-d H:i", $start);
		
			// about 30 days in a month * seconds per day/200 intervals
			// Montly stats stores twice a day
			$retVal .= outputStats($hostId, $statsDefId, $start, $end, 60, $useDelta, 43200, $multiplier);
			
			break;

			default:
			error('Please specify a stats time range!');
			break;
		}

		$retVal .= "</stats>";
		return $retVal;
	}


	function outputStats($hostId, $statsDefId, $start, $end, $num,  $useDelta, $intervalInSeconds, $multiplier)
	{
		// If we say to use delta, then for each set of points, we'll take delta and return that 
		// value instead of the absolute value


		$query = "CALL give_me_data( $hostId, $statsDefId, '$start', '$end' , $num)";
		
		$conn = @getConnection(false);
		
		$result = @mysql_query($query, $conn);

		if(!$result)
			error("Unable to retrieve stats! ". mysql_error());
	
		$numrows = mysql_numrows($result);

	
		$i = -1;
		$retVal = "";

		$prevValue = 0;
		$prevTime = 0;


		while($i < $numrows)
		{
			if($useDelta)
			{
				$i++;

				$row = mysql_fetch_assoc($result);
				$nextTime =  $row['time_avg'];
				$nextValue = $row['value'];

				if($i > 0)
				{
	
					$time = $prevTime + $intervalInSeconds/2;

					if( $nextValue < $prevValue|| $nextValue == -1 || $prevValue == -1 )
					{
						$value = '';
				     	

					} 
					
					else 
					{
					
						$diff = $nextValue - $prevValue ;
						$value =( $diff/$intervalInSeconds ) * $multiplier;

					}
					$retVal .= "<stat  v='$value' i='$i' t='$time'/>\n";
				}

				$prevValue = $nextValue;
				$prevTime = $nextTime;
			}		
			else
			{
				$i++;
				
				$row = mysql_fetch_assoc($result);
				$time =  $row['time_avg'];
				$value = $row['value'];

				if($value == -1)
					$value = "";
			
				else $value *= $multiplier;

				if($time == 0)
					continue;


				$retVal .= "<stat  v='$value' i='$i' t='$time'/>\n";
			}
			
		}  // while
		mysql_close($conn);
		return $retVal;
			
	}

	/******************************************************************
	*  This gets all stat info for the user id for the dashboard.	
   	*  (This is currently not used...)	
	*/
	function getDashboardStatsData($userId)
	{
		/* Let's get the user's report id.  If it's null or 0, return nothing */

		$retVal = "<dashboardReports>";
			
		$row = @sqlRow("SELECT * FROM UserGraphGroup " 
			. " WHERE showOnDashboard  = 1 AND userid = $userId ");

		sqlError("Unable to get dashboard reports! ");
	
		if($row)
		{
			$groupId = (int) $row['id'];

			/* Let's get first 3 graphs and include the data here... */

			$retVal .= "<graphGroup id='$groupId'> ";

			$retVal .= tag('name', $row['name'], true);
			$retVal .= tag('id', $groupId);

			$retVal .= getGraphsInGroup($groupId);

			$retVal .= "</graphGroup>";	
		}

		$retVal .= "</dashboardReports>";

		return $retVal;

	}



}

?>
