<?php

include('lib/settings.php');
include('lib/permissions.php');
include('lib/user.php');
include('lib/system-time.php');

if(!function_exists('system_settings_wrapper'))
{
	function system_settings_wrapper() {}

	/* The length of fields in the DB for the System Settings table */
	$SYSSETTINGS_LEN = array(
				'value' 			=> 100);


	function handleSystemSettingsAction($action)
	{
		if($action == null)
			error('Unauthorized');

		switch($action)
		{
			case 'get':

				global $currentUserId;

				echo getSystemSettings($currentUserId);

			break;

			case 'updateGeneral':
				echo updateGeneralSettings(
					req('lostHbThreshold'), 
					req('googleKeys'), 
					req('name'), 
					req('org'), 
					req('serverAddress'));

			break;

			case 'updateEmailSettings':
				echo updateEmailSettings(req('fromEmail'), 
					req('smtpServer'),
					req('smtpUser'),  
					req('smtpPassword'), 
					req('useTLS'),
					req('smtpPort'));
				return tag("result", "success");

			break;

			case 'updateDatabaseSettings':

				global $currentUserId;

				if(!isUserAdminUser($currentUserId))
					error("Unauthorized attempt to write database settings!");
				else
	 				writeDBSettings(req('host'), req('user'),	req('pass'), req('dbname'));
				return tag("result", "success");

			break;

			case 'google':
				updateGoogleMapsKeys(req('apiKeys'));
			break;

			case 'get':
				;
			break;

		}

	}

	/***************************************************
	* Return the list of system settings.
	* NOTE: Confirm that user is an admin to get
   * database and email settings
	*/
   function getSystemSettings($userId)
	{
		$isAdmin = isUserAdminUser($userId);

		// Manually setting to true - let everyone get these settings
		$isAdmin = 1;

		// Make sure some sort of value exists
		setSystemSettingDefaults();

		$query =  " SELECT SystemSettings.key, SystemSettings.value "
				  . " FROM SystemSettings "
				  . " WHERE 0 "
				  .  ($isAdmin ? " OR SystemSettings.key = 'LostHeartbeatThreshold' " : "")
				  .  ($isAdmin ? " OR SystemSettings.key = 'FromEmail' " : "")
				  .  ($isAdmin ? " OR SystemSettings.key = 'SmtpServer' " : "")
				  .  ($isAdmin ? " OR SystemSettings.key = 'SmtpServerPort' " : "")
				  .  ($isAdmin ? " OR SystemSettings.key = 'AuthUser' " : "")
				  .  ($isAdmin ? " OR SystemSettings.key = 'AuthPassword' " : "")
				  .  ($isAdmin ? " OR SystemSettings.key = 'Name' " : "")
				  .  ($isAdmin ? " OR SystemSettings.key = 'Organization' " : "")
				  .  ($isAdmin ? " OR SystemSettings.key = 'UseTls' " : "")
				  .  ($isAdmin ? " OR SystemSettings.key = 'ServerAddress' " : "") ;

		$conn = @getConnection();

		$result = mysql_query($query, $conn);

		if(!$result)
		{
			error("Unable to retrieve WNMS System settings! ". mysql_error());
			return;
		}
		$numrows = mysql_numrows($result);

		$retVal = "";

		$i = 0;

		$retVal = "<systemSettings>";

		while($i < $numrows)
		{
			$pair = mysql_fetch_assoc($result);

			$retVal .= "<setting ";

			$key = $pair['key'];
			$value = $pair['value'];

			$settingsTag = " key='$key' ";

			$retVal .= $settingsTag . ">";
			$retVal .= tag('value', $value, true);

			$retVal .= "</setting>";
			$i++;
		}

		$retVal .= getDBSettings();

		$retVal .= getGoogleMapKeys();
		
		$retVal .= getLanguages();

		$retVal .= "</systemSettings>\n";

		return $retVal;

	}
	
	function getLanguages()
	{
    $retVal = "<languages>\n";
    
    $result = mysql_query("SELECT Languages.id, Languages.name, IF(SystemSettings.value IS NULL, 0, 1) AS isCurrent FROM Languages LEFT JOIN SystemSettings ON `key` = 'SystemLanguageId' AND value = Languages.id WHERE Languages.enabled = 1 ORDER BY Languages.name");
    
    while ($row = mysql_fetch_row($result)) {
      $retVal .= "  <language id=\"${row[0]}\"";
      if ($row[2] == '1') {
        $retVal .= " current=\"true\"";
      }
      $retVal .= ">" . htmlspecialchars($row[1], ENT_COMPAT, "UTF-8") . "</language>\n";
    }
    
    mysql_free_result($result);
    
    $retVal .= "</languages>\n";
    
    return $retVal;
	}

	function getDBSettings()
	{

		global $sql_host;
		global $sql_username;
		global $sql_password;
		global $sql_dbname;

		$retVal = "<dbSettings>";

		$retVal .= "<dbSetting key='sqlUsername'>"
		 		   . tag('value', $sql_username, true)
					. "</dbSetting>";

		$retVal .= "<dbSetting key='sqlHost'>"
		 		   . tag('value', $sql_host, true)
					. "</dbSetting>";

		$retVal .= "<dbSetting key='sqlPassword'>"
		 		   . tag('value', $sql_password, true)
					. "</dbSetting>";

		$retVal .= "<dbSetting key='sqlDbname'>"
		 		   . tag('value', $sql_dbname, true)
					. "</dbSetting>";

		$retVal .= "</dbSettings>";

		return $retVal;
	}

	/***************************************************
	* Get google maps keys
	*/
	function getGoogleMapKeys()
	{
		$query = " SELECT id, domain, apiKey FROM GoogleMapKeys ";

		$conn = @getConnection();

		$result = mysql_query($query, $conn);

		$numrows = mysql_numrows($result);

		$i = 0;

		$retVal = "";

		while($i < $numrows)
		{
			$row = mysql_fetch_assoc($result);

			$value =  tag("domain", $row["domain"], true);
			$value .= tag("apiKey", $row["apiKey"], true);

			$retVal .= tag("googleKey", $value, false, " id='" . $row['id'] . "' ");

         $i++;
		}

		return tag("googleMapKeys", $retVal);
	}

	/***************************************************
	* Update the google maps key
	*/
	function updateGoogleMapsKeys($apiKeys)
	{

		$apiKeys = base64_decode($apiKeys);

		$apiKeys = "<?xml version=\"1.0\" encoding=\"utf-8\"?> " .$apiKeys;

		$doc = new DOMDocument();
		$doc->loadXML($apiKeys);

		// Delete all keys

		@sqlUpdate("DELETE FROM GoogleMapKeys ");

		$list =$doc->getElementsByTagName('googleKey');

		foreach($list as $item)
		{

			$apiKey =$item->getElementsByTagName('apiKey')->item(0)->nodeValue;
			$domain =$item->getElementsByTagName('domain')->item(0)->nodeValue;

			// strip out http
			$domain = str_replace('https://', '', $domain);
			$domain = str_replace('http://', '', $domain);

			$query =   " INSERT INTO GoogleMapKeys "
					. " (domain, apiKey) "
					. " VALUES "
				   . " ('" . cleanParam($domain) . "', '" . cleanParam($apiKey) ."') ";

			sqlUpdate($query);
		}
	   return tag('result','success');

	}


	/***************************************************
	* Update general system settings (time, lost heartbeat threshold)
	*/
	function updateGeneralSettings($hbThresh, $googleKeys, $name, $org, $serverAddress)
	{

		global $currentUserId;

		if(!isUserAdminUser($currentUserId))
			error("Unauthorized attempt to write general system settings!");

		setSystemSettingDefaults();

		if(!is_numeric($hbThresh))
			error("Invalid lost heartbeat threshold value.");

		$settings = array(
				"Name" => $name,
				"Organization" => $org,
				"LostHeartbeatThreshold" => $hbThresh,
				"ServerAddress" => $serverAddress);


		foreach($settings as $key=>$value)
		{

			$query =
					  " UPDATE SystemSettings "
					. " SET   SystemSettings.value = '"
					. cleanParam($value) . "' "
					. " WHERE SystemSettings.key = '$key'  ";

			sqlUpdate($query);

		}

		updateGoogleMapsKeys($googleKeys);
		
		return tag('result','success');

	}


	/***************************************************
	* Update email settings (located in the database)
	*/
   function updateEmailSettings($fromEmail, $smtpServer, $smtpUser,
										  $smtpPassword, $useTLS, // $useSSL,
										  $smtpPort)
	{

		global $currentUserId;

		if(!isUserAdminUser($currentUserId))
			error("Unauthorized attempt to write email settings!");


		global $SYSSETTINGS_LEN;


		// first make sure system settings have not been deleted.
		setSystemSettingDefaults();

		if($smtpPort <=0) $smtpPort = "";


		$updateFields = array("FromEmail" => $fromEmail,
					"SmtpServer" => $smtpServer,
					"AuthUser" => $smtpUser,
					"AuthPassword" => $smtpPassword,
					"SmtpServerPort"=> $smtpPort,
					"UseTls" => $useTLS
					);

		foreach($updateFields as $key=>$value)
		{
			$query =   " UPDATE SystemSettings "
					. " SET   SystemSettings.value = '"
					. cleanTrimParam($value, $SYSSETTINGS_LEN['value']) . "' "
					. " WHERE SystemSettings.key = '$key'  ";


			sqlUpdate($query);
		}

		return tag('result','success');

	}

	/***********************************************************
	* Confirm that all required system setting exist in the DB.
	*/
	function setSystemSettingDefaults()
	{
		$settings = array( "FromEmail"  => "none@none.com",
				"SmtpServer" => "",
				"SmtpServerPort" => "",
				"AuthUser" => "",
				"AuthPassword" => "",
				"UseTls" => "1",
				"Name" => "WNMS",
				"Organization" => "",
				"LostHeartbeatThreshold" => 3);

		foreach($settings as $key=>$value)
		{
			$query = " SELECT SystemSettings.key FROM SystemSettings "
				. " WHERE SystemSettings.key like '$key' ";


			$currentKey = sqlString( $query, "key");


			if($currentKey == "" || $currentKey == null)
			{

			   $query = "INSERT INTO SystemSettings "
				. " (SystemSettings.key, SystemSettings.value) "
				. " VALUES "
				. " ('$key', '" . cleanParam($value) . "') ";

				// then create the setting
				sqlInsert($query);

			}

		}

	}

}
?>
