<?php

include('lib/sql.php');
include('lib/user.php');
include('lib/permissions.php');

if(!function_exists('system_time_wrapper'))
{

	function system_time_wrapper() { }



	/**************************************************************
	* Output sql server time
	*
	*/
	function getSqlTime()
	{

		return	sqlString("SELECT NOW() as time", "time");

	}

	/**************************************************************
	* Output sql server time offset
	*
	*/
	function getSqlOffset()
	{

		$diff =	sqlString("SELECT TimeDiff(now(), utc_timestamp()) as time", "time");

		$offsets = explode(':', $diff);
		$hr = $offsets[0];
		$min = $offsets[1];

		$sign = 1;

		if($hr < 0) $sign = -1;

		$min *= $sign;
		$offset = $hr + ($min/60);


		return $offset;

	}

	/**************************************************************
	* Get timezone offset in hours.
	*
	*/
	function getLinuxOffset()
	{

		$offset = shell_exec('date +%::z');

		// make offset a number in hours
		$offsets = explode(':', $offset);
		$hr = $offsets[0];
		$min = $offsets[1];

		$sign = 1;

		if($hr < 0) $sign = -1;

		$min *= $sign;
		$offset = $hr + ($min/60);


		return $offset;

	}


	/**************************************************************
	* Output system time
	*
	*/
	function getSystemTime()
	{

		if(isWindows())
		{
			$retVal = "<result>";

			$stime = getSqlTime();
			// 2010-09-14 18:27:41
			$pieces = explode(' ', $stime);

			$dates = explode('-', $pieces[0]);

			$retVal .= tag("year", $dates[0]);
			$retVal .= tag("month", $dates[1]);
			$retVal .= tag("day", $dates[2]);

			$times = explode(':', $pieces[1]);

			$retVal .= tag("hour", $times[0]);
			$retVal .= tag("minute", $times[1]);

			$retVal .= tag("offset",  getSqlOffset());

			$retVal .= "</result>";

			return $retVal;

		}
		else
		{
			$line = shell_exec('date +%Y-%m-%d\ %H:%M');

			$array = explode(' ' , $line);
			$dateArray = $array[0];
			$timeArray = $array[1];

			$dates = explode( "-", $dateArray);
			$times = explode(":", $timeArray);

			$retVal = "<result>";

			$retVal .= tag("year", $dates[0]);
			$retVal .= tag("month", $dates[1]);
			$retVal .= tag("day", $dates[2]);

			$retVal .= tag("hour", $times[0]);
			$retVal .= tag("minute", $times[1]);


			$retVal .= tag("offset",  getLinuxOffset());

			$retVal .= "</result>";

			return $retVal;
		}

	}


	/******************************************************************8
	* Set the system time and date on the server.
	*/
	function setSystemTime()
	{
		global $currentUserId;

		if(!isUserAdminUser($currentUserId))
			error("Unauthorized access.");

		$hour =  (int) req('hour');
		$minute = (int) req('minute');
		$year = (int) req('year');
		$day = (int) req('day');

		$month = req('month');

		if(strlen($month) > 15)
			error("Invalid month provided.");

		// using explicit month string so dont get confused about month vs day
		$format =  "$month-$day-$year "
					. "$hour:$minute" ;

		$command = "sudo date -s '$format'";
		$line = shell_exec($command);
		if($line == '')
			error('Permission denied to change date! ');

		$line = 'stuff' . $line;

		// if it contains date: then we got some kind of bad message from date change.
		if(strrpos($line, 'date:'))
			error('Error setting date');

		tag('result','success');

	}
}

?>
