<?php
  /*
   * PHP for Windows is sometimes unable to make a reasonable "guess" of
   * the timezone name based on system timezone settings, and reverts to
   * using UTC instead.
   *
   * The fix is to get the actual timezone offset from the MySQL server
   * and set the PHP timezone name to a generic "Etc/GMT+<offset>".
   *
   * This file is meant to be included in all code that deals with local
   * dates/times, e.g. lib/stats.php that passes 'start' and 'end' local
   * dates/times to the give_me_data() MySQL stored procedure.
   */
  if (PHP_OS === 'WINNT' && ini_get('date.timezone') == '') {
    include_once('lib/system-time.php');
    $offset = getSqlOffset();
    $timeZone = sprintf('Etc/GMT%+d', -$offset);
    date_default_timezone_set($timeZone);
  }
?>
