<?php

include('lib/sql.php');
include('lib/maps.php');

if(!function_exists('topology_wrapper'))
{

	function topology_wrapper() {}

	
	function handleTopologyAction($action)
	{
		if($action == null)
			error('Unauthorized');

		switch($action)
		{
			case 'sync':
			echo syncChanges(req('changes'));
			break;

			case 'add-hosts':
			echo addHostsToTopo(req('hosts'));
			break;

			case 'remove-hosts':
			echo removeHostsFromTopo(req('hosts'));
			break;

			case 'get':
			echo getTopoLinks(req('networks'));

			break;
		}

	}

	/********************************************************
	*  Remove hosts from the logical topology map
	*/
	function removeHostsFromTopo($hostString)
	{
		$hosts = explode(',', $hostString);

		if(!is_array($hosts))
			return tag('result', 'success');

		foreach($hosts as $hostId)
		{
			$hostId = (int) $hostId;

			// Remove all links to this host
			$query = "DELETE FROM Links WHERE fromHostId = $hostId "
					. " OR toHostId = $hostId ";

			@sqlUpdate($query);

			// Now remove from topology map 
			$query = "UPDATE Hosts set topology = 0 " 
				. " WHERE id = $hostId ";

			@sqlUpdate($query);

			$error = mysql_error();

			if($error != "")
				error("Unable to remove host from toplogy map! $error");
		}

		return tag('result', 'success');
	}

	/********************************************************
	*  Add hosts to the logical topology map
	*/
	function addHostsToTopo($hostString)
	{

		$hosts = explode(',', $hostString);

		if(!is_array($hosts))
			return tag('result', 'success');

		foreach($hosts as $hostId)
		{
			$hostId = (int) $hostId;

			$query = "UPDATE Hosts set topology = 1 " 
				. " WHERE id = $hostId ";

			@sqlUpdate($query);

			$error = mysql_error();

			if($error != "")
				error("Unable to add hosts to toplogy map! $error");
		}
		return tag('result', 'success');

	}


	/********************************************************
	*  Get all links for all devices in the given networks
	*  $networkIds = "id,id,id," etc...
	*/
	function getTopoLinks($networkIdStr)
	{

		global $currentUserId;

		// Only include networks that this user is allowed to access		
		$isNetworkUser = isUserNetworkUser($currentUserId);

		$networkIds = explode(',', $networkIdStr );
	
		$networkQuery = "";

		if ($isNetworkUser)
		{
			$allowedNetworks = getAllowableNetworkIds($currentUserId);

			/* If we've not specified any network ids (meaning search them all,
			* then make sure we only search the ones that belong to the given user
			*/

			if ($networkIdStr == "" || !is_array($networkIds) || count($networkIds) ==0) 
			{
				$networkIds = $allowedNetworks;
			}

		}

		$networkQuery = " AND (  ";

		$networkSubQuery = " 0 ";
		foreach($networkIds as $networkId)
		{				
			$networkId = (int)$networkId;

			if($networkId == 0)
			{
			
				$networkSubQuery .= " OR Hosts1.networkId = $networkId "
										. " OR Hosts1.networkId is null ";

				continue;
			}
			$networkSubQuery .= " OR Hosts1.networkId = $networkId ";
		}		

		$networkQuery .= $networkSubQuery . ")";

		// How add stuff from hosts2 table 
		/*$networkQuery .= " AND ( Hosts2.networkId is null OR ";
		$networkSubQuery = "";
		foreach($networkIds as $networkId)
		{				
			$networkId = (int)$networkId;

			if($networkSubQuery != "")
				$networkSubQuery .= " OR ";

			$networkSubQuery .= " Hosts2.networkId = $networkId ";

		}

		$networkQuery .= $networkSubQuery . ")";
*/

		$query = "SELECT Hosts1.name as fromName, "
				. " Hosts1.id as fromId, "
				. " Hosts2.name as toName, "
				. " Hosts2.id as toId, "
				. " Hosts1.isdown, "
				. " Links.fromHostId, Links.toHostId, "
				. " Links.fromHostRSSI, Links.toHostRSSI, "
				. " CASE WHEN " 
				. str_replace('Hosts1', 'Hosts2', $networkSubQuery)
				. " THEN 1 "
				. " WHEN Hosts2.id is NULL Then 1 "
				. " ELSE 2 END as allowedStatus "
				. " FROM  Hosts as Hosts1 "
				. " Left Join Links "
				. " on Links.fromHostId = Hosts1.id "
				. " Left Join Hosts as Hosts2 "
				. " ON Hosts2.id = Links.toHostId  "
				. " WHERE Hosts1.topology = 1 "
				. " AND (Hosts2.topology is null OR Hosts2.topology = 1) ";



		if($networkQuery != "")
		{
			$query .= $networkQuery;
		}

		/* Query up until now won't get devices that are ONLY connected to unallowed networks */
		/* For now just going to show these nodes that are in the next network */

	
		$conn = @getConnection();

		$result = mysql_query($query, $conn);

		if(!$result)
		{
			error("Unable to retrieve topo map links! ". mysql_error());
			return;
		}

		//error($query);

		$numrows = mysql_numrows($result);

		$retVal = "";

		$i = 0;
 
		$retVal = "<nodes>";

		while($i < $numrows)
		{	
			// Ugh, visualizer flex library doesn't work when we include these 
			// fields as elements instead of attributes.

			$row = mysql_fetch_assoc($result);
			
			$allowedStatus = (int) $row['allowedStatus']; // 2 = not allowed, 0 or 1 = allowed
			$allowed = $allowedStatus != 2; 	// This means the end point shouldn't be included, but the originating point should.

			// DO NOT CHANGE THIS FORMAT UNLESS YOU CHANGE ON FLEX SIDE too!!!

			$fromName = $row['fromName'] . ' ('. $row['fromId'] . ')';
			$fromName =  str_replace("'", '',  $fromName);

			if ($allowed)
			{
				$toName = $row['toName'] . ' (' . $row['toId'] .')';
				$toName =  str_replace("'", '',  $toName);
			}
			else $toName = '';

			$status = $row['isdown'];

			$retVal .= "<node nid='" . $row['fromId'] . "' id='$fromName' isdown='$status' ";
			
			$connectedTo = "";

			if ($allowed && $row['toId'] != "")
			{
				$connectedTo  = " connectedTo='$toName' " ;
			}
			
			$retVal .= $connectedTo;
			
			if ($row['fromHostRSSI'] != "")
			{
				$retVal .= " rssiFrom='{$row['fromHostRSSI']}'";
			}
			
			if ($row['toHostRSSI'] != "")
			{
				$retVal .= " rssiTo='{$row['toHostRSSI']}'";
			}
				
			$retVal .= "/>";


			$i++;
		}

		$retVal .= "</nodes>";
		
		return $retVal;
	}
}
?>
