<?php

include('lib/sql.php');

if(!function_exists('trouble_wrapper'))
{

	function trouble_wrapper() {}

	
	function handleTroubleAction($action)
	{
		switch($action)
		{
			case "view":
				echo viewTroubleContents(req('id'));
			break;

			case "download":
				echo getTroubleFile(req('id'));
			break;


			case 'search':
					echo tag('result', searchTroubleFiles(req('hostId'), req('dateStart'), req('dateEnd'),
							req('pageSize'), req('pageNumber'), req('sortField'), req('sortDirection')));

			break;

			case 'delete-all':
				echo tag('result', deleteAll(req('hostId')));
	
			break;


			case 'delete':
				echo tag('result', deleteTroubleFile(req('id')));
	
			break;

		}
	}


	/*************************************************************
	* Remove the given trouble file
	*
	*/
	function deleteTroubleFile($id)
	{
		$id = (int) $id;
		$query = "DELETE FROM TroubleshootFile WHERE id = $id";
		sqlCmd($query);

		sqlError();

		return "success";


	}

	/*************************************************************
	* REmove all trouble files for a device
	*
	*/
	function deleteAll($hostId)
	{
		$hostId = (int) $hostId;
		$query = "DELETE FROM TroubleshootFile WHERE hostid = $hostId";
		sqlCmd($query);

		sqlError();

		return "success";


	}

	/*************************************************************
	* Dump the contents from a trouble shooting file for download
	*
	*/
	function getTroubleFile($id)
	{
		$id = (int) $id;
		$query = "SELECT data FROM TroubleshootFile "
				. " WHERE id = $id ";

		$content = @sqlString($query, 'data');

		
		echo $content;
	}

	/*************************************************************
	* View the contents from a trouble shooting file
	*
	*/
	function viewTroubleContents($id)	
	{
		$id  = (int) $id;

		$query = "SELECT TroubleshootFile.data, TroubleshootFile.date "
				. " FROM TroubleshootFile  "
				. " WHERE id = $id ";


		$result = @sqlRow($query);

		sqlError("Unable to retrieve file! ");

		$retVal .= tag('id', $id);
		$retVal .= tag('date', $result['date'], TRUE);
		$retVal .= tag('contents', $result['file'], TRUE);

		return tag('file', $retVal, FALSE, " id= '$id' ");	

	}

	function searchTroubleFiles($hostId, $dateStart, $dateEnd,$pageSize, $pageNumber,
										$sortField, $sortDirection)
	{
		
		$dateStart 	= cleanParam($dateStart);
		$dateEnd 	= cleanParam($dateEnd);

		$hostId = (int) $hostId;
		$pageSize = (int) $pageSize;
		$pageNumber = (int) $pageNumber;
	
		$page = ($pageNumber - 1) * $pageSize;

		$query = "SELECT TroubleshootFile.*, IFNull(Task.name, 'N/A') as task  ";
		$recordCountQuery = " SELECT Count(TroubleshootFile.id) as Total ";

		$mainQuery = " FROM TroubleshootFile  "
					. " LEFT JOIN Task "
					. " ON Task.id = TroubleshootFile.taskid "
					. " WHERE TroubleshootFile.hostId = $hostId "
					. ($dateEnd != ""?  " AND TroubleshootFile.date <= '$dateEnd' " : "");

	
		if($sortField != '')
		{
			$sortField = getSortByField_troubleHistory($sortField);
		
		}
		else
		 {
			$sortField = "TroubleshootFile.date";
			$sortDirection = "DESC";
		}


		$mainQuery .= "Order By $sortField $sortDirection LIMIT $page, $pageSize ";

		$query .= $mainQuery;
		$recordCountQuery .= $mainQuery;

		$conn = getConnection();
		$result = @mysql_query($query, $conn);


		if(!$result)
			error("Unable to retrieve file list! " . mysql_error());

		$numrows = mysql_numrows($result);

		$retVal = "<files>";

		$i = 0;

		while($i < $numrows)
		{	
			$config = mysql_fetch_assoc($result);
 			
			$retVal .= "<file>\n";

			foreach($config as $key=>$value)
			{		
				if($key == 'data')
					continue;

				$tag = tag($key, $value, true);

				$retVal .= $tag;
			}

			$retVal .= "</file>";
			$i++;
		}
	
		$retVal .= "</files>";

		$totalRecords = @sqlNumber($recordCountQuery, "Total");

		$retVal .= tag('totalCount', $totalRecords); 
		return $retVal;	
		


	}


	/**************************************************************
	* Translate the client's sort by field to actual DB values
	*
	**************************************************************/	
	function getSortByField_troubleHistory($name)
	{

		$name = strtolower($name);

		switch($name)
		{
			case "date" : return "TroubleshootFile.date"; 
			case "task" : return "Task.name"; 
		}

		return "";
			
	}

}
?>
