<?php

include('lib/sql.php');
include('lib/settings.php');
include('lib/user.php');

if (!function_exists('user_settings_wrapper'))
{
	function user_settings_wrapper()
	{
	}

	/* The length of fields in the DB for the System Settings table */
	$USERSETTINGS_LEN = array(
		'value' => 100);


	function handleUserSettingsAction($action)
	{
		if ($action == null)
			error('Unauthorized');

		switch ($action)
		{
			case 'get':

				global $currentUserId;

				echo getUserSettings($currentUserId);

				break;

			case 'update':
				echo updateUserSettings();

				break;

		}

	}

	/***************************************************
	 * Return the list of user settings for the given user
	 */
	function getUserSettings($userId)
	{

		// Make sure some sort of value exists
		setUserSettingDefaults($userId);

		$query = " SELECT UserSettings.key, UserSettings.value "
				. " FROM UserSettings "
				. " WHERE "
				. " userid = $userId ";


		$conn = @getConnection();

		$result = mysql_query($query, $conn);

		if (!$result)
		{
			error("Unable to retrieve WNMS User settings! " . mysql_error());
			return;
		}
		$numrows = mysql_numrows($result);

		$retVal = "";

		$i = 0;

		$retVal = "<userSettings>";

		while ($i < $numrows)
		{
			$pair = mysql_fetch_assoc($result);

			$retVal .= "<setting ";

			$key = $pair['key'];
			$value = $pair['value'];

			$settingsTag = " key='$key' ";

			$retVal .= $settingsTag . ">";
			$retVal .= tag('value', $value, true);

			$retVal .= "</setting>";
			$i++;
		}

		$reportId = sqlNumber("SELECT id FROM UserGraphGroup  "
						      . " WHERE showOnDashboard  = 1 AND userid = $userId LIMIT 1 ", "id");


		$retVal .= "<setting key='DashboardStatsReportId'>" . tag('value', $reportId) . "</setting>";

		$retVal .= "</userSettings>\n";

		return $retVal;

	}

	/***************************************************
	 * Update user settings
	 */
	function updateUserSettings()
	{

		global $currentUserId;

		setUserSettingDefaults($currentUserId);

		$dateFormat = req('dateFormat');

		$refreshInterval = (int) req('refreshInterval'); // in minutes

		if ($refreshInterval <= 0) $refreshInterval = 5;


		$alarmRefreshInterval = (int) req('alarmRefreshInterval'); // in minutes

		if ($alarmRefreshInterval <= 0) $alarmRefreshInterval = 5;

		$dashboardAlertCount = (int) req('dashboardAlertCount');
		$dashboardShowCritical = (int) req('dashboardShowCritical');
		$dashboardShowWarning = (int) req('dashboardShowWarning');

		$dashboardShowClosed = (int) req('dashboardShowClosed');
		$dashboardShowNotify = (int) req('dashboardShowNotify');

		$dashboardShowInfo = (int) req('dashboardShowInfo');
		$reportId = (int) req('graphReportId');

		if ($dateFormat == "")
			$dateFormat = "us";

		$autoRefreshInterval = (int) req('autoRefreshInterval'); // in seconds
		if ($autoRefreshInterval < 10) {
			$autoRefreshInterval = 10;
		} else if ($autoRefreshInterval > 300) {
			$autoRefreshInterval = 300;
		}

		$settings = array("RefreshInterval" => $refreshInterval,
			"AlarmRefreshInterval" => $alarmRefreshInterval,
			"DashboardAlertCount" => $dashboardAlertCount,
			"DashboardShowInfoAlerts" => $dashboardShowInfo,
			"DashboardShowWarningAlerts" => $dashboardShowWarning,
			"DashboardShowCriticalAlerts" => $dashboardShowCritical,
			"DashboardShowClosed" => $dashboardShowClosed,
			"DashboardShowNotify" => $dashboardShowNotify,
			"DateFormat" => cleanParam($dateFormat),
			"AutoRefreshInterval" => $autoRefreshInterval
		);

		foreach ($settings as $key => $value)
		{
			$query = " UPDATE UserSettings "
					. " SET UserSettings.value = '$value' "
					. " WHERE UserSettings.key like '$key'"
					. " AND userid = $currentUserId ";

			@sqlUpdate($query);

			$error = mysql_error();
			if ($error != "")
				error($error);
		}


		/* This is to set the report who's graphs we want to show on the dashboard */
		$query = "UPDATE UserGraphGroup SET showOnDashboard = 0  "
				. " WHERE userid = $currentUserId ";

		@sqlUpdate($query);

		$query = "UPDATE UserGraphGroup SET showOnDashboard = 1  "
				. " WHERE userid = $currentUserId "
				. " AND id = $reportId ";

		@sqlUpdate($query);
		sqlError("Unable to update preferences! ");

		return tag('result', 'success');

	}


	/***********************************************************
	 * Confirm that all required user settings exist in the DB.
	 */
	function setUserSettingDefaults($currentUserId)
	{

		$settings = array("RefreshInterval" => "3", // Refresh interval is 3 mins by default
			"DashboardAlertCount" => "20", // Show max of 20 alerts on dashboard
			"DashboardShowInfoAlerts" => "0", // Show info alerts on dashboard
			"DashboardShowWarningAlerts" => "1", // Show warning alerts on dashboard
			"DashboardShowCriticalAlerts" => "1", // Show critical alerts on dashboard
			"DashboardShowNotify" => "1", // Show "notify only" alerts on Dashboard
			"DashboardShowClosed" => "1", // Show "closed" alerts as well as active ones
			"AlarmRefreshInterval" => "5", // Refresh alarms every 5 mins (on Alarms tab)
			"DateFormat" => "us", // US format for dates - mua ha ha);
			"AutoRefreshInterval" => "20" // Refresh each 20 seconds
		);

		foreach ($settings as $key => $value)
		{
			$query = " SELECT UserSettings.key FROM UserSettings "
					. " WHERE UserSettings.key like '$key'AND userid = $currentUserId ";

			$currentKey = sqlString($query, "key");

			if ($currentKey == "" || $currentKey == null)
			{
				$query = "INSERT INTO UserSettings "
						. " (UserSettings.key, UserSettings.value, UserSettings.userid) "
						. " VALUES "
						. " ('$key', '" . cleanParam($value) . "', $currentUserId) ";

				// then create the setting
				@sqlInsert($query);
				$error = mysql_error();
				if ($error != "")
					error("Unable to create default settings . $error");

			}

		}

	}

}
?>
