<?php

include('permissions.php');

if(!function_exists('user_wrapper'))
{

	function user_wrapper() { }

	function handleUserAction($action)
	{
		if($action == null)
			error('Unauthorized');

		switch($action)
		{
			case 'create':
				createUser(req('username'), req('firstname'),  req('lastname'),
							  req('email'), req('password'), req('usergroup'), 
							  req('networks'),req('permissions'));
			break;
				
			case 'delete':
			  deleteUser(req('userid'));
			
			break;

			case 'changepass':				
				changePass(req('userid'), req('password'));
			break;
			case 'modify':
				modifyUser(req('userid'), req('username'), req('firstname'), req('lastname'),
						  	  req('email'), req('usergroup'), req('networks'), req('permissions'));
			break;
			case 'modifybasic':
				modifyUserBasic(req('userid'), req('username'), req('firstname'), req('lastname'),
						  	  req('email'));
			break;
			
			case 'get':
				getAllUsers();
			break;

		}

	}

	/********************************************************
	* doesUerNameExist: you can prolly guess what this checks
	* 		
	********************************************************/
	function doesUsernameExist($username)
	{
		$query = " SELECT id FROM Users "
					. " WHERE deleted = 0 "
					. " AND username like '" 
					. cleanParam($username) ."'";

		$result  = sqlNumber($query, 'id');

		return ($result > 0);
	}

	/********************************************************
	* isUserLastAdmin: determine if it's the last admin in the system.
	*********************************************************/
	function isUserLastAdmin($userid)
	{
		$query = " SELECT COUNT(*) as Total "
					. " FROM Users "
					. " WHERE userGroupId = "
					. getGroupIdFromKey('ADMIN') ." "
					. " AND deleted = 0 "
					. " AND id != $userid ";
					
		$result = sqlNumber($query, "Total");

		return $result < 1;
	}

	/********************************************************
	* deleteUser: remove a user and all their settings
	* 		
	********************************************************/
	function deleteUser($userid)
	{
		global $currentUserId;

		$userid=(int) $userid;

		if ($userid == 0) 
        	error('Error: Invalid user id.');	

		$currentUserId=(int) $currentUserId;

		if ($currentUserId == 0) 
        	error('Error: Invalid current user id.');	

		if(!isUserAdminUser($currentUserId))
			error('You are not authorized to delete users.');
        
		if (isUserLastAdmin($userid))
        	error('You can\'t remove the last admin user.');
      
		if ($userid == $currentUserId) 
        	error('You can\'t remove the logged in user');	
        	
		$query = " UPDATE Users "
			. " SET  deleted = '1' " 
			. " WHERE id = $userid ";

		@sqlUpdate($query);
		$error = mysql_error();
		if($error != "")
        	error('Error\: can\'t remove user from database' . $error);
        	
		$query = "DELETE FROM UserSettings WHERE userId = $userid";
		@sqlCmd($query);
		$error = mysql_error();
		if($error != "")
			error('Error\: can\'t remove user settings' . $error);

		$query = "DELETE FROM User2Network WHERE userId= $userid";
		@sqlCmd($query);
		$error = mysql_error();
		if($error != "")
			error('Error\: can\'t remove user settings' . $error);
	
		$query = "DELETE FROM TabPermissions WHERE userId = $userid";
		@sqlCmd($query);
		$error = mysql_error();
		if($error != "")
			error('Error\: can\'t remove user settings' . $error);

	

		echo tag('result', 'success');
	}

	/********************************************************
	* createUser: insert a new user into the DB.
	* 
	*********************************************************/
	function createUser($username, $firstname, $lastname, $email, $password, 
							  $usergroup, $networks, $permissions)
	{	
		global $salt;
		global $currentUserId;
	
		if(!isUserAdminUser($currentUserId))
			error('You are not authorized to create new users.');

		if(empty($username) || empty($usergroup) || empty($password))
			error('Invalid parameters.');

		if(doesUsernameExist($username))
			error('Username is already in use.');
			
		$usergroupid = getGroupIdFromKey($usergroup);

		$hash = md5($password . $salt);

		$guid = uniqid(rand(), true);

		$query = 	
				  "INSERT INTO Users "
				. " (username, firstname, lastname, email, password, usergroupid, guid) "
				. " VALUES "
				. " ('". cleanParam($username). "', '" . cleanParam($firstname) 
				. "', '" .  cleanParam($lastname) . "', '" . cleanParam($email) 
				. "', '$hash', " . 	" $usergroupid, '" . cleanParam($guid) . "') ";

		$result = sqlInsert($query);

		if($result == null || $result['rows'] <=0 || $result['id'] <=0)
			error('Unable to create user! Unknown system problem.');
		
		$userid = $result['id'];

		setNetworks($userid, $networks);

		setPermissions($userid, $permissions);

		/* Return this new user's user id. */
		echo tag('result', tag('userid', $userid));
				
	}

	
	/********************************************************
	* changePass: change users password. 
	*
	*********************************************************/
	function changePass($userid, $password)
	{

		global $salt;
		global $currentUserId;

		if(empty($userid) || empty($password))
			error('Invalid parameters.');

		$userid = (int) $userid;

		if($userid != $currentUserId && !isUserAdminUser($currentUserId))
			error('Unauthorized');

			
		if(strlen($password) < 3)
			error('Invalid password.');
		
		$hash = md5($password . $salt);

		$query = 	" UPDATE Users "
				. " SET  password ='$hash' " 
				. " WHERE id = $userid ";

		$result = sqlUpdate($query);

		//if($result <=0)
		//	error('Unable to update user! Unknown system problem.');
		

		echo tag('result','success');
	}

	/********************************************************
	* modifyUser: change a user. 
	*
	*********************************************************/
	function modifyUserBasic($userid, $username, $firstname, $lastname, $email)
	{			
		global $currentUserId;

		$userid = (int) $userid;


		if($userid <=0)
			error('Invalid user id.');

		if($userid != $currentUserId && !isUserAdminUser($currentUserId))
			error('Unauthorized');

		$oldusername = sqlString("SELECT username From Users where id = $userid", "username");
		
		if($oldusername == "")
			error('User not found.');

		if($oldusername != $username && doesUsernameExist($username))
			error('Username is already in use.');

		$query = " UPDATE Users "
					. " SET username ='". cleanParam($username). "', firstname = '" . cleanParam($firstname). "', " 
					. " lastname ='"    . cleanParam($lastname) . "', email = '". cleanParam($email) . "' "
					. " WHERE id = $userid ";

		$result = sqlUpdate($query);

		if($result <=0)
			error('Unable to update user! Unknown system problem.');
		
		
		echo tag('result','success');
	}

	
	/********************************************************
	* Get the user group id from the key (like 'ADMIN')
	*
	*********************************************************/
	function getGroupIdFromKey($usergroup)
	{
		return sqlNumber(" SELECT id "
				.  " FROM UserGroups "
				.  " WHERE UserGroups.key like '" . cleanParam($usergroup) ."'", 
				 "id");

	}

	/********************************************************
	* modifyUser: change a user. 
	*
	*********************************************************/
	function modifyUser($userid, $username, $firstname, $lastname, $email, 
							  $usergroup, $networks, $permissions)
	{	
		
		global $currentUserId;

		$userid = (int) $userid;

		if($userid <=0)
			error('Invalid user id.');

		if($userid != $currentUserId && !isUserAdminUser($currentUserId))
			error('Unauthorized');

		$usergroupid = getGroupIdFromKey($usergroup);

		$oldusername = sqlString("SELECT username From Users where id = $userid", "username");
		
		if($oldusername == "")
			error('User not found.');

		if($oldusername != $username && doesUsernameExist($username))
			error('Username is already in use.');

		$query = 	" UPDATE Users "
					. 	" SET username ='". cleanParam($username). "', firstname = '" . cleanParam($firstname). "', " 
					.  " lastname ='"    . cleanParam($lastname) . "', email = '". cleanParam($email) . "', "
					.  " usergroupid = $usergroupid "  
					.  " WHERE id = $userid ";


		$result = sqlUpdate($query);

		//if($result <= 0)
		//	error('Unable to update user! Unknown system problem.');
		
		removeAllUserNetworks($userid);

		setNetworks($userid, $networks);
		

		setPermissions($userid, $permissions);

		echo tag('result','success');
				
	}

	/***************************************************
	*  Set allowed networks for a user.
	*
	*  $networks: empty or 'networkid|networkid|etc...'
	**************************************************/
	function setNetworks($userid, $networks)
	{
		/* Update user's allowed networks if they're specified here. */
		if(isUserNetworkUser($userid))
		{
			if(!empty($networks))
 			{
				$pieces = explode("|", $networks);

				if(is_array($pieces) && count($pieces) > 0)
				{
					foreach($pieces as $networkid)
					{
						if(!is_numeric($networkid))
							continue;
						else 
						{
							$query =   " INSERT INTO User2Network "
										. " (userid, networkid) "
										. " VALUES "
										. " ($userid, $networkid) ";
 
							$numrows = sqlUpdate($query);

							if(!$numrows)
								error("A critical error has occured.  Unable to set networks for this user!");

						}
					} // end foreach networkid

				}// end if is valid array

			}
			
		}
	}


	/********************************************************
	* changePermissions: change tab and network permissions 
	* for the given user.  
	* 		$permissions: 'tabid=value|tabid=value', etc...
	*********************************************************/
	function setPermissions($userid, $permissions)
	{
		
		global $currentUserId;

		$userid = (int) $userid;

		if(!$userid)
			error('Invalid user id.');

		if($userid != $currentUserId && !isUserAdminUser($currentUserId))
			error('Unauthorized');

		$pieces = explode("|", $permissions);

		if(!(is_array($pieces)) || count($pieces) <=0)
			error("Invalid parameters. ");

		$permissions = array();
		$i = 0;

		/* First validate */
		foreach($pieces as $chunk)
		{
			$tabs = explode("=", $chunk);

			if(!is_array($tabs) || count($tabs) != 2)	
			{		
				continue;
			}

			$tabid = $tabs[0];
			$tabvalue = $tabs[1];


			if(!is_numeric($tabvalue) || !is_numeric($tabid))
				error("Invalid parameterss.");
			
			$permissions[$tabid] = $tabvalue;
			$i++;

		}

		/* Remove current permissions */
		removeAllPermissions($userid);
		
		/* Now add back. */
		foreach($permissions as $key => $val)
		{
			$query =   " INSERT INTO TabPermissions "
						. " (userid, permissionlevel, tabid) "
						. " VALUES "
						. " ($userid, $val, $key) ";
 
			$numrows = sqlUpdate($query);

			if(!$numrows)
				error("A critical error has occured.  Unable to set rights for this user!");
				
		}

	}

	/****************************************************
	*	Remove all network rights for the user
	*
	*****************************************************/
	function removeAllUserNetworks($userid)
	{
		sqlCmd("DELETE FROM User2Network WHERE userid = $userid");

	}



	/****************************************************
	* Return user's group name (like ADMIN, NETWORK, SYSTEM, etc...) 
	*
	****************************************************/
	function getUsersGroup($userid)
	{
		return sqlString(		
							  " SELECT UserGroups.key FROM Users, UserGroups "
							. " WHERE Users.id = $userid AND UserGroups.id = Users.UserGroupId ", "key");

	}

	/****************************************************
	* Return user's info in XML 
	*
	****************************************************/
	function getUserInfoXML($userId)
	{
		$conn = getConnection();

		$query = "Select Users.id as userid, Users.username, "
					. " Users.firstname, Users.lastname, Users.email, "
					. " UserGroups.key as groupKey, UserGroups.name AS groupName  "
					. " FROM Users, UserGroups "
					. " WHERE Users.Id = " . $userId . " AND UserGroups.Id = Users.UserGroupId "
					. " Order BY createdOn ASC ";

		$result = mysql_query($query, $conn);
		
		
		if(!$result || mysql_numrows($result) == 0)
			error("Error! User Not Found" . mysql_error());

		
		$userid 		= mysql_result($result, 0, 'userid');
		$username	= mysql_result($result, 0, 'username');
		$firstname	= mysql_result($result, 0, 'firstname');
		$lastname	= mysql_result($result, 0, 'lastname');
		$email 		= mysql_result($result, 0, 'email');
		$groupname	= mysql_result($result, 0, 'groupName');
		$groupkey	= mysql_result($result, 0, 'groupKey');
		
		return  tag( 'userid', $userid) . tag('username', $username)
				. tag( 'firstname', $firstname, TRUE) . tag('lastname', $lastname, TRUE)
				. tag( 'email', $email, TRUE). tag('groupname', $groupname)
				. tag('groupkey', $groupkey);

	}

	/****************************************************
	* Return all current users in XML
	*
	****************************************************/
	function getAllUsers()
	{

		global $currentUserId;

		if(!isUserAdminUser($currentUserId))
			error("Unauthorized.");

		$conn = getConnection();

		$query = "Select Users.id as userid, Users.username, "
					. " Users.firstname, Users.createdon, Users.lastname, Users.email, "
					. " UserGroups.name AS groupname, UserGroups.key as groupkey  "
					. " FROM Users, UserGroups "
					. " WHERE UserGroups.Id = Users.UserGroupId "
					. " AND Users.deleted = 0 " 
					. " Order by Users.createdon ASC ";

		$result = mysql_query($query, $conn);
		
		$numrows = mysql_numrows($result);

		if(!$result ||$numrows == 0)
			return tag('users', "");


		$retVal = "<users>";
		$i = 0;

		while($i < $numrows)
		{
			$retVal .= "<user>";
				
			$userid 		= mysql_result($result, $i, 'userid');
			$username	= mysql_result($result, $i, 'username');
			$firstname	= mysql_result($result, $i, 'firstname');
			$lastname	= mysql_result($result, $i, 'lastname');
			$email 		= mysql_result($result, $i, 'email');
			$groupname	= mysql_result($result, $i, 'groupname');
			$groupkey	= mysql_result($result, $i, 'groupkey');
			$createdon	= mysql_result($result, $i, 'createdon');

			$retVal .=  
				  tag('userid', $userid) 
				. tag('username', $username)
				. tag('firstname',  $firstname, TRUE) 
				. tag('lastname', $lastname, TRUE)
				. tag('email', $email, TRUE)
				. tag('groupname',$groupname)
				. tag('groupkey',$groupkey)
				. tag('createdon', $createdon);

			$retVal .= tag('networks', getSelectableNetworksXML($userid));
			$retVal .= tag('permissions', getTabPermissionsXML($userid));

			$retVal .= "</user>";
			$i++;
		}
		$retVal .= "</users>";

		echo $retVal;	
	}



}

?>
